/*  Wiiengine 
    Copyright (C) 2008 Francisco Muoz "Hermes" 

    GP2Xengine (original project)
    Copyright (C) 2006  Hermes/PS2Reality  * Made in Vallecas - Madrid (Spain)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/




// wii
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include <ogcsys.h>
#include <gccore.h>
#include "ogc/lwp_threads.h"
#include <wiiuse/wpad.h>
#include "utils/usb2storage.h"
#include "utils/mload.h"

#include <fat.h>
#include <fcntl.h>
#include "sys/dir.h"
#include <sys/statvfs.h>
#include "unistd.h"
//
//#include "snd.h"
#include "pce.h"
#include <asndlib.h>
#include "sound.h"

// MOD Player
#include "gcmodplay.h"
#include "mod.h"


#include "wav.h"

int sprite_ticks=0;
#define TIME_SPRITES 15*55


MODPlay mod_track; 

void mixaudiofun();

char path_rom[257]="/roms/pcengine/";



/*unsigned trap=0;
unsigned trap2=0;
unsigned trap3=0;*/

static int auto_fire=0;

int key_alarm=0; // alarma que habilita el pad en caso de cuelgue  en el emulador

//extern int  wave_sound_thread_exit;
//extern int wave_sound_run;
extern void SaveWRAM();

void memsetw(void *p, unsigned color, int words)
{
u32 *p1=(u32 *) p;
int n;

	for(n=0;n<words;n++) *p1++=color;
}

unsigned new_key=0,old_key=0;

int file_modified=0;

static GXRModeObj	*screenMode;

void copy_buffers(u32 count);

static void *frameBuffer[2] = {NULL,NULL};
int frame=0;

char tempfilename[257];

#define	FIFO_SIZE (256*1024)

int exit_by_reset=0;

int return_reset=2;

void reset_call() {exit_by_reset=return_reset;}
void power_call() {exit_by_reset=3;}

GXTexObj scr_tex,scr_tex2;
/* formats for tiling4x4  */

#define TILE_LITTLE_ENDIAN 128 // change the byte order in the color
#define TILE_CI4       0 // for CI4  (color index of 4 bits)
#define TILE_CI8       1 // for CI8  (color index of 8 bits)
#define TILE_RGB5A3    2 // for RGB5A3 
#define TILE_RGB5A1    2 // pseudo RGB5A1
#define TILE_RGB565    3 // for RGB565 
#define TILE_SRGB565   4 // for RGB565 with R and B swapped
#define TILE_SRGB5A1   5 // for RGB5A1 with R and B swapped
#define TILE_RGBA8     6 // for RGBA8
#define TILE_SRGBA8    7 // for RGBA8 with R and B swapped

void tiling4x4(void *mem, int format, int tx, int ty); // function for texture conversion

/* formats for ctlut: */

#define TLUT_LITTLE_ENDIAN 128 // change the byte order in the color
#define TLUT_RGB5A3    2 // for RGB5A3 
#define TLUT_RGB5A1    2 // pseudo RGB5A1
#define TLUT_RGB565    3 // for RGB565 
#define TLUT_SRGB565   4 // for RGB565 with R and B swapped
#define TLUT_SRGB5A1   5 // for RGB5A1 with R and B swapped


void ctlut(void *mem,int format,int entries); // function for palette conversion

// u32 color Big to Little Endian
#define Get_LE(x) (((x>>24) & 0xff) | ((x>>8) & 0xff00) | ((x<<8) & 0xff0000) | ((x<<24) & 0xff000000))

void Init_Sprites();
void main_sprites();

#define WII_A 16
#define WII_B 32

#define WII_MINUS 64
#define WII_PLUS 128

#define WII_HOME 256
#define WII_START 512

#define WII_VOL_UP 1024
#define WII_VOL_DOWN 2048


#define WII_RIGHT 2
#define WII_LEFT  1
#define WII_UP    4
#define WII_DOWN  8

static unsigned wii_palette[256];

unsigned char  wii_screen8[512*512] __attribute__((aligned(32)));

int out_w=384,out_h=256;

unsigned out_texture[512*512]  __attribute__((aligned(32)));

int input_mode=1;
int swap_runselect=0;

unsigned gamecubepad=0;

#define QTDEN(a,b)  ((a & (b))==(b))


static s32 prio_joystick[8]={-1,-1,-1,-1,-1,-1,-1,-1};





unsigned wii_joystick_read(int sel)
{
u32 type[4]={0,0,0,0};
u32 butt=0;
s32 retj[4]={-1,-1,-1,-1};
//static s32 prio_joystick[8]={-1,-1,-1,-1,-1,-1,-1,-1};
int n;

unsigned ret=0;
static expansion_t w_exp;



debug_str="wii_joystick_read()";

	if(sel==0 || (sel & 128)!=0)
		{
		
		debug_str="WPAD_ScanPads()";
		WPAD_ScanPads();
        debug_str="PAD_ScanPads()";
		//PAD_Sync();
		gamecubepad=PAD_ScanPads();
		debug_str="wii_joystick_read()";
		}
	
	sel&=127;

	if(exit_by_reset) 
		{
		
		SaveWRAM();
		exit(0);
		}


// lee los 4 wiimotes
for(n=0;n<4;n++)
	retj[n]=WPAD_Probe(n, &type[n]);

	/*if((ret0<0 || ret1<0) && sel==2 && input_mode==1) return 0;

	if((ret0<0 || ret1<0) && (sel==1 || sel==2)) sel=666;*/

	if(sel==0) // mapea inteligentemente el numero de pads conectados, estando en los menus
		{
	    n=0;
		if(gamecubepad & 1) {prio_joystick[n]=17;n++;}
		if(gamecubepad & 2) {prio_joystick[n]=18;n++;}
		if(gamecubepad & 4) {prio_joystick[n]=19;n++;}
		if(gamecubepad & 8) {prio_joystick[n]=20;n++;}

		if(retj[0]>=0) {prio_joystick[n]=1;n++;}
		if(retj[1]>=0) {prio_joystick[n]=2;n++;}
		if(retj[2]>=0) {prio_joystick[n]=3;n++;}
		if(retj[3]>=0) {prio_joystick[n]=4;n++;}

		for(;n<8;n++) prio_joystick[n]=-1;
		}
		

    if(input_mode==1 && sel!=0)
		{
		n=sel-1;
		sel=prio_joystick[n];

		if(sel<=0) 
			{
		    int m;
			for(m=0;m<4;m++)
				{

				//if(prio_joystick[m]<=0 ) continue;
				if(prio_joystick[m]>16 && ((1<<(prio_joystick[m]-17)) & gamecubepad)!=0) continue;
				
				if((gamecubepad>>m) & 1) // permite volver al menu, si se  ha conectado recientemente, para poder reasignar
					{
					butt=PAD_ButtonsHeld(m);
					if(QTDEN(butt ,(PAD_TRIGGER_L | PAD_TRIGGER_R | PAD_BUTTON_START))) ret|=WII_HOME;	
				    debug_str="Undef";
			        return ret; // joystick desconectado
					}
				if(prio_joystick[m]>0 && prio_joystick[m]<16 && (prio_joystick[n]-1)==m) continue; 

				if(retj[m]>=0) // permite volver al menu, si se  ha conectado recientemente, para poder reasignar
					{
					butt=WPAD_ButtonsHeld(m);
					if(butt & (WPAD_BUTTON_HOME | WPAD_CLASSIC_BUTTON_HOME)) ret|=WII_HOME;
					debug_str="Undef";
					return ret; // joystick desconectado
					}

				}
			 debug_str="Undef";
			 return 0; // joystick desconectado
			}
		
		}
	
	for(n=0;n<4;n++)
	{
	if((gamecubepad>>n) & 1)
	 {
     butt=PAD_ButtonsHeld(n);
	 

	 if(sel==0)
			{
		    if(QTDEN(butt,(PAD_BUTTON_START))) ret|=WII_HOME;
			if(PAD_StickY(n)<(-48)) ret|=WII_DOWN;
			if(PAD_StickY(n)>(+48)) ret|=WII_UP;
		
			if(butt & PAD_BUTTON_A) ret|=WII_A;
			if(butt & PAD_BUTTON_B) ret|=WII_B;


			if(butt & (PAD_BUTTON_UP | PAD_BUTTON_RIGHT)) ret|=WII_UP;
			if(butt & (PAD_BUTTON_DOWN | PAD_BUTTON_LEFT)) ret|=WII_DOWN;
			
		
			//if(butt & WPAD_BUTTON_HOME) ret|=WII_HOME;

			if(butt & PAD_BUTTON_Y) ret|=WII_MINUS;
			if(butt & PAD_BUTTON_X) ret|=WII_PLUS;
			}
		/////////
		else
		if(sel==(16*(input_mode==1)+(n+1)) || sel==666)
			{
            if(QTDEN(butt,(PAD_TRIGGER_L | PAD_TRIGGER_R | PAD_BUTTON_START))) ret|=WII_HOME;
			if(QTDEN(butt, (PAD_TRIGGER_L | PAD_TRIGGER_R | PAD_BUTTON_A))) ret|=WII_MINUS | WII_B; // para foto

			if(butt & PAD_BUTTON_A) ret|=WII_A;
			if(butt & PAD_BUTTON_B) ret|=WII_B;

			if(auto_fire & 4)
				{
				if(butt & PAD_BUTTON_X) ret|=WII_A;
				if(butt & PAD_BUTTON_Y) ret|=WII_B;
				}

				if(!swap_runselect)
					{if(butt & PAD_BUTTON_START) ret|=WII_START;}
				else
					{if(butt & PAD_BUTTON_START) ret|=WII_PLUS;}
				
			{
			int x,y;
			x=PAD_StickX(n);
			y=PAD_StickY(n);
            if(y<(-48)) ret|=WII_DOWN;
			if(y>(+48)) ret|=WII_UP;
			if(x<(-48)) ret|=WII_LEFT;
			if(x>(+48)) ret|=WII_RIGHT;
			}
			if(butt & PAD_BUTTON_UP) ret|=WII_UP;
			if(butt & PAD_BUTTON_DOWN) ret|=WII_DOWN;
			if(butt & PAD_BUTTON_LEFT) ret|=WII_LEFT;
			if(butt & PAD_BUTTON_RIGHT) ret|=WII_RIGHT;

			
			//if(butt & WPAD_BUTTON_HOME) ret|=WII_HOME;

			if(QTDEN(butt, (PAD_TRIGGER_L | PAD_TRIGGER_R)))
				{	
				if(butt & PAD_BUTTON_Y) ret|=WII_VOL_DOWN;
				if(butt & PAD_BUTTON_X) ret|=WII_VOL_UP;
				}
			else
				{
				if(!swap_runselect)
					{
					if(butt & PAD_TRIGGER_Z) ret|=WII_PLUS;
					}
				else
					{
					if(butt & PAD_TRIGGER_Z) ret|=WII_START;
					}
				}
			}
		////////////

	 }
	if(retj[n]>=0)
		{
		butt=WPAD_ButtonsHeld(n);

		if(butt & (WPAD_BUTTON_HOME | WPAD_CLASSIC_BUTTON_HOME)) ret|=WII_HOME;

		if(sel==0)
			{
			if(type[n]==WPAD_EXP_NUNCHUK)
				{
				WPAD_Expansion(n,&w_exp);
				if(w_exp.nunchuk.js.pos.y<(128-48)) ret|=WII_DOWN;
				if(w_exp.nunchuk.js.pos.y>(128+48)) ret|=WII_UP;
				}
			if(butt & (WPAD_BUTTON_A | WPAD_BUTTON_1 | WPAD_CLASSIC_BUTTON_A)) ret|=WII_A;
			if(butt & (WPAD_BUTTON_B | WPAD_BUTTON_2 | WPAD_CLASSIC_BUTTON_B)) ret|=WII_B;

			if(butt & (WPAD_BUTTON_UP | WPAD_BUTTON_RIGHT | WPAD_CLASSIC_BUTTON_UP | WPAD_CLASSIC_BUTTON_LEFT)) ret|=WII_UP;
			if(butt & (WPAD_BUTTON_DOWN | WPAD_BUTTON_LEFT | WPAD_CLASSIC_BUTTON_DOWN | WPAD_CLASSIC_BUTTON_RIGHT)) ret|=WII_DOWN;
			
		
			//if(butt & WPAD_BUTTON_HOME) ret|=WII_HOME;

			if(butt & (WPAD_BUTTON_MINUS | WPAD_CLASSIC_BUTTON_MINUS)) ret|=WII_MINUS;
			if(butt & (WPAD_BUTTON_PLUS | WPAD_CLASSIC_BUTTON_PLUS)) ret|=WII_PLUS;
			}
		else
		if(sel==(n+1) || sel==666)
			{

			if(type[n]==WPAD_EXP_NUNCHUK)
				{
				WPAD_Expansion(n,&w_exp);
				if(w_exp.nunchuk.js.pos.x<(128-48)) ret|=WII_LEFT;
				if(w_exp.nunchuk.js.pos.x>(128+48)) ret|=WII_RIGHT;
				if(w_exp.nunchuk.js.pos.y<(128-48)) ret|=WII_DOWN;
				if(w_exp.nunchuk.js.pos.y>(128+48)) ret|=WII_UP;
				if(butt & WPAD_BUTTON_A) ret|=WII_A;
			    if(butt & WPAD_BUTTON_B) ret|=WII_B;

				if(!swap_runselect)
					{if(butt & WPAD_BUTTON_1) ret|=WII_START;}
				else
					{if(butt & WPAD_BUTTON_1) ret|=WII_PLUS;}

			    
				if((butt & WPAD_BUTTON_MINUS) && (butt & WPAD_BUTTON_2)) ret|=WII_MINUS | WII_B; // para foto
				//else if(butt & WPAD_BUTTON_2) ret|=WII_PLUS;
				}
			else
				{
				if(butt & WPAD_BUTTON_1) ret|=WII_A;
				if(butt & WPAD_BUTTON_2) ret|=WII_B;
				//benoa
				if(butt & WPAD_CLASSIC_BUTTON_A) ret|=WII_A;
				if(butt & WPAD_CLASSIC_BUTTON_B) ret|=WII_B;
				//
				if(!swap_runselect)
					{if(butt & (WPAD_BUTTON_A | WPAD_CLASSIC_BUTTON_X | WPAD_CLASSIC_BUTTON_Y | WPAD_CLASSIC_BUTTON_FULL_L | WPAD_CLASSIC_BUTTON_FULL_R)) ret|=WII_START;}					
				else
					{if(butt & (WPAD_BUTTON_A | WPAD_CLASSIC_BUTTON_X | WPAD_CLASSIC_BUTTON_Y | WPAD_CLASSIC_BUTTON_FULL_L | WPAD_CLASSIC_BUTTON_FULL_R)) ret|=WII_PLUS;}
				}

			if(butt & WPAD_BUTTON_RIGHT) ret|=WII_UP;
			if(butt & WPAD_BUTTON_LEFT) ret|=WII_DOWN;
			if(butt & WPAD_BUTTON_UP) ret|=WII_LEFT;
			if(butt & WPAD_BUTTON_DOWN) ret|=WII_RIGHT;
			//benoa
			if(butt & WPAD_CLASSIC_BUTTON_RIGHT) ret|=WII_RIGHT;
			if(butt & WPAD_CLASSIC_BUTTON_LEFT) ret|=WII_LEFT;
			if(butt & WPAD_CLASSIC_BUTTON_UP) ret|=WII_UP;
			if(butt & WPAD_CLASSIC_BUTTON_DOWN) ret|=WII_DOWN;
			
			//if(butt & WPAD_BUTTON_HOME) ret|=WII_HOME;

			if(butt & WPAD_BUTTON_B)
				{	
				if(butt & WPAD_BUTTON_MINUS) ret|=WII_VOL_DOWN;
				if(butt & WPAD_BUTTON_PLUS) ret|=WII_VOL_UP;
				}
			else
				{
				if(!swap_runselect)
					{
					if(butt & WPAD_BUTTON_MINUS) ret|=WII_MINUS;
					if(butt & WPAD_BUTTON_PLUS) ret|=WII_PLUS;
					//benoa
					if(butt & WPAD_CLASSIC_BUTTON_MINUS) ret|=WII_MINUS;
					if(butt & WPAD_CLASSIC_BUTTON_PLUS) ret|=WII_PLUS;
					//
					}
				else
					{
					if(butt & WPAD_BUTTON_MINUS) ret|=WII_START;
					if(butt & WPAD_BUTTON_PLUS) ret|=WII_START;
					//benoa
					if(butt & WPAD_CLASSIC_BUTTON_MINUS) ret|=WII_START;
					if(butt & WPAD_CLASSIC_BUTTON_PLUS) ret|=WII_START;
					//
					}
				}
			}

		}
	}
	
debug_str="Undef";
return ret;
}

void wii_video_RGB_color8(u8 r, u8 g, u8 b, u8 index) // set palete color
{
	wii_palette[index & 255]=0xff000000 | (r<<16) | (g<<8) | b;
}

	
static int reset_gfx=0;

void wii_video_RGB_flip(int param)
{
unsigned color=0xffffffff;

int n,m,t;

debug_str="wii_video_RGB_flip()";

	if(reset_gfx)
		{
		reset_gfx=0;
		GX_SetZMode(GX_TRUE, GX_LEQUAL,	GX_TRUE);
		GX_SetColorUpdate(GX_TRUE);
		GX_CopyDisp(frameBuffer[frame],GX_TRUE);
	//	frame^=1;
		GX_Flush();
		VIDEO_SetNextFramebuffer(frameBuffer[frame]);
		VIDEO_Flush();
		GX_InvVtxCache();
		GX_InvalidateTexAll();
		}


	t=0;
	for(n=0;n<256;n++)
		{
		for(m=0;m<384;m++)
			{
			out_texture[t]=wii_palette[wii_screen8[t] & 255];t++;
			}
		}

	//DCFlushRange(out_texture,384*256*4);


	tiling4x4((void *) out_texture, TILE_RGBA8, 384,256);



	GX_InitTexObj(&scr_tex, // objeto textura a inicializar
					  (void *) out_texture, // direccion de memoria de la textura
					  384, // ancho
					  256, // alto
					  GX_TF_RGBA8, // formato de color
					  GX_CLAMP, // Wrap Mode para S
					  GX_CLAMP, // Wrap Mode para T
					  GX_FALSE // No MipMap
					  );
		// ajusta los filtros segn el LOD
		GX_InitTexObjLOD(&scr_tex, // objeto de textura
						 GX_LINEAR, // filtro Linear para cerca
						 GX_LINEAR, // filtro Linear para lejos
						 0, 0, 0, 0, 0, GX_ANISO_1);
	GX_LoadTexObj(&scr_tex, GX_TEXMAP0);

	GX_SetNumTevStages(1);
	GX_SetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0);
	GX_SetTevOp(GX_TEVSTAGE0, GX_MODULATE);

// ajusta a una textura
	GX_SetNumTexGens(1);

    // aqui se describe los vertices y su formato (el orden sera, pos, norm, color, textura)

	GX_ClearVtxDesc();                    // borra los descriptores
	GX_SetVtxDesc(GX_VA_POS, GX_DIRECT);  // selecciona Posicion como directo
	GX_SetVtxDesc(GX_VA_CLR0, GX_DIRECT); // selecciona Color como directo  
	GX_SetVtxDesc(GX_VA_TEX0, GX_DIRECT); // selecciona Textura como directa

	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,	 GX_POS_XYZ,GX_S16,	0);      // formato de posicion S16 para X, Y ,Z
	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8,	0);  // color RGBA8 para color0
	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_S16, 10);  /* coordenadas de textura como S16 para S y T y desplazamiento 10
	                                                                  las coords de texturas estn en el rango de 0.0f a 1.0f por lo que al meter
																	  un desplazamiento de 10, 1024==1.0f dado que 2 elevado a 10 es 1024
																	  */
  
	// dibujando el QUAD de pantalla

	GX_Begin(GX_QUADS, GX_VTXFMT0, 4); 
		 
		 GX_Position3s16(0,0, 0); 
         GX_Color1u32(color);
		 GX_TexCoord2s16(0,0); 
		 GX_Position3s16(screenMode->fbWidth,0, 0); 
		 GX_Color1u32(color);
		 GX_TexCoord2s16(1023,0); 
		 GX_Position3s16(screenMode->fbWidth, screenMode->efbHeight, 0); 
		 GX_Color1u32(color);
		 GX_TexCoord2s16(1023,1023); 
		 GX_Position3s16(0,screenMode->efbHeight, 0);
		 GX_Color1u32(color);
		 GX_TexCoord2s16(0,1023); 

	GX_End();

	main_sprites();

	GX_DrawDone();

reset_gfx=1;

debug_str="Undef";
}

void wii_video_RGB_flip2(int param)
{
int xx1,xx2,yy1,yy2;
debug_str="wii_video_RGB_flip2()";
	if(reset_gfx)
		{
		reset_gfx=0;
		GX_SetZMode(GX_TRUE, GX_LEQUAL,	GX_TRUE);
		GX_SetColorUpdate(GX_TRUE);
		GX_CopyDisp(frameBuffer[frame],GX_TRUE);
		
		GX_Flush();
		VIDEO_SetNextFramebuffer(frameBuffer[frame]);
		VIDEO_Flush();
		GX_InvVtxCache();
		GX_InvalidateTexAll();
		}

	GX_InitTexObj(&scr_tex, // objeto textura a inicializar
					  (void *) out_texture, // direccion de memoria de la textura
					  out_w, // ancho
					  out_h, // alto
					  GX_TF_RGBA8, // formato de color
					  GX_CLAMP, // Wrap Mode para S
					  GX_CLAMP, // Wrap Mode para T
					  GX_FALSE // No MipMap
					  );
		// ajusta los filtros segn el LOD
		GX_InitTexObjLOD(&scr_tex, // objeto de textura
						 GX_LINEAR, // filtro Linear para cerca
						 GX_LINEAR, // filtro Linear para lejos
						 0, 0, 0, 0, 0, GX_ANISO_1);

	tiling4x4((void *) out_texture, TILE_RGBA8, out_w,out_h);
	DCFlushRange(out_texture,512*256*4);
	GX_LoadTexObj(&scr_tex, GX_TEXMAP0);

	GX_SetNumTevStages(1);
	GX_SetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0);
	GX_SetTevOp(GX_TEVSTAGE0, GX_MODULATE);

// ajusta a una textura
	GX_SetNumTexGens(1);

    // aqui se describe los vertices y su formato (el orden sera, pos, norm, color, textura)

	GX_ClearVtxDesc();                    // borra los descriptores
	GX_SetVtxDesc(GX_VA_POS, GX_DIRECT);  // selecciona Posicion como directo
	GX_SetVtxDesc(GX_VA_CLR0, GX_DIRECT); // selecciona Color como directo  
	GX_SetVtxDesc(GX_VA_TEX0, GX_DIRECT); // selecciona Textura como directa

	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,	 GX_POS_XYZ,GX_S16,	0);      // formato de posicion S16 para X, Y ,Z
	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8,	0);  // color RGBA8 para color0
	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_S16, 10);  /* coordenadas de textura como S16 para S y T y desplazamiento 10
	                                                                  las coords de texturas estn en el rango de 0.0f a 1.0f por lo que al meter
																	  un desplazamiento de 10, 1024==1.0f dado que 2 elevado a 10 es 1024
																	  */
  
	xx1=0;
	if(out_w<out_h) xx1=(screenMode->fbWidth-((480*out_w)/out_h))/2;
	if(xx1<0) xx1=0;

	xx2=screenMode->fbWidth-xx1;

	// dibujando el QUAD de pantalla

	 if(screenMode->efbHeight<=480)
		{
		 yy1=12;yy2=screenMode->efbHeight-16;
		}
	else
		{
		yy1=0;yy2=screenMode->efbHeight;
		}

	GX_Begin(GX_QUADS, GX_VTXFMT0, 4); 
		 
		 GX_Position3s16(xx1,yy1, 0); 
         GX_Color1u32(0xffffffff);
		 GX_TexCoord2s16(0,0); 
		 GX_Position3s16(xx2,yy1, 0); 
		 GX_Color1u32(0xffffffff);
		 GX_TexCoord2s16(1023,0); 
		 GX_Position3s16(xx2, yy2, 0); 
		 GX_Color1u32(0xffffffff);
		 GX_TexCoord2s16(1023,1020); 
		 GX_Position3s16(xx1, yy2, 0);
		 GX_Color1u32(0xffffffff);
		 GX_TexCoord2s16(0,1020);  

	GX_End();
	GX_DrawDone();

	reset_gfx=1;   
debug_str="Undef";
}

void wii_video_RGB_noflip(int param)
{
	wii_video_RGB_flip(param);
}

void wii_video_waitvsync()
{
debug_str="wii_video_waitvsync()";

	VIDEO_WaitVSync();

	if(reset_gfx)
		{
		reset_gfx=0;
		GX_SetZMode(GX_TRUE, GX_LEQUAL,	GX_TRUE);
		GX_SetColorUpdate(GX_TRUE);
		GX_CopyDisp(frameBuffer[frame],GX_TRUE);
		
		GX_Flush();
		VIDEO_SetNextFramebuffer(frameBuffer[frame]);
		VIDEO_Flush();
		GX_InvVtxCache();
		GX_InvalidateTexAll();

		}
debug_str="Undef";
}

void wii_sound_volume(int volumel, int volumer)
{
	//SND_ChangeVolumeVoice(1,volumel,volumer);
ASND_ChangeVolumeVoice(0,volumel,volumer);
}

void wii_sound_pause(int pause)
{
	SND_PauseVoice(1, pause);
	//SND_Pause(pause);
}

int Main_Emulator(unsigned char * path_game, int fps);

extern char *MY_filename;
char * get_name(char *name);

int skip_wave_sound=1;
unsigned wii_nKeys=0;

unsigned char *XBuf;

static char rom_name[256]; // almacen del nombre: se utiliza porque en el caso de cargar un .sav, el nombre es reescrito


int vmode=0;

#define WIDTH 512 //(320+64)
#define HEIGHT 256

int volume=80;
int delay_volume=0;






/*********************************************************************/
/* Save/Load configuration of gp2xengine                             */
/*********************************************************************/


MCONFIG mconfig={1,2};

static unsigned cfg_pad[16];

void load_mconfig()
{FILE *fp;

sprintf(tempfilename,"%ssaves/wiiengine.cfg",path_rom);
fp=fopen(tempfilename,"rb");

if(fp==NULL) return;
fread(&mconfig, 1, sizeof(mconfig), fp);
fread(&input_mode, 1, 4, fp);
fread(&swap_runselect, 1, 4, fp);
fread(&volume, 1, 4, fp);
fread(cfg_pad, 1, 16*4, fp);
fclose(fp);
}

void save_mconfig()
{
FILE *fp;
sprintf(tempfilename,"%ssaves/wiiengine.cfg",path_rom);
fp=fopen(tempfilename,"wb");
if(fp==NULL) return;
fwrite(&mconfig, 1, sizeof(mconfig), fp);
fwrite(&input_mode, 1, 4, fp);
fwrite(&swap_runselect, 1, 4, fp);
fwrite(&volume, 1, 4, fp);
memset(cfg_pad, 0, 16*4);
fwrite(cfg_pad, 1, 16*4, fp);

fclose(fp);

}




/****************************************************************************************************************************************/
// PANTALLA
/****************************************************************************************************************************************/

extern unsigned char msx[];  // define la fuente externa usada para dibujar letras y numeros 

unsigned char COLORFONDO=0; // color de fondo (vaya noticia :P)

void set_mypalette()
{
	wii_video_RGB_color8(0x00,0x20,0x40,0);
	wii_video_RGB_color8(0x00,0xa0,0x00,1);
	wii_video_RGB_color8(0xff,0xff,0xff,2);
	wii_video_RGB_color8(0xff,0x00,0x00,3);
	wii_video_RGB_color8(0xff,0xff,0x00,4);
	wii_video_RGB_color8(0x00,0xff,0xff,5);
	wii_video_RGB_color8(0x00,0x00,0x00,6);
	wii_video_RGB_color8(0xff,0xff,0x00,7);
	wii_video_RGB_color8(0x00,0x40,0x80,8);
	wii_video_RGB_color8(0x80,0x80,0x80,9);
	wii_video_RGB_color8(255,255,255,255);
	
}

void set_emupalette()
{
int i;
unsigned  ga= 256; // nivel de brillo (256 == 1.0)

	for(i=0;i<255;i++)
		{

		unsigned r=((i&0x1c)<<3),g=(((i&0xe0)>>2)<<2),b=(((i&3)<<6));
		r=(r*ga)>>8;if(r>255) r=255;
		g=(g*ga)>>8;if(g>255) g=255; 
		b=(b*ga)>>8;if(b>255) b=255;

		wii_video_RGB_color8(r,g,b,i);

		}

	wii_video_RGB_color8(255,255,255,i);

}


void ClearScreen(unsigned char c) // se usa para 'borrar' la pantalla virtual con un color
{
int n;

	for(n=0;n<384*256;n++)
		{
		wii_screen8[n]=c;
		}
}

void v_setpixel(unsigned x, unsigned y, unsigned char color)
{
	if(x>=384 || y>=256) return;
	wii_screen8[y*384+x]=color;
}

void v_square(int x1,int y1, int x2, int y2, unsigned char color)
{
int n=x1;

for(;x1<=x2;x1++)
	{
	v_setpixel(x1, y1, color);
	v_setpixel(x1, y2, color);
	}
x1=n;
for(;y1<=y2;y1++)
	{
	v_setpixel(x1, y1, color);
	v_setpixel(x2, y1, color);
	}
}

void v_putchar( unsigned x, unsigned y, unsigned char color, unsigned char ch) // rutina usada para dibujar caracteres (coordenadas de 8x8)
{
int i,j,v;
unsigned char	*font;
unsigned char col,col2;

	if(x>=48 || y>=32) return;

	col=color;
	col2=COLORFONDO;

	v=(y*384*8);
	font = &msx[ (int)ch * 8];
	for (i=0; i < 8; i++, font++)
		{  
		for (j=0; j < 8; j++)
			{
			if ((*font & (128 >> j)))
				{ 
				wii_screen8[v+(((x<<3)+j))]=col;
				}
			else wii_screen8[v+(((x<<3)+j))]=col2;
			}
	    v+=384;
	 }
 
}

// display array of chars

int v_breakcad=48;
int v_forcebreakcad=0;

void v_putcad(int x,int y,unsigned color,char *cad)  // dibuja una cadena de texto
{
int n=0;

	while(cad[0]!=0) {if(n==v_breakcad) break; v_putchar(x,y,color,cad[0]);cad++;x++;n++;}

	if(v_forcebreakcad)
		{
		while(1) {if(x>=48 || n==v_breakcad) break; v_putchar(x,y,color,' ');cad++;x++;n++;}
		}
}


void m_putchar( unsigned x, unsigned y, unsigned char color, unsigned char ch,int width) // rutina usada para dibujar caracteres (coordenadas de 8x8)
{
int i,j,v;
unsigned char	*font;
unsigned char col,col2;

	if(x>=48 || y>=32) return;

	col=color;
	col2=7;//COLORFONDO;

	v=(y*width*8);
	font = &msx[ (int)ch * 8];

	for (i=0; i < 8; i++, font++)
		{  
		for (j=0; j < 8; j++)
			{
			if((*font & (128 >> j)))
				{ 
				XBuf[v+(((x<<3)+j))]=col;
				}
			else XBuf[v+(((x<<3)+j))]=col2;
			}
		v+=width;
		}

}

// display array of chars

void m_putcad(int x,int y,unsigned color,char *cad,int width)  // dibuja una cadena de texto
{
int n=0;

	while(cad[0]!=0) {if(n==v_breakcad) break; m_putchar(x,y,color,cad[0],width);cad++;x++;n++;}

	if(v_forcebreakcad)
		{
		while(1) {if(x>=48 || n==v_breakcad) break; m_putchar(x,y,color,' ',width);cad++;x++;n++;}
		}
}



static int vwidth=384,vheight=256;
int scount=0;



int osd_volumen=0;

/*********************************************************************/
//  saving bitmap (photo mode)
/*********************************************************************/

int make_photo=0; // variable asignada cuando queremos hacer una foto

int photo_number=0;  // contador de numero de foto
char photo_name[256]; // nombre del fichero

typedef struct
	{ 
	unsigned size;
	unsigned reserved; 
	unsigned offset; 

	unsigned header_size; 
	unsigned width; 
	unsigned height; 
	unsigned short planes;  
	unsigned short bpp; 
	unsigned compression; 
	unsigned image_size; 
	unsigned ppm[2]; 
	unsigned colors_used,colors_important; 

} bmp_header;

bmp_header bmph;

struct 
	{
	unsigned char b,g,r,a;
	} cprgba, *prgba;

void load_bmp_texture(char *bitmap, unsigned *text)
{
int l,n,m,k;
unsigned char *punt;
int colors;

debug_str="load_bmp_texture()";

	punt=(unsigned char*) bitmap;

	memcpy((void *)&bmph,punt+2,52);

	// conversion de endian
	bmph.offset=SWAP32(bmph.offset);
	bmph.header_size=SWAP32(bmph.header_size);
	bmph.width=SWAP32(bmph.width);
	bmph.height=SWAP32(bmph.height);
	bmph.planes=SWAP16(bmph.planes);
	bmph.bpp=SWAP16(bmph.bpp);
	bmph.compression=SWAP32(bmph.compression);
	bmph.image_size=SWAP32(bmph.image_size);
	bmph.colors_used=SWAP32(bmph.colors_used);
	bmph.colors_important=SWAP32(bmph.colors_important);

	if(!bmph.image_size)
		bmph.image_size=bmph.height*(((bmph.width*(bmph.bpp)*2/8)/2)+3) & (~3);

	colors=bmph.bpp;

	if(colors==8 && bmph.colors_used==0) bmph.colors_used=256;
	if(colors==4 && bmph.colors_used==0) bmph.colors_used=16;
	if(colors==1 && bmph.colors_used==0) bmph.colors_used=2;

	prgba=(void *) (punt+54);

	punt+=54+4*bmph.colors_used;

	if(colors==1)
		{
		n=((bmph.width>>3)+3) & ~3;

		for(m=0;m<bmph.height;m++)
			for(l=0;l<bmph.width;l+=8)
				{
				unsigned char ind;

				ind=punt[(l>>3)+(n)*(bmph.height-1-m)];

				for(k=0;k<8;k++)
					{
					if(ind & 128) text[l+k+(m*128)]=0xffffffff; else text[l+k+(m*128)]=0;
					ind<<=1;
					}
				}
	
		}

	if(colors==4)
		{
		n=((bmph.width>>1)+3) & ~3;

		for(m=0;m<bmph.height;m++)
			for(l=0;l<bmph.width;l++)
				{
				unsigned char ind;

				ind=punt[(l>>1)+(n)*(bmph.height-1-m)];

				if(l % 1) ind &=15; else ind>>=4;
				ind&=15;
		
				text[l+(m*bmph.width)]=(prgba[ind].b<<16) | (prgba[ind].g<<8) | (prgba[ind].r) | 0xff000000;
				}
		}

	if(colors==8)
		{
		n=((bmph.width)+3) & ~3;

		for(m=0;m<bmph.height;m++)
			for(l=0;l<bmph.width;l++)
				{
				unsigned char ind;

				ind=punt[(l)+(n)*(bmph.height-1-m)];
   
				text[l+(m*bmph.width)]=(prgba[ind].b<<16) | (prgba[ind].g<<8) | (prgba[ind].r) | 0xff000000;
				}
		}

	if(colors==24)
		{
		n=((bmph.width*3)+3) & ~3;

		for(m=0;m<bmph.height;m++)
			for(l=0;l<bmph.width;l++)
				{
				unsigned char *p;

				p=&punt[(l*3)+(n)*(bmph.height-1-m)];
        
				text[l+(m*bmph.width)]=(((unsigned)p[0])<<16) | (((unsigned)p[1])<<8) | ((unsigned)p[2]) | 0xff000000;
				}
		}
 debug_str="Undef";   
}

int display_bmp(char *name)
{
//int n,m,l,k;
int fsize;
FILE *fp;
int ret=0;

#if 1
char *mem1;
unsigned *mem2;

int xx1,xx2;

debug_str="display_bmp()";

	fp=fopen(name,"rb");
	if(fp==NULL) return 0;

	//exit(0);

	fseek(fp,0,SEEK_END);
	fsize = ftell(fp);
	fseek(fp,0,SEEK_SET);

	mem1=malloc(fsize);
	if(!mem1) {fclose(fp);return 0;}

	fread(mem1,1,fsize,fp);
	fclose(fp);

	mem2=memalign(32,512*256*4);
	if(!mem2) {free(mem1);return 0;}

	memset(mem2,0,512*256*4);

	load_bmp_texture(mem1, mem2);

	free(mem1);

	wii_video_waitvsync();
	wii_video_waitvsync();

debug_str="display_bmp() tiling4x4";
	tiling4x4((void *) mem2, TILE_SRGBA8, bmph.width, bmph.height);
	DCFlushRange(mem2,512*256*4);
	GX_InitTexObj(&scr_tex2, // objeto textura a inicializar
					  (void *) mem2, // direccion de memoria de la textura
					  bmph.width, // ancho
					  bmph.height, // alto
					  GX_TF_RGBA8, // formato de color
					  GX_CLAMP, // Wrap Mode para S
					  GX_CLAMP, // Wrap Mode para T
					  GX_FALSE // No MipMap
					  );
		// ajusta los filtros segn el LOD
		GX_InitTexObjLOD(&scr_tex2, // objeto de textura
						 GX_LINEAR, // filtro Linear para cerca
						 GX_LINEAR, // filtro Linear para lejos
						 0, 0, 0, 0, 0, GX_ANISO_1);
	GX_LoadTexObj(&scr_tex2, GX_TEXMAP0);

	GX_SetNumTevStages(1);
	GX_SetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0);
	GX_SetTevOp(GX_TEVSTAGE0, GX_MODULATE);

// ajusta a una textura
	GX_SetNumTexGens(1);

    // aqui se describe los vertices y su formato (el orden sera, pos, norm, color, textura)

	GX_ClearVtxDesc();                    // borra los descriptores
	GX_SetVtxDesc(GX_VA_POS, GX_DIRECT);  // selecciona Posicion como directo
	GX_SetVtxDesc(GX_VA_CLR0, GX_DIRECT); // selecciona Color como directo  
	GX_SetVtxDesc(GX_VA_TEX0, GX_DIRECT); // selecciona Textura como directa

	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,	 GX_POS_XYZ,GX_S16,	0);      // formato de posicion S16 para X, Y ,Z
	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8,	0);  // color RGBA8 para color0
	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_S16, 10);  /* coordenadas de textura como S16 para S y T y desplazamiento 10
	                                                                  las coords de texturas estn en el rango de 0.0f a 1.0f por lo que al meter
																	  un desplazamiento de 10, 1024==1.0f dado que 2 elevado a 10 es 1024
																	  */
  
    xx1=0;
	if(bmph.width<bmph.height)
		xx1=(screenMode->fbWidth-((int)((480*bmph.width)/bmph.height)))/2;
	if(xx1<0) xx1=0;

	xx2=screenMode->fbWidth-xx1;

	// dibujando el QUAD de pantalla

	GX_Begin(GX_QUADS, GX_VTXFMT0, 4);
		 
		 GX_Position3s16(xx1,0, 0); 
         GX_Color1u32(0xffffffff);
		 GX_TexCoord2s16(0,0); 
		 GX_Position3s16(xx2,0, 0); 
		 GX_Color1u32(0xffffffff);
		 GX_TexCoord2s16(1023,0); 
		 GX_Position3s16(xx2, screenMode->efbHeight, 0); 
		 GX_Color1u32(0xffffffff);
		 GX_TexCoord2s16(1023,1023); 
		 GX_Position3s16(xx1,screenMode->efbHeight, 0);
		 GX_Color1u32(0xffffffff);
		 GX_TexCoord2s16(0,1023); 

	GX_End();
	GX_DrawDone();
   
// ajusta a una textura

	reset_gfx=1;
	wii_video_waitvsync();

debug_str="display_bmp() wait";

	usleep(100*1000);
	while(wii_nKeys & (WII_A | WII_B | WII_START)) wii_nKeys=wii_joystick_read(0);

	while(1)
		{
		wii_nKeys=wii_joystick_read(0);
		
		new_key=wii_nKeys & (~old_key);
		old_key=wii_nKeys;
	  
		

		if(new_key  & (WII_A | WII_B))  break;
		if(new_key  & WII_UP)   {ret=-1;break;}
		if(new_key  & WII_DOWN) {ret=1; break;}
		wii_video_waitvsync();
		}

	wii_video_waitvsync();
	GX_LoadTexObj(&scr_tex, GX_TEXMAP0);
	sprite_ticks=(TIME_SPRITES+50);
	wii_video_RGB_flip(0);
	wii_video_waitvsync();free(mem2);

#endif
 debug_str="Undef";
return ret;
}

int save_bmp(char *name,unsigned char *punt, int ancho, int alto, int align)
{
FILE *fp;
int i;
int ret=-1;

debug_str="save_bmp()";

	fp=fopen(name,"wb");
	if(fp==NULL) return -1;
	if(fputc('B',fp)!='B') goto error;
	if(fputc('M',fp)!='M') goto error;

	bmph.reserved=0;
	bmph.size=SWAP32(54+ancho*alto+256*4);
	bmph.offset=SWAP32(256*4+54);
	bmph.header_size=SWAP32(40);
	bmph.width=SWAP32(ancho);
	bmph.height=SWAP32(alto);
	bmph.planes=SWAP16(1);
	bmph.bpp=SWAP16(8);
	bmph.compression=0;
	bmph.image_size=SWAP32(ancho*alto);
	bmph.ppm[0]=bmph.ppm[1]=0;
	bmph.colors_used=0; // 0 es 256
	bmph.colors_important=0;
	if(fwrite(&bmph, 1, 52, fp)!=52) goto error;

	cprgba.a=0;

	for(i=0;i<255;i++)
		{

		cprgba.r=((i&0x1c)<<3);
		cprgba.g=(((i&0xe0)>>2)<<2);
		cprgba.b=(((i&3)<<6));
		if(fwrite(&cprgba, 1, 4, fp)!=4) goto error;
		}
	cprgba.r=255;
	cprgba.g=255;
	cprgba.b=255;
	if(fwrite(&cprgba, 1, 4, fp)!=4) goto error;
	for(i=1;i<=alto;i++)
		{
		if(fwrite(punt+(alto-i)*align, 1, ancho, fp)!=ancho) goto error;
		}

	ret=0;
error:
	fclose(fp);
 debug_str="Undef";
return ret;
}




/*********************************************************************/
// funciones llamadas por PCE.C
/*********************************************************************/

char cad[256];


void PutImage(int X, int Y, int W, int H)
{
//int time1;

unsigned char *source;
unsigned  *dest;
unsigned  *dest2;

int signal_photo=0;

int h,w,dw,dh;
int n,m;

debug_str="PutImage()";

	if(make_photo==1) // saca una foto
		{
		char *mname;
		debug_str="PutImage() make photo";
		mname=get_name(MY_filename);
		// obten nombre sin extension
		n=0;while(mname[n]!=0) n++;
		while(n>0) {if(mname[n]=='.') {mname[n]=0;break;} n--;}
		
		wii_sound_pause(1);

		skip_wave_sound=1;
	/*	while(1)
			{
			usleep(1000*200);
			if(wave_sound_run==0) break;
			}*/

		make_photo=2;
		sprintf(photo_name,"%simg/%s-%3.3u.bmp",path_rom,mname,photo_number);
		
		if(save_bmp(photo_name, XBuf + Y * WIDTH + X, W, H, WIDTH)==0) signal_photo=1; else signal_photo=2;
		file_modified=1;
		skip_wave_sound=0;
		photo_number++;
        
		debug_str="PutImage()";
		}

	if(signal_photo==2) {m_putcad((X+7)/8,(Y+7)/8+1,255,"Error Writing Photo File",WIDTH);}
	else
	if(osd_volumen)
		{sprintf( (void *) cad,"Volume: %u%% ",volume);
		m_putcad((X+7)/8,(Y+7)/8+1,255,cad,WIDTH);
		osd_volumen--;
		}

/*
 if(trap || 1) // desbichador oficial del programa :P
	  {
	  sprintf( (void *) cad,"Pos %x %i %i",trap,trap2,trap3);
	  
		m_putcad((X+7)/8,(Y+7)/8+6,255,cad,WIDTH);
	  }
*/

	dw=(vwidth-W)/2;dh=(vheight-H)/2;
	if(dw<0) dw=0;
	if(dh<0) dh=0;
	w=W; if(W<vwidth) w=vwidth;
	h=H; if(H<vheight) h=vheight;
	dh*= w;

	out_h=H;
	out_w=W;

	if(signal_photo==1) 
		memsetw(out_texture,0xffffffff,w*h);
	else
		{
		dw=dh=0;
		memset(out_texture,0,w*h*4);
		dest = &out_texture[dh+dw];
		source = XBuf + Y * WIDTH + X;

		for(n=0;n<H;n++)
			{
			dest2=(unsigned *) dest;
			for(m=0;m<W;m++) *dest2++=wii_palette[source[m]];
			
			source+=WIDTH;
			dest+=W;
			}
		}
	
  
	wii_video_waitvsync();
	wii_video_RGB_flip2(0);
	WPAD_ScanPads();
	gamecubepad=PAD_ScanPads();
	debug_str="wav_loop()";
	wav_loop();
	mixaudiofun();

	if(signal_photo) {wii_video_waitvsync();if(signal_photo==1) usleep(100*1000); else usleep(1000*1000);wii_sound_pause(0);}

	if(exit_by_reset) 
		{
		SaveWRAM();
		exit(0);
		
		}
 debug_str="Undef";
}

int InitMachine(void)
{



	XBuf = malloc(sizeof(char) * WIDTH * HEIGHT);
	if(!XBuf) return 0;

	memset(XBuf,0,WIDTH * HEIGHT);

	wii_video_RGB_noflip(0); // single buffer screen

	ClearScreen(COLORFONDO);wii_video_waitvsync();
	InitSound(1);

return 1;
}

void TrashMachine(void)
{
	
	if (XBuf) free(XBuf);XBuf=0;

	StopSound();

}


#define	JOY_A	1
#define	JOY_B	2
#define	JOY_SELECT	4
#define	JOY_START	8
#define	JOY_UP	0x10
#define	JOY_RIGHT	0x20
#define	JOY_DOWN	0x40
#define	JOY_LEFT	0x80



int Config_SCR();

int Joysticks(int num)
{
int v=0;

key_alarm=0;

	wii_nKeys=wii_joystick_read(1+num);


//	auto_fire++;

	if(num & 128) // caso especial de lectura en watchdog o en cuelgue
		{
		if(wii_nKeys & (WII_HOME)) if(Config_SCR())  v|=0x10000;
		return v;
		}
    
	if((wii_nKeys & WII_MINUS) && (wii_nKeys & WII_B)) {make_photo|=1;wii_nKeys&=~(WII_B | WII_MINUS);}

	if(mconfig.A)
		{
		if(wii_nKeys & WII_A) 
			{if(mconfig.A & 4) {if(auto_fire & 4) v|=mconfig.A & 3;} else v|=mconfig.A & 3;}
		}
	if(mconfig.B)
		{
		if(wii_nKeys & WII_B) 
			{if(mconfig.B & 4) {if(auto_fire & 4) v|=mconfig.B & 3;} else v|=mconfig.B & 3;}
		}

	/*if(make_photo>1)  // si la foto se ha hecho, evita autorrepeticiones 
		{
		if((make_photo & 1)==0) make_photo=0;
		}
*/

	if((wii_nKeys & (WII_PLUS | WII_MINUS)))v|=JOY_SELECT;
	if((wii_nKeys & WII_START)) v|=JOY_START;

	if((wii_nKeys & WII_UP))v|=JOY_UP;
	if((wii_nKeys & WII_DOWN))v|=JOY_DOWN;
	if((wii_nKeys & WII_LEFT))v|=JOY_LEFT;
	if((wii_nKeys & WII_RIGHT))v|=JOY_RIGHT;


	if((wii_nKeys & WII_HOME)) {v=0;if(Config_SCR()) v|=0x10000;}

	if(wii_nKeys & (WII_VOL_UP | WII_VOL_DOWN))
		{
		osd_volumen=50;
		if(delay_volume) delay_volume--;
		else
			{
			if(wii_nKeys & WII_VOL_UP)
				{delay_volume=20;volume+=1;if(volume>100) volume=100;wii_sound_volume(volume*255/100, volume*255/100);}
			if(wii_nKeys & WII_VOL_DOWN)
				{delay_volume=20;volume-=1;if(volume<0) volume=0;wii_sound_volume(volume*255/100, volume*255/100);}
			}
		}
		else 
			delay_volume=0;

if(num==3) // nota: esto usa el ultimo joystick leido para desbloquear el modo foto
    {
	if(make_photo==2) make_photo=0;
	else if(make_photo==3) make_photo=2;
	}

return v;
}





/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// SONIDO
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


int		ds_nChannels	= 2;
int		ds_nSampleRate	= 44100; // no modificar! 


int di_sound=1;


int InitDSound()
{
return 1;
}

int StartSound(void)
{ 
	di_sound=0;wii_sound_pause(0);

return 0;
}

int ReleaseDSound(void)
{
return 0;
}

int ReleaseSoundBuffer(void)
{
return 0;
}

int StopSound(void)
{ 
	di_sound=1;wii_sound_pause(1);

return 0;
}

/***********************************************************/
// MAIN SOUND
/***********************************************************/




static int audio_samples=8820;

static s16 out_stream[2][8820*2];
static int stream_flip=0;

static int sound_status=0;

int PCM_fade=0;
int ADPCM_fade=0;

extern void h_stop_track();
extern UChar new_adpcm_play;

static int set_samples=0;
void mixcallback(s32 voice)
{
//short *pu;
//int n;

	if(SND_TestPointer(1,&out_stream[stream_flip][0])!=0 || di_sound!=0)  return;
	if(sound_status==0 && set_samples==0)
		{
       set_samples=1;
		/*pu=&out_stream[stream_flip][0];
		
		for(n=0;n<6;n++) {WriteSoundData(pu, n, audio_samples);}
		wav_mix_samples(pu,audio_samples);
		write_adpcm(audio_samples);
		adpcm_mix(pu,audio_samples);
		sound_status=1;
		if(PCM_fade>0) {PCM_fade-=audio_samples;h_stop_track();}
		if(ADPCM_fade>0) {ADPCM_fade-=audio_samples;new_adpcm_play=0;}*/
		}
    if(set_samples==2)
	if(SND_AddVoice(1, (void *) &out_stream[stream_flip][0], audio_samples<<1)==SND_OK)
		{
		sound_status=0;
		stream_flip^=1;
        set_samples=0;
		}

}

void mixaudiofun()
{
short *pu;
int n;
if(set_samples==1)
	{
	pu=&out_stream[stream_flip][0];
		
	for(n=0;n<6;n++) {WriteSoundData(pu, n, audio_samples);}
	wav_mix_samples(pu,audio_samples);
	write_adpcm(audio_samples);
	adpcm_mix(pu,audio_samples);
	sound_status=1;
	if(PCM_fade>0) {PCM_fade-=audio_samples;h_stop_track();}
	if(ADPCM_fade>0) {ADPCM_fade-=audio_samples;new_adpcm_play=0;}
	set_samples=2;
	}
}


/**************************************************************/
// SONIDO WAV
/**************************************************************/



void wav_loop();


////////////////////////////////////////////////////////////////////////


/***************************************************************************/
// seleccion de roms y otras pantallas del emu 
/***************************************************************************/



int nfiles=0;
int ndirs=0;

#define MAX_ENTRY 512

struct _files
{
int size;
char name[259];
char is_directory;
} files[MAX_ENTRY],swap_file;





int is_ext(char *a,char *b) // compara extensiones
{
int n,m;

	m=0;n=0;
	while(a[n]!=0) {if(a[n]=='.') m=n; n++;}

	n=0;
	while(b[n]!=0) {if(a[m]!=b[n]) return 0; m++; n++;}

	if(a[m]==0) return 1;

return 0;
}

char * get_name_short(char *name) // devuelve el nombre del fichero recortado a 28 caracteres
{
static unsigned char name2[32];

int n,m;

m=0;n=-1;
while(name[m]!=0) {if(name[m]=='/') n=m;m++;}
n++;

	for(m=0;m<28;m++)
		{
		name2[m]=name[n];
		if(name[n]==0) break;
		n++;
		}

	name2[m]=0;

return ((char *)name2);
}

char * get_name(char *name) // devuelve el nombre del fichero completo
{
static unsigned char name2[256];

int n,m;

	m=0;n=-1;

	while(name[m]!=0) {if(name[m]=='/') n=m;m++;}
	n++;

	for(m=0;m<255;m++)
		{
		name2[m]=name[n];
		if(name[n]==0) break;
		n++;
		}

	name2[m]=0;

return ((char *) name2);
}


int never_run_one_rom=1; // se usa para evitar que se reentre con el boto B sin haber cargado una rom primero

int have_device=0;

int current_device=0;

int refresh_disk_size=1;

long long disk_space=0;

void read_list_rom(unsigned char *dirname)
{
DIR_ITER *fd;

static char namefile[256*4];

static struct stat filestat;

static struct statvfs disk_stat;

static char olddirname[256];

static char swap[257];

int n,m,f;

	//if(refresh_disk_size)
	{
	if(current_device==0)
		{
		refresh_disk_size=0;
		statvfs("sd:/", &disk_stat);
		disk_space=((long long) disk_stat.f_bsize)*((long long) disk_stat.f_bfree);
		}
	if(current_device==1)
		{
		refresh_disk_size=0;
		statvfs("usb:/", &disk_stat);
		disk_space=((long long) disk_stat.f_bsize)*((long long) disk_stat.f_bfree);
		}

	}

	if(((int) dirname)==-1) dirname = (unsigned char *) olddirname;
	else 
		{if(dirname) memcpy(olddirname, (void *) dirname,256); 
		 else olddirname[0]=0;
		}

	ndirs=0;
	nfiles = 0;

	if(dirname)
		{
		if(dirname[0] == 0) {sprintf(swap, "%s", path_rom);dirname=0;}
		else
		if(dirname[0] == '.') {sprintf(swap, "%s", path_rom);dirname=0;} // raiz
		else sprintf(swap, "%s%s/", path_rom, dirname);

		}
	else {sprintf(swap, "%s", path_rom);}

if(!dirname)
	{
	
	if(current_device==0 && (have_device & 2)!=0)
		{
		sprintf(files[nfiles].name, ".[USB]");
		ndirs++;files[nfiles].is_directory=1;
		nfiles++;
		}
	if(current_device==1 && (have_device & 1)!=0)
		{
		sprintf(files[nfiles].name, ".[SD]");
		ndirs++;files[nfiles].is_directory=1;
		nfiles++;
		}
	}

	fd = diropen(swap);

	if(fd != NULL) 
		{

		while(nfiles < MAX_ENTRY)
			{
			files[nfiles].is_directory=0;
			
			if(dirnext(fd, namefile, &filestat)!=0) break;

			if(namefile[0]=='.' && namefile[1]==0) continue;
		   
			sprintf(files[nfiles].name, "%s%s", swap, namefile);
		
			if((filestat.st_mode & S_IFDIR)) 
				{
				files[nfiles].size=0;
				if((dirname==0 && namefile[0] != '.') || (namefile[0] == '.' && dirname!=0)) {ndirs++;files[nfiles].is_directory=1; }
				else continue; 
				}
			else 
				{
				if(!(is_ext(files[nfiles].name,".pce") || is_ext(files[nfiles].name,".PCE") || is_ext(files[nfiles].name,".toc") || is_ext(files[nfiles].name,".TOC") 
					|| is_ext(files[nfiles].name,".hcd") || is_ext(files[nfiles].name,".HCD") 
					|| is_ext(files[nfiles].name,".iso") || is_ext(files[nfiles].name,".ISO") || is_ext(files[nfiles].name,".bin") || is_ext(files[nfiles].name,".BIN") || is_ext(files[nfiles].name,".sav")
					|| is_ext (files[nfiles].name, ".bz2") || is_ext (files[nfiles].name, ".BZ2") || is_ext (files[nfiles].name, ".zip") || is_ext (files[nfiles].name, ".ZIP")
					|| is_ext (files[nfiles].name, ".bmp") || is_ext (files[nfiles].name, ".BMP")
				   ) ) continue;

				files[nfiles].size=filestat.st_size;
				}
			
			nfiles++;
			}
	
	dirclose(fd);	
	}
	
    if(!nfiles)
		{
		
		if(current_device==0 && (have_device & 2)!=0)
			{
			sprintf(files[nfiles].name, ".[USB]");
			ndirs++;files[nfiles].is_directory=1;
			nfiles++;
			}
		if(current_device==1 && (have_device & 1)!=0)
			{
			sprintf(files[nfiles].name, ".[SD]");
			ndirs++;files[nfiles].is_directory=1;
			nfiles++;
			}
			
		}

	for(n=0;n<(nfiles);n++) //ordena
	for(m=n+1;m<nfiles;m++)
		{
		f=0;
	 
		
		if(files[m].is_directory==1 && files[n].is_directory==0) f=1;
		if(f==0) 
			if(files[m].is_directory==files[n].is_directory) 
				if(strcmp(files[m].name,files[n].name)<0) f=1;
		if(f)
			{
			f=0;
		    swap_file=files[m];
			files[m]=files[n];
			files[n]=swap_file;
			}
		}

} 


int compress_rom(char *name);


int get_rom()
{
static int init=1;
static  int posfile=0;
unsigned char cad[256];

int n,m,y,f;

int delete_files=0;
int exit_loader=0;

sprite_ticks=(TIME_SPRITES+50);

	set_mypalette();


	if(init)
		{
		file_modified=0;
		read_list_rom(0);if(nfiles)  init=0; else init=1;
		posfile=0;
		}
	else 
		if(file_modified)
			{
			file_modified=0;
			read_list_rom((void *) -1);if(nfiles)  init=0; else init=1;posfile=0;
			}

	while(wii_nKeys & WII_A ) wii_nKeys=wii_joystick_read(0); // para quieto!!

	if(posfile>=nfiles) posfile=0;
	COLORFONDO=0; wii_video_RGB_flip(0);

	f=0;
	while(1)
		{
		wii_video_waitvsync();wii_video_RGB_flip(0);ClearScreen(COLORFONDO);
		sprintf( (void *) cad,"ROM LIST (%u)",nfiles-ndirs);
		v_putcad(0,1,4,(char *) cad);
		m=0;

		for(n=posfile-10;n<posfile+25;n++)
			{
			if(n<0) continue;
			if(n>=nfiles) break;
			if(m>24) break;
			if(n==posfile) COLORFONDO=1; else COLORFONDO=6;

			v_breakcad=19+8;v_forcebreakcad=1;
			if(files[n].is_directory)
				{
				if(files[n].name[0]=='.' && files[n].name[1]=='[')
					{
					sprintf( (void *) cad,"%s",&files[n].name[1]);
				    v_putcad(0,m+3,4,(char *) cad);
					}
				else
					{
					sprintf( (void *) cad,"<%s>",get_name_short(&files[n].name[0]));
					v_putcad(0,m+3,5,(char *) cad);
					}
				}
			else v_putcad(0,m+3,2,(char *) get_name_short(&files[n].name[0]));
			v_breakcad=40+8;v_forcebreakcad=0;
			COLORFONDO=0;
			 m++;
			}
	

		for(;m<25;n++)
			{
			COLORFONDO=6;
			v_breakcad=19+8;v_forcebreakcad=1;
			v_putcad(0,m+3,2," ");
			v_breakcad=40+8;v_forcebreakcad=0;
			COLORFONDO=0;
			 m++;
			}

		v_breakcad=48;
		y=6;

		//benoa
		/*v_putcad(28,y,4,"Press HOME to Delete");y+=1;
		v_putcad(28,y,4,"files");y+=2;
		v_putcad(28,y,4,"Press 1/A to Play");y+=2;
		v_putcad(28,y,4,"Press 2/B to return  ");y+=2;
		v_putcad(28,y,4,"Press PLUS to create");y+=1;
		v_putcad(28,y,4,"compressed .PCE files");y+=2;
		v_putcad(28,y,4,"Press MINUS to exit");y+=1;
		v_putcad(28,y,4,"to the loader");y+=2;*/
				
		v_putcad(28,y,4,"Press 1/A to Play");y+=3;
		v_putcad(28,y,4,"Press 2/B to return  ");y+=3;
		v_putcad(28,y,4,"Press HOME to Quit/  ");y+=1;
		v_putcad(28,y,4,"Compress .PCE files");y+=3;
		//
        y+=4;
        v_putcad(28,y,4,"  Free Disk Space:");y+=1;
		if(disk_space>=0x40000000LL)
			{
			long long temp=disk_space*100LL/0x40000000LL;
			sprintf( (void *) cad,"%u.%2.2u GB",((u32)temp)/100,((u32) temp) % 100);
			}
		else
		if(disk_space>=0x100000LL)
			{
			long long temp=disk_space*100LL/0x100000LL;
			sprintf( (void *) cad,"%u.%2.2u MB",((u32)temp)/100,((u32) temp) % 100);
			}
		else
			{
			long long temp=disk_space*100LL/0x400LL;
			sprintf( (void *) cad,"%u.%2.2u KB",((u32)temp)/100,((u32) temp) % 100);
			}

		v_putcad(28+10-strlen((void *) cad)/2,y,255,(void *) cad);y+=2;

		if(files[posfile].size)
			{
			v_putcad(28,y,4,"    File Size:");y+=1;
			if(files[posfile].size>=0x100000)
				{
				long long temp=((long long)files[posfile].size)*100LL/0x100000LL;
				sprintf( (void *) cad,"%u.%2.2u MB",((u32)temp)/100,((u32) temp) % 100);
				}
			else
				{
				long long temp=((long long)files[posfile].size)*100LL/0x400LL;
				sprintf( (void *) cad,"%u.%2.2u KB",((u32)temp)/100,((u32) temp) % 100);
				}
			v_putcad(28+10-strlen((void *) cad)/2,y,255,(void *) cad);y+=2;
			}
 
        v_square(-1,(2<<3)+2,384,(2<<3)+6,2);
        v_square(-1,(2<<3)+6,(28<<3)-4,(29<<3)-6,2);
		v_square((28<<3)-4,(2<<3)+6,384,(29<<3)-6,2);
		v_square(-1,(29<<3)-6,384,(29<<3)-2,2);

	    if(delete_files)
			{
			COLORFONDO=8;
			v_putcad(12,12,2,"                        ");
			v_putcad(12,13,2,"      Delete File?      ");
			v_putcad(12,14,2,"                        ");
			v_putcad(12,15,2,"  Press 1/A to Delete   ");
			v_putcad(12,16,2,"                        ");
			v_putcad(12,17,2,"  Press 2/B to Cancel   ");
			v_putcad(12,18,2,"                        ");
			v_square(12<<3,12<<3,36<<3,19<<3,2);
			COLORFONDO=0;
			}
        if(exit_loader)
			{
			COLORFONDO=8;
			v_putcad(12,12,2,"                         ");
			v_putcad(12,13,2,"  Exit to the loader ?   ");
			v_putcad(12,14,2,"                         ");
			v_putcad(12,15,2,"   Press 1/A to Exit     ");
			v_putcad(12,16,2,"                         ");
			v_putcad(12,17,2,"   Press 2/B to Cancel   ");
			v_putcad(12,18,2,"                         ");
			//v_square(12<<3,12<<3,36<<3,19<<3,2);
			v_putcad(12,19,2,"  Press PLUS to Compress ");
			v_putcad(12,20,2,"  .PCE file              ");
//v_square(96,96,288,152,2);
v_square(96,96,293,169,2);
			COLORFONDO=0;
			}


//v_putcad(0,26,4,cadenetadelamuerte);

		wii_nKeys=wii_joystick_read(0);
	
		new_key=wii_nKeys & (~old_key);
		old_key=wii_nKeys;
        
	    if(delete_files)
			{
			if(new_key & WII_B) delete_files=0;
			if(new_key & WII_A)
				{
				delete_files=0;
				if(!files[posfile].is_directory) {Main_Emulator((void *) "\0",50);remove(&files[posfile].name[0]);read_list_rom((void *) -1);if(nfiles)  init=0; else init=1;posfile=0;}
				}
			}
		else
		if(exit_loader)
			{
			if(new_key & WII_B) exit_loader=0;
			if(new_key & WII_A)
				{
				wii_video_waitvsync();
				ClearScreen(COLORFONDO);wii_video_RGB_flip(0);wii_video_waitvsync();
				exit_loader=0;
				exit_by_reset=return_reset;
				SaveWRAM();
				exit(0);
		
				}

if(new_key & WII_PLUS)
					{
					for(n=0;n<nfiles;n++)
						{
						ClearScreen(0);
				        v_square(16,16,384-16,256-16,2);
						v_square(24,24,384-24,256-24,2);
						v_putcad((48-22)>>1,10,4,"COMPRESSING .PCE FILES");
						sprintf( (void *) cad,"%% %u",(n*100)/nfiles);
						v_putcad(22,12,5,(char *) cad);
						v_putcad((48-17)>>1,15,2,"Press B to Cancel");
						wii_video_waitvsync();wii_video_RGB_flip(0);

						if(!files[n].is_directory) 
							if(is_ext(&files[n].name[0],".pce") || is_ext(&files[n].name[0],".PCE")) if(compress_rom(&files[n].name[0])) break;
						wii_nKeys=wii_joystick_read(0);
						if(wii_nKeys  & WII_B) break;
						
						}
					read_list_rom((void *) -1);if(nfiles)  init=0; else init=1;posfile=0;
					}


			}
		else
			{ // B

			if(!(old_key  & (WII_UP | WII_DOWN))) f=0;
			if(old_key  & WII_UP)
				{
				if(f==0) f=2;
				else if(f & 1) f=2;
				else {f+=2;if(f>40) {f=34;new_key|=WII_UP;}}
				}
			if(old_key  & WII_DOWN)
				{
				if(f==0) f=1;
				else if(!(f & 1)) f=1;
				else {f+=2;if(f>41) {f=35;new_key|=WII_DOWN;}}
				}
			
	

			if(nfiles>0) if(new_key & WII_A) 
				{
				
				if(!files[posfile].is_directory && (is_ext (&files[posfile].name[0], ".bmp") || is_ext (&files[posfile].name[0], ".BMP")))
					{
					while(1)
						{
						memsetw(out_texture,0,384*256);
						ClearScreen(COLORFONDO);
					    
						n=display_bmp(&files[posfile].name[0]);
						if(n==0) break;
						if(n==-1) {posfile--;if(posfile<0) posfile=nfiles-1; if(files[posfile].is_directory) {posfile--;if(posfile<0) posfile=nfiles-1;}}
						if(n== 1) {posfile++;if(posfile>=nfiles) posfile=0;  if(files[posfile].is_directory) {posfile++;if(posfile>=nfiles) posfile=0;}}
						}
					memsetw(out_texture,0,384*256);
					ClearScreen(COLORFONDO);
					continue;
					}
				else
					{
					if(!files[posfile].is_directory) {return posfile;}
					  else
						{
						 // cambio de device
						 if(files[posfile].name[0]=='.' && files[posfile].name[1]=='[')
							{
							
							if(files[posfile].name[2]=='U') 
								{
								
								Main_Emulator((void *) "\0",50); // libera todo
sprintf (path_rom, "usb:/roms/pcengine/");	
current_device=1;
//refresh_disk_size=0;
							
								//fatSetDefaultInterface(PI_USBSTORAGE);current_device=1;
								//usleep(1000*500);
							    file_modified=0;
								read_list_rom(0);if(nfiles)  init=0; else init=1;
								posfile=0;
								never_run_one_rom=1;
								}
							else
							if(files[posfile].name[2]=='S') 
								{
								Main_Emulator((void *) "\0",50); // libera todo
								//usleep(1000*500);
sprintf (path_rom, "sd:/roms/pcengine/");
current_device=0;
//refresh_disk_size=0;
								//sdio_Shutdown();
								//sdio_Startup();

								//fatSetDefaultInterface(PI_INTERNAL_SD);current_device=0;
								//usleep(1000*500);
							    file_modified=0;
								read_list_rom(0);if(nfiles)  init=0; else init=1;
								posfile=0;
								never_run_one_rom=1;
								}
							}
						 else
						 read_list_rom((void *) get_name(&files[posfile].name[0]));if(nfiles)  init=0; else init=1;posfile=0;
						}
					}
				}

				if(never_run_one_rom==0 && (new_key & (WII_B)))  // continua el juego
					{        
														
					memset(XBuf,0,WIDTH * HEIGHT);

					wii_video_RGB_noflip(0); // single buffer screen

					ClearScreen(COLORFONDO);wii_video_waitvsync();
					return -666;
					}
				//benoa
                //if(new_key & WII_MINUS) {exit_loader=1;new_key=0;}				
				if(new_key & WII_HOME) {exit_loader=1;new_key=0;
					if(new_key & WII_PLUS)
						{
						for(n=0;n<nfiles;n++)
							{
							ClearScreen(0);
						    v_square(16,16,384-16,256-16,2);
							v_square(24,24,384-24,256-24,2);
							v_putcad((48-22)>>1,10,4,"COMPRESSING .PCE FILES");
							sprintf( (void *) cad,"%% %u",(n*100)/nfiles);
							v_putcad(22,12,5,(char *) cad);
							v_putcad((48-17)>>1,15,2,"Press B to Cancel");
							wii_video_waitvsync();wii_video_RGB_flip(0);

							if(!files[n].is_directory) 
								if(is_ext(&files[n].name[0],".pce") || is_ext(&files[n].name[0],".PCE")) if(compress_rom(&files[n].name[0])) break;
							wii_nKeys=wii_joystick_read(0);
							if(wii_nKeys  & WII_B) break;
						
							}
						read_list_rom((void *) -1);if(nfiles)  init=0; else init=1;posfile=0;
						}
				}




				if((new_key & WII_UP)) {posfile--;if(posfile<0) posfile=nfiles-1;}
				if((new_key & WII_DOWN)){posfile++;if(posfile>=nfiles) posfile=0;}
				//benoa
				if((new_key & WII_MINUS)) {posfile=posfile-24;if(posfile<0) posfile=nfiles-1;} 
				if((new_key & WII_PLUS)) {posfile=posfile+24;if(posfile>=nfiles) posfile=0;}
				//if((new_key & WII_HOME) && (!files[posfile].is_directory)) {delete_files=1;}
			} // B
		}

return -1;
}



void credits()
{

int y;
int count=50*2;

sprite_ticks=-1;

	set_mypalette();
	COLORFONDO=0;  

	wii_video_RGB_flip(0);
	while(count>0)
		{
		count--;
		wii_video_waitvsync();wii_video_RGB_flip(0);ClearScreen(COLORFONDO);
		
		v_square(16,16,384-16,256-16,2);
		v_square(24,24,384-24,256-24,2);
		
		y=4;
		v_putcad((48-14)/2,y,2,"Wiiengine v1.5");y+=2;
		v_putcad((48-30)/2,y,2,"Developed by F. Munoz 'Hermes'");y+=3;
		v_putcad((48-16)/2,y,4,"Music by Estrayk");y+=2;
		v_putcad((48-21)/2,y,4,"Based on the work of:");y+=2;
		v_putcad((48-23)/2,y,4,"Marat Fayzullin/ Hu6280");y+=2;
		v_putcad((48-23)/2,y,4,"Alex Krasivsky / Hu6280");y+=2;
		v_putcad((48-11)/2,y,4,"BERO / fpce");y+=2;
		v_putcad((48-11)/2,y,4,"hmmx / XPCE");y+=2;
		v_putcad((48-15)/2,y,4,"Zeograd / Hu-Go");y+=2;
		v_putcad((48-13)/2,y,4,"BZIP2 library");y+=2;
		v_putcad((48-13)/2,y,4,"And DevkitPro");y+=3;
		
		

	   
		wii_nKeys=wii_joystick_read(0);

		if((wii_nKeys & (WII_A | WII_B | WII_START))) 
			{while(wii_nKeys & (WII_A | WII_B |  WII_START)) wii_nKeys=wii_joystick_read(0);return;}

		}

	while(wii_nKeys & (WII_A | WII_B | WII_START)) wii_nKeys=wii_joystick_read(0);

}

static char t_button[8][16]={"Unused","Button I","Button II","Crazy","Crazy","Autofire I","Autofire II","Photo"};

int save_game();
int load_game(int modo);


int Config_SCR()
{

int y,g;
int op=0;

unsigned char cad[256];
int ret=0;
int mess1=0;
int mess2=0;

sprite_ticks=(TIME_SPRITES+50);

	wii_sound_pause(1);
	MODPlay_SetVolume( &mod_track, 64*volume/200,64*volume/200); // fix the volume to 32 (max 64)
	mod_track.paused=0;
    SND_PauseVoice(0, 0);
	COLORFONDO=0;

	set_mypalette();
	ClearScreen(COLORFONDO);


	g=0;
	while(1)
		{
		COLORFONDO=0;
		wii_video_waitvsync();wii_video_RGB_flip(0);ClearScreen(COLORFONDO);
		 
		v_square(16,16,384-16,256-16,2);
		v_square(24,24,384-24,256-24,2);

		y=4;
		v_putcad(14+4,y,4,"CONFIGURATION");
		y+=3;

        if(op==0) COLORFONDO=1; else COLORFONDO=0;
		if(input_mode==1) v_putcad(14,y,2,"Input Mode: Intelligent"); else v_putcad(14,y,2,"Input Mode: Direct");
		y+=2;

		if(op==1) COLORFONDO=1; else COLORFONDO=0;
		sprintf( (void *) cad,"Button 1: %s",t_button[mconfig.A]);
		v_putcad(14,y,2,(char *) cad);y+=2;

		if(op==2) COLORFONDO=1; else COLORFONDO=0;
		sprintf( (void *) cad,"Button 2: %s",t_button[mconfig.B]);
		v_putcad(14,y,2,(char *) cad);y+=2;

		if(op==3) COLORFONDO=1; else COLORFONDO=0;
		if(swap_runselect) sprintf( (void *) cad,"Swap RUN & SELECT: Yes");
		else sprintf( (void *) cad,"Swap RUN & SELECT: No");
		v_putcad(14,y,2,(char *) cad);y+=2;

		if(op==4) COLORFONDO=1; else COLORFONDO=0;
		if(Test_if_CD_Ready()) v_putcad(14,y,2,"Save Game State"); else v_putcad(14,y,9,"Save Game State"); y+=2;

		if(op==5) COLORFONDO=1; else COLORFONDO=0;
		if(Test_if_CD_Ready() || 1) v_putcad(14,y,2,"Load Game State"); else  v_putcad(14,y,9,"Load Game State");y+=2;

        
		if(op==6) COLORFONDO=1; else COLORFONDO=0;
		v_putcad(14,y,2,"Game Exit");y+=3;

		if(op==7) COLORFONDO=1; else COLORFONDO=0;
		v_putcad(14,y,2,"Return");y+=3;

		
		if(mess1) {COLORFONDO=8;v_putcad(16,27,7,"Game State Saved");COLORFONDO=0;mess1--;if(!mess1) break;}
		if(mess2) {COLORFONDO=8;v_putcad(9,27,7,"Error Saving The State Game !!!");COLORFONDO=0;mess2--;}



		wii_nKeys=wii_joystick_read(0);

		new_key=wii_nKeys & (~old_key);
		old_key=wii_nKeys;  

		if(!(old_key  & (WII_UP | WII_DOWN))) g=0;

		if(old_key  & WII_UP)
			{
			if(g==0) g=2;
			else if(g & 1) g=2;
			else {g+=2;if(g>80) {g=68;new_key|=WII_UP;}}
			}

		if(old_key  & WII_DOWN)
			{
			if(g==0) g=1;
			else if(!(g & 1)) g=1;
			else {g+=2;if(g>81) {g=69;new_key|=WII_DOWN;}}
			}

		if(new_key & WII_UP) {op--;if(op<0) op=7;}
		if(new_key & WII_DOWN) {op++;if(op>7) op=0;}

		if(new_key & WII_B) {break;}

		if(new_key & (WII_A))
			{

			if(op==0)
				{
				if(input_mode==2) input_mode=1; else input_mode=2;
				}

			if(op==1)
				{
				mconfig.A++;
				if(mconfig.A==3) mconfig.A=5;
				if(mconfig.A>6) mconfig.A=0;
				}

			if(op==2)
				{
				mconfig.B++;
				if(mconfig.B==3) mconfig.B=5;
				if(mconfig.B>6) mconfig.B=0;
				}

			if(op==3) swap_runselect^=1;
	
			if(op==4 && mess1==0 && mess2==0 && Test_if_CD_Ready())  {if(save_game()) mess1=90; else mess2=90; file_modified=1;}
			if(op==5 && (Test_if_CD_Ready())) {mess1=mess2=0;load_game(0);break;}
			if(op==6) {ret=1;break;}
			if(op==7) break;
			}
		}

    memsetw(out_texture,0,384*256);
    ClearScreen(0);
    wii_video_waitvsync();wii_video_RGB_flip(0);
	while(wii_nKeys & ( WII_A | WII_B | WII_START)) wii_nKeys=wii_joystick_read(0);

	set_emupalette();
	wii_video_waitvsync();wii_video_RGB_noflip(0); 
	COLORFONDO=0;
	ClearScreen(COLORFONDO);wii_video_waitvsync();
	mod_track.paused=1;
    SND_PauseVoice(0, 1);
	wii_sound_pause(0);

return ret;
}

void Loading_Encrypt_SCR()
{

int y,n;

	set_mypalette();
	COLORFONDO=0;

	wii_video_waitvsync();
	ClearScreen(COLORFONDO);
	wii_video_RGB_noflip(0);
	wii_video_waitvsync();
	ClearScreen(COLORFONDO);
	y=15;

	v_putcad((48-21)/2,y,255,"Loading Encrypted ROM");
	wii_video_RGB_noflip(0);
	for(n=0;n<50;n++)
		wii_video_waitvsync();
	   
	set_emupalette();
}
////////////////////////////////////////////////////////////////////////7



void fun_exit()
{
	Main_Emulator((void *) "\0",50); // libera todo
	WPAD_Shutdown();
	skip_wave_sound=1;
	//if(have_device & 1) {fatSetDefaultInterface(PI_INTERNAL_SD);save_mconfig();}
	//if(have_device & 2) {fatSetDefaultInterface(PI_USBSTORAGE); save_mconfig();}
	if(have_device & 1) {save_mconfig();}
	if(have_device & 2) {save_mconfig();}

	SND_End();
   
	//if(have_device & 1) fatUnmount(PI_INTERNAL_SD);
	//if(have_device & 2) fatUnmount(PI_USBSTORAGE);
	if(have_device & 1) fatUnmount("sd:/");
	if(have_device & 2) fatUnmount("usb:/");

	VIDEO_WaitVSync();
	VIDEO_WaitVSync();

	if(exit_by_reset==2)
		SYS_ResetSystem(SYS_RETURNTOMENU, 0, 0);
	if(exit_by_reset==3)
		SYS_ResetSystem(SYS_POWEROFF_STANDBY, 0, 0);
}
 

#include "sprites.h"
void DrawSprite(GXTexObj *sprite,int x,int y, int width, int height, int layer, u32 color)
{

color=Get_LE(color); // ordena los colores

layer=-layer; // layer en realidad, es Z y tiene que tener progresion negativa

    // carga la textura para trabajar como Mapa de textura 0
    GX_LoadTexObj(sprite, GX_TEXMAP0);

	//  ajusta el texture environment a 1 y selecciona para que use el color proporcionado en los vertices 
	GX_SetNumTevStages(1);
	GX_SetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0);
	GX_SetTevOp(GX_TEVSTAGE0, GX_MODULATE);
    
	// ajusta a una textura
	GX_SetNumTexGens(1);

    // aqui se describe los vertices y su formato (el orden sera, pos, norm, color, textura)

	GX_ClearVtxDesc();                    // borra los descriptores
	GX_SetVtxDesc(GX_VA_POS, GX_DIRECT);  // selecciona Posicion como directo
	GX_SetVtxDesc(GX_VA_CLR0, GX_DIRECT); // selecciona Color como directo  
	GX_SetVtxDesc(GX_VA_TEX0, GX_DIRECT); // selecciona Textura como directa

	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,	 GX_POS_XYZ,GX_S16,	0);      // formato de posicion S16 para X, Y ,Z
	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8,	0);  // color RGBA8 para color0
	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_S16, 10);  /* coordenadas de textura como S16 para S y T y desplazamiento 10
	                                                                  las coords de texturas estn en el rango de 0.0f a 1.0f por lo que al meter
																	  un desplazamiento de 10, 1024==1.0f dado que 2 elevado a 10 es 1024
																	  */
    
	// dibujando el QUAD del Sprite

	GX_Begin(GX_QUADS, GX_VTXFMT0, 4); // le decimos que pinte 3 vertices de un triangulo (si fueran mas triangulos, aadir mas vertices)
		 
		 GX_Position3s16(x,y,layer); 
         GX_Color1u32(color);
		 GX_TexCoord2s16(0,0); 
		 GX_Position3s16(x+width-1,y,layer); 
		 GX_Color1u32(color);
		 GX_TexCoord2s16(1023,0); 
		 GX_Position3s16(x+width-1,y+height-1,layer); 
		 GX_Color1u32(color);
		 GX_TexCoord2s16(1023,1023); 
		 GX_Position3s16(x,y+height-1,layer);
		 GX_Color1u32(color);
		 GX_TexCoord2s16(0,1023); 

	GX_End();

}

typedef struct 
{
int x,y;
int dx,dy;
int width,height;

int tex_index;
int layer;
u32 color;
} Sprite;

Sprite sprites[4];

GXTlutObj palette;

GXTexObj sprite_text[32]; // objetos texturas para 32 sprites


void Init_Sprites()
{
int n;
//carga la paleta de los sprites

ctlut(sprites_palette, TLUT_SRGB5A1, sprites_palette_colors);

GX_InitTlutObj(&palette, sprites_palette, GX_TL_RGB5A3, sprites_palette_colors);
GX_LoadTlut(&palette, GX_TLUT0);

// cargado de todos los sprites


for(n=0;n<sprites_num_sprites;n++)
    {
	void *sprite_tex;
	int sprite_width;
	int sprite_height;

	sprite_tex    = sprites_sprites[n].ptr;
	sprite_width  = sprites_sprites[n].sx;
	sprite_height = sprites_sprites[n].sy;
	
    tiling4x4((void *) sprite_tex, TILE_CI8, sprite_width, sprite_height); // function for texture conversion
    // carga la textura
	
	GX_InitTexObjCI(&sprite_text[n], // objeto textura a inicializar
				  (void *) sprite_tex, // direccion de memoria de la textura
				  sprite_width, // ancho
				  sprite_height, // alto
				  GX_TF_CI8, // formato de color
				  GX_CLAMP, // Wrap Mode para S
				  GX_CLAMP, // Wrap Mode para T
				  GX_FALSE, // No MipMap
				  GX_TLUT0  // asigna la paleta
				  );
	
	// ajusta los filtros segn el LOD
	GX_InitTexObjLOD(&sprite_text[n], // objeto de textura
					 GX_LINEAR, // filtro Linear para cerca
					 GX_LINEAR, // filtro Linear para lejos
					 0, 0, 0, 0, 0, GX_ANISO_1);


	}			

	

}


void main_sprites()
{
int n;
unsigned alpha=0xc0000000;
static int ticks=0;

if(sprite_ticks<0) return;
if(sprite_ticks==0)
	{
	// define los cuatro sprites

     sprites[0].x=-64; // coordenadas en cada esquina, fuera de la pantalla para que no se vean inicialmente
	 sprites[0].y=-64;
     sprites[0].dx=2;  // paso de desplazamiento en  cada frame
	 sprites[0].dy=4;
	 sprites[0].tex_index=0; // indice a la textura, para animarla
	 sprites[0].width=64;    // ancho aumentado
	 sprites[0].height=64;   // alto aumentado
     sprites[0].layer=0;     // ordenacin mediante buffer Z
	 sprites[0].color=0x00ffffff; // blanco un poco translucido

	 sprites[1].x=screenMode->fbWidth+64;
	 sprites[1].y=-64;
     sprites[1].dx=-3;
	 sprites[1].dy=4;
	 sprites[1].tex_index=0; 
	 sprites[1].width=64;
	 sprites[1].height=64;
     sprites[1].layer=0;
	 sprites[1].color=0x000000ff; // rojo

	 sprites[2].x=-64;
	 sprites[2].y=screenMode->efbHeight+64;
     sprites[2].dx=2;
	 sprites[2].dy=-4;
	 sprites[2].tex_index=0; 
	 sprites[2].width=64;
	 sprites[2].height=64;
     sprites[2].layer=0;
     sprites[2].color=0x0000ff00; // verde

	 sprites[3].x=screenMode->fbWidth+64;
	 sprites[3].y=screenMode->efbHeight+64;
     sprites[3].dx=2;
	 sprites[3].dy=-5;
	 sprites[3].tex_index=0; 
	 sprites[3].width=64;
	 sprites[3].height=64;
     sprites[3].layer=0;
	 sprites[3].color=0x0000ffff; // amarillo, como el submarino
	}
if(sprite_ticks>=TIME_SPRITES)
	{
	alpha=(sprite_ticks-TIME_SPRITES)*4;
	if(alpha>=0xc0) alpha=0xc0;
	alpha=(0xc0-alpha)<<24;
    if(sprite_ticks>=(TIME_SPRITES+50+480)) {sprite_ticks=0;return;}
	}
sprite_ticks++;
GX_SetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA,GX_BL_INVSRCALPHA, GX_LO_CLEAR);

// activa la transparencia de texturas: los colores con alpha<8 no se dibujan
GX_SetAlphaCompare(GX_GEQUAL, 8, GX_AOP_AND, GX_ALWAYS, 0); // esto deja pasar solo valores entre 8 y 255

 ticks++;
    
	for(n=0;n<4;n++)
	{
	
	// aqui se dibuja el sprite

	DrawSprite(&sprite_text[sprites[n].tex_index],sprites[n].x,sprites[n].y, sprites[n].width, sprites[n].height, sprites[n].layer,sprites[n].color | alpha);
	

	// animacin del sprite

   if(ticks & 1)
		{
	    sprites[n].x+=sprites[n].dx; // desplaza
	    sprites[n].y+=sprites[n].dy;
		}
    
	if(sprites[n].x<0 || sprites[n].x>(screenMode->fbWidth-sprites[n].width)) // comprueba limites X y cambia el sentido si procede
		{
		
		if((sprites[n].dx*(sprites[n].x-screenMode->fbWidth/2))>0)	
			{sprites[n].dx=-sprites[n].dx;sprites[n].x-=sprites[n].dx;}

		if(sprites[n].dx<0) sprites[n].tex_index=1; else sprites[n].tex_index=5; 
		}

	if(sprites[n].y<8 || sprites[n].y>(screenMode->efbHeight-sprites[n].height))  // comprueba limites Y y cambia el sentido si procede
		{
		
		if((sprites[n].dy*(sprites[n].y-screenMode->efbHeight/2))>0)	
			{sprites[n].y-=sprites[n].dy;sprites[n].dy=-sprites[n].dy;}
		}

    
	 if(ticks==8) sprites[n].tex_index^=1; // cambia la animacion una vez cada 8 frames
	}


     if(ticks>=8) ticks=0; // solo se cuenta hasta 8


GX_SetBlendMode(GX_BM_NONE, GX_BL_SRCALPHA,GX_BL_INVSRCALPHA, GX_LO_CLEAR);
// activa la transparencia de texturas: los colores con alpha<8 no se dibujan
GX_SetAlphaCompare(GX_ALWAYS, 8, GX_AOP_AND, GX_ALWAYS, 0); // esto deja pasar solo valores entre 8 y 255    
}


/****************************************************************************
 * IOS support
 ***************************************************************************/
static bool FindIOS(u32 ios)
{
	s32 ret;
	u32 n;
	
  u64 *titles = NULL;
	u32 num_titles=0;
	
	ret = ES_GetNumTitles(&num_titles);
	if (ret < 0)
		return false;
	
	if(num_titles < 1) 
		return false;
	
	titles = (u64 *)memalign(32, num_titles * sizeof(u64) + 32);
	if (!titles)
		return false;
	
	ret = ES_GetTitles(titles, num_titles);
	if (ret < 0)
	{
		free(titles);
		return false;
	}
	
	for(n=0; n < num_titles; n++)
	{
		if((titles[n] & 0xFFFFFFFF)==ios) 
		{
			free(titles); 
			return true;
		}
	}
  free(titles); 
	return false;
}

int main(int argc, char *argv[])
{
int r;
//int dclock;

DIR_ITER *dir;
Mtx44 projection;
Mtx	modelView;

GXColor	backgroundColor	= {0, 0x20*0, 0x40*0,	255};


void *fifoBuffer = NULL;

return_reset=1;

if(argc<1) return_reset=2;

// Inicializa el sistema de video

	VIDEO_Init();

if(IOS_GetVersion() != 202 && FindIOS(202))
		IOS_ReloadIOS(202);

if(IOS_GetVersion() == 202)
	{
		/* disable DVDX stub */
        //DI_LoadDVDX(false);
		//DI_Init();

//benoa
//DI_Close();

		/* load EHCI module & enable USB2 driver */
		if(mload_init() >= 0 && load_ehci_module())
			USB2Enable(true);

	}


// Inicializa la pantalla para doble buffer

    screenMode = VIDEO_GetPreferredMode (NULL);
	
	frameBuffer[0]	= MEM_K0_TO_K1(SYS_AllocateFramebuffer(screenMode));
	frameBuffer[1]	= MEM_K0_TO_K1(SYS_AllocateFramebuffer(screenMode));

	VIDEO_Configure(screenMode);
	VIDEO_SetNextFramebuffer(frameBuffer[frame]);
	VIDEO_SetPostRetraceCallback(copy_buffers);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();

    // asigna la memoria para el FIFO

	fifoBuffer = MEM_K0_TO_K1(memalign(32,FIFO_SIZE));
	memset(fifoBuffer,0, FIFO_SIZE);

	GX_Init(fifoBuffer, FIFO_SIZE);
    
	// formato RGB y Buffer Z a 24 bits
	GX_SetPixelFmt(GX_PF_RGB8_Z24, GX_ZC_LINEAR);
	// asigna los valores de borrado de pantalla (color) y de relleno de buffer Z
	GX_SetCopyClear(backgroundColor, 0x00ffffff);

	GX_SetViewport(0,0,screenMode->fbWidth,screenMode->efbHeight,0.0f,1.0f);
	GX_SetDispCopyYScale((f32)screenMode->xfbHeight/(f32)screenMode->efbHeight);
	GX_SetScissor(0,0,screenMode->fbWidth,screenMode->efbHeight);
	GX_SetDispCopySrc(0,0,screenMode->fbWidth,screenMode->efbHeight);
	GX_SetDispCopyDst(screenMode->fbWidth,screenMode->xfbHeight);
	GX_SetCopyFilter(screenMode->aa,screenMode->sample_pattern,
					 GX_TRUE,screenMode->vfilter);
	GX_SetFieldMode(screenMode->field_rendering,
					((screenMode->viHeight==2*screenMode->xfbHeight)?GX_ENABLE:GX_DISABLE));

	GX_SetCullMode(GX_CULL_NONE);
	GX_CopyDisp(frameBuffer[frame],GX_TRUE);
    
	GX_SetDispCopyGamma(GX_GM_1_0);

	// Ajusta la Matriz de Proyeccion para trabajar con Sprites en 2D
   /* if(screenMode->efbHeight<=480)
       guOrtho(projection, -16.0f ,(f32) (screenMode->efbHeight+16), 0.0f ,(f32)(screenMode->fbWidth-1), 0.0f, 1000.0f); // z desde 0 a 1000.0f
	else*/
	   guOrtho(projection, 0.0f ,(f32) (screenMode->efbHeight), 0.0f ,(f32)(screenMode->fbWidth-1), 0.0f, 1000.0f); // z desde 0 a 1000.0f

	GX_LoadProjectionMtx(projection, GX_ORTHOGRAPHIC);


    // activa translucidez

#if 0
	GX_SetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA,GX_BL_INVSRCALPHA, GX_LO_CLEAR);

    // activa la transparencia de texturas: los colores con alpha<8 no se dibujan

	GX_SetAlphaCompare(GX_GEQUAL, 8, GX_AOP_AND, GX_ALWAYS, 0); // esto deja pasar solo valores entre 8 y 255
	#endif
    GX_PixModeSync(); // funcin de sincronizacin.
    GX_SetZCompLoc(GX_FALSE); /* esto hace que no se actualize el buffer Z hasta despus de texturizar */


    // aqui ajustamos la iluminacion en Off a un solo canal y para que tome el color de los vertices
	GX_SetNumChans(1); 
	GX_SetChanCtrl(GX_COLOR0A0,GX_DISABLE, GX_SRC_REG, GX_SRC_VTX, GX_LIGHTNULL, GX_DF_CLAMP, GX_AF_NONE );
	


	GX_InitTexObj(&scr_tex, // objeto textura a inicializar
					  (void *) out_texture, // direccion de memoria de la textura
					  384, // ancho
					  256, // alto
					  GX_TF_RGBA8, // formato de color
					  GX_CLAMP, // Wrap Mode para S
					  GX_CLAMP, // Wrap Mode para T
					  GX_FALSE // No MipMap
					  );
	// ajusta los filtros segn el LOD
	GX_InitTexObjLOD(&scr_tex, // objeto de textura
					 GX_LINEAR, // filtro Linear para cerca
					 GX_LINEAR, // filtro Linear para lejos
					 0, 0, 0, 0, 0, GX_ANISO_1);


    Init_Sprites();

	SYS_SetResetCallback(reset_call); // esto es para que puedas salir al pulsar boton de RESET
	SYS_SetPowerCallback(power_call); // esto para apagar con power

    PAD_Init();
	WPAD_Init();
	WPAD_SetIdleTimeout(60*5); // 5 minutes 


    LWP_SetThreadPriority(LWP_GetSelf(),40);

	
	

	SND_Init(INIT_RATE_48000); // Initialize the Sound Lib

    MODPlay_Init(&mod_track);


	if (MODPlay_SetMOD (&mod_track, omega2_mod ) < 0 ) // set the MOD song
		{
		MODPlay_Unload (&mod_track);   
		}
	else  
		{
		MODPlay_SetVolume( &mod_track, 32,32); // fix the volume to 32 (max 64)
		MODPlay_Start (&mod_track); // Play the MOD
		}
	mod_track.paused=0;
	SND_Pause(0);
    SND_PauseVoice(0, 0);

	GX_InvVtxCache();
	GX_InvalidateTexAll();

	guMtxIdentity(modelView);

	/* NOTA: con sta matriz, podrias jugar para rotar los sprites*/

	GX_LoadPosMtxImm(modelView,	GX_PNMTX0); // carga la matriz mundial como identidad
	GX_SetCurrentMtx(GX_PNMTX0); // selecciona la matriz

	atexit(fun_exit);
	
	credits();

	VIDEO_WaitVSync();
    
	fatInitDefault();
     
	//fatInit(8, false);

	//usleep(1500*1000);

    //fatSetDefaultInterface(PI_INTERNAL_SD);
	
	have_device=0;
	{
		int n;

    //char fat[6] = "fat:/";
    
	//fat[3] = 48+PI_INTERNAL_SD;
    
	for(n=0;n<5;n++)
		{
		dir = diropen("sd:/");
		if (dir) {dirclose(dir); have_device|=1;break;}
		usleep(200*1000);
		}

	//fat[3] = 48+PI_USBSTORAGE;

    for(n=0;n<5;n++)
		{
		dir = diropen("usb:/");
		if (dir) {dirclose(dir);  have_device|=2;break;}
		usleep(200*1000);
		}

    }
	
	
    current_device=0;
	// crea los directorios saves e img
	for(r=0;r<2;r++)
	{
	
	if(r==0 && (have_device & 2)==0)  continue;
	if(r==1 && (have_device & 1)==0)  continue;

	usleep(1000*500);

	dir = diropen(path_rom);
	if (dir) 
		{
		dirclose(dir);
		//usleep(1000*200);
		sprintf(tempfilename,"%ssaves",path_rom);
		mkdir(tempfilename,S_IREAD | S_IWRITE);
	//	usleep(1000*200);
		sprintf(tempfilename,"%simg",path_rom);
		mkdir(tempfilename,S_IREAD | S_IWRITE);
	//	usleep(1000*500);
	    load_mconfig();

		if(r==0) {current_device=1;}
		else current_device=0;
	   
		}
	}

	
	skip_wave_sound=1;

	while(1)
		{
	    debug_str="main() loop";
		make_photo=0;
		wii_sound_pause(1);
		set_mypalette();
		memsetw(out_texture,0,384*256);
		ClearScreen(COLORFONDO);
        wii_video_waitvsync();wii_video_RGB_flip(0);

		MODPlay_SetVolume( &mod_track, 64*volume/200,64*volume/200); // fix the volume to 32 (max 64)
		mod_track.paused=0;
        SND_PauseVoice(0, 0);
                
		r=get_rom();
		
		sprite_ticks=-1;
        mod_track.paused=1;
        SND_PauseVoice(0, 1);
		memsetw(out_texture,0,384*256);
		ClearScreen(COLORFONDO);

		set_emupalette();
	
		if(r>=0 || r==-666)
			{
			SND_PauseVoice(1, 0);
			SND_StopVoice(1);
			memset((void *) &out_stream[stream_flip][0], 0, audio_samples<<1);
			set_samples=0;
			sound_status=0;
			SND_SetVoice(1,VOICE_STEREO_16BIT, 44100, 0, (void *) &out_stream[stream_flip][0], audio_samples<<1, volume*255/100, volume*255/100, mixcallback);
			stream_flip^=1;
			
			SND_PauseVoice(1, 0);
			}

		 if(r>=0) {di_sound=0;memcpy(rom_name,&files[r].name[0],256);Main_Emulator((void *) rom_name,(screenMode->efbHeight<=480) ? 60 : 50); }
		 else {if(r==-666)  {di_sound=0;Main_Emulator((void *) 0, (screenMode->efbHeight<=480) ? 60 : 50);} else break;}

		 di_sound=1; 	
		}

return(0);

}

void tiling4x4(void *mem,int format,int tx,int ty)
{
int n,m,l;
u16 mem_tile[1024*8];
int swap=(format & TILE_LITTLE_ENDIAN)!=0;

format &= ~TILE_LITTLE_ENDIAN;

#define INV_COLORA16(x) ((x & 0x83e0) | ((x & 31)<<10) | ((x>>10) & 31))
#define INV_COLOR16(x) ((x & 0x7e0) | ((x & 31)<<11) | ((x>>11) & 31))
#undef SWAP16
#define SWAP16(x) (((x)>>8) | ((x)<<8))

if(format==TILE_CI4)
	{
	u8 *p1,*p2;
	
	p1=(u8 *) mem;
    p2=(u8 *) &mem_tile[0];
    tx>>=1;
    for(n=0;n<ty;n+=8)
		{
		for(l=0;l<8;l++)
			{
			for(m=0;m<tx;m+=4)
				{
				p2[((l+(m<<1))<<2)]=p1[(n+l)*tx+m];
				p2[((l+(m<<1))<<2)+1]=p1[(n+l)*tx+m+1];
				p2[((l+(m<<1))<<2)+2]=p1[(n+l)*tx+m+2];
				p2[((l+(m<<1))<<2)+3]=p1[(n+l)*tx+m+3];
				}
			}
		for(l=0;l<8;l++)
			{
			for(m=0;m<tx;m++)
				{
				p1[(n+l)*tx+m]=p2[(l)*tx+m];
				}
			}
		}

	DCFlushRange(mem,tx*ty);
	return;
	}
            
if(format==TILE_CI8)
	{
	u16 *p1,*p2;
	
	p1=(u16 *) mem;
    p2=(u16 *) &mem_tile[0];
    tx>>=1;
    for(n=0;n<ty;n+=4)
		{
		for(l=0;l<4;l++)
			{
			for(m=0;m<tx;m+=4)
				{
				p2[((l+m)<<2)]=p1[(n+l)*tx+m];
				p2[((l+m)<<2)+1]=p1[(n+l)*tx+m+1];
				p2[((l+m)<<2)+2]=p1[(n+l)*tx+m+2];
				p2[((l+m)<<2)+3]=p1[(n+l)*tx+m+3];
				}
			}
		for(l=0;l<4;l++)
			{
			for(m=0;m<tx;m++)
				p1[(n+l)*tx+m]=p2[(l)*tx+m];
			}
		}

	DCFlushRange(mem,tx*2*ty);
	return;
	}

if(format<TILE_RGBA8) // color 16 bits
	{
	u16 *p1,*p2;
	
	p1=(u16 *) mem;
    p2=(u16 *) &mem_tile[0];

    for(n=0;n<ty;n+=4)
		{
		for(l=0;l<4;l++)
			{
			for(m=0;m<tx;m+=4)
				{
				p2[((l+m)<<2)]=p1[(n+l)*tx+m];
				p2[((l+m)<<2)+1]=p1[(n+l)*tx+m+1];
				p2[((l+m)<<2)+2]=p1[(n+l)*tx+m+2];
				p2[((l+m)<<2)+3]=p1[(n+l)*tx+m+3];
				}
			}
	if(format==TILE_RGB5A3 || format==TILE_RGB565)
		{
		for(l=0;l<4;l++)
			{
			if(swap) // for little endian to big endian order
			  for(m=0;m<tx;m++) p1[(n+l)*tx+m]= SWAP16(p2[(l)*tx+m]);
			else
			  for(m=0;m<tx;m++) p1[(n+l)*tx+m]=p2[(l)*tx+m];
	
			}
		}
	else
	if(format==TILE_SRGB565)
		{
		for(l=0;l<4;l++)
			{
			if(swap)  // for little endian to big endian order
			  for(m=0;m<tx;m++) p1[(n+l)*tx+m]=INV_COLOR16(SWAP16(p2[(l)*tx+m]));
		    else
			  for(m=0;m<tx;m++) p1[(n+l)*tx+m]=INV_COLOR16(p2[(l)*tx+m]);
			
			}
		}
	else
	if(format==TILE_SRGB5A1)
		{
		for(l=0;l<4;l++)
			{
			if(swap)  // for little endian to big endian order
				for(m=0;m<tx;m++) p1[(n+l)*tx+m]=INV_COLORA16(SWAP16(p2[(l)*tx+m]));  // color 16 bits (With R and B swap)
			else
			    for(m=0;m<tx;m++) p1[(n+l)*tx+m]=INV_COLORA16(p2[(l)*tx+m]);  // color 16 bits (With R and B swap)
				
			}
		}
		
		}
	}
if(format==TILE_RGBA8 || format==TILE_SRGBA8)
	{
	u16 *p1,*p2;
	u32 *p32;
	int tx2=tx*2;

	p1=(u16 *) mem;
    p2=(u16 *) &mem_tile[0];
    p32=(u32 *) p1;
    
	if(format==TILE_SRGBA8) // swap R and B
		{
		for(n=0;n<ty;n++)
		for(m=0;m<tx;m++)
			{
			u32 rgba;
		
			rgba=p32[n*tx+m];

			if(swap)  // for little endian to big endian order
				rgba=(rgba<<24) | ((rgba<<8) & 0xff0000) | ((rgba>>8) & 0xff00) | ((rgba>>24) & 0xff0000);
		
			rgba=(rgba & 0xff00ff00) | ((rgba>>16) & 0xff)  | ((rgba<<16) & 0xff0000);

			p32[n*tx+m]=rgba;

			}
		}

    for(n=0;n<ty;n+=4)
		{
		for(l=0;l<4;l++)
			{
		
			for(m=0;m<tx;m+=4)
				{
				int m2=m<<1;
				p2[((l+m2)<<2)]=p1[(((n+l)*tx+m)<<1)];
				p2[((l+m2)<<2)+1]=p1[(((n+l)*tx+m+1)<<1)];
				p2[((l+m2)<<2)+2]=p1[(((n+l)*tx+m+2)<<1)];
				p2[((l+m2)<<2)+3]=p1[(((n+l)*tx+m+3)<<1)];
               
                p2[((l+m2)<<2)+16]=p1[(((n+l)*tx+m)<<1)+1];
				p2[((l+m2)<<2)+17]=p1[(((n+l)*tx+m+1)<<1)+1];
				p2[((l+m2)<<2)+18]=p1[(((n+l)*tx+m+2)<<1)+1];
				p2[((l+m2)<<2)+19]=p1[(((n+l)*tx+m+3)<<1)+1];
				
				}
			}
	
		for(l=0;l<4;l++)
			{
			for(m=0;m<tx2;m++)
				{
				p1[(n+l)*tx2+m]=p2[(l)*tx2+m];
				}
			}
		
		}
	}

#undef INV_COLOR16
#undef INV_COLORA16
#undef SWAP16

if(format<TILE_RGBA8)
    DCFlushRange(mem,tx*ty*2);
else 
	DCFlushRange(mem,tx*ty*4);

}

void ctlut(void *mem,int format,int entries)
{
int n;
int swap=(format & TLUT_LITTLE_ENDIAN)!=0;

format &= ~TLUT_LITTLE_ENDIAN;

#define INV_COLORA16(x) ((x & 0x83e0) | ((x & 31)<<10) | ((x>>10) & 31))
#define INV_COLOR16(x) ((x & 0x7e0) | ((x & 31)<<11) | ((x>>11) & 31))
#define SWAP16(x) (((x)>>8) | ((x)<<8))

if(format==TLUT_RGB5A3 || format==TLUT_RGB565) 
	{
	if(swap) // for little endian to big endian order
		{
		u16 *p1=(u16 *) mem;

	    for(n=0;n<entries;n++)  p1[n]=SWAP16(p1[n]);

		}
	DCFlushRange(mem, entries*2); return;
	}

if(format==TLUT_SRGB565)
	{
	u16 *p1=(u16 *) mem;
  
    if(swap) // for little endian to big endian order
	     for(n=0;n<entries;n++) p1[n]=INV_COLOR16(SWAP16(p1[n]));
	else
		 for(n=0;n<entries;n++) p1[n]=INV_COLOR16(p1[n]);
		 
		
	DCFlushRange(mem, entries*2); return;
	}
if(format==TLUT_SRGB5A1)
	{
	u16 *p1=(u16 *) mem;

    if(swap) // for little endian to big endian order
	     for(n=0;n<entries;n++) p1[n]=INV_COLORA16(SWAP16(p1[n]));
	else
		 for(n=0;n<entries;n++) p1[n]=INV_COLORA16(p1[n]);
		
	DCFlushRange(mem, entries*2); return;
	}

#undef INV_COLOR16
#undef INV_COLORA16
#undef SWAP16
}

void copy_buffers(u32 count __attribute__ ((unused)))
{
key_alarm++;
auto_fire++;
}

/* end */


