/*  GP2Xengine 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/


/*
	Portable PC-Engine Emulator
	1998 by BERO bero@geocities.co.jp

    Modified 1998 by hmmx hmmx@geocities.co.jp
	Modified 1999-2005 by Zeograd (Olivier Jolly) zeograd@zeograd.com
	Modified 2005 by Hermes/PS2Reality
	Modified 2008 by Francisco Muoz 'Hermes'
*/


#include	<stdio.h>
#include	<stdlib.h>

// added for Wii
#include	<string.h>
#include	<malloc.h>
#include	<math.h>
#include	<ogcsys.h>
#include	<gccore.h>
#include	<fat.h>
#include	<fcntl.h>


#include	"m6502.h"
#include	"pce.h"
#include	"bzip/bzlib.h"
#include	"unzip.h"

#include	"sound.h"
#include    "wav.h"
#include	"iso.h"


#define BOOL int
//#define DWORD unsigned
#define WORD unsigned short
#define BYTE byte

int fast_sprite=0;

extern char path_rom[257];
extern char tempfilename[257];

extern UChar new_adpcm_play;
extern int PCM_fade;
extern int ADPCM_fade;

extern unsigned WAV_TPOSITION_IN;

void memcpy_b16(char *a, char *b, int size)
{
int n;
size>>=1;

for(n=0;n<size;n++)
	{
	a[0]=b[1];
    a[1]=b[0];
	a+=2;b+=2;
	}
}

int load_game(int modo);

int is_ext(char *a,char *b); // compara extensiones
int StartSound(void); 
int StopSound(void);

extern int never_run_one_rom;

extern int skip_wave_sound;
//extern int wave_sound_run;

char *MY_filename;
M6502 dummy;
M6502 *M2=&dummy;

char back_name_path[256];
int back_name_ext;
char * get_name(char *name);

int is_street_fighter=0;
int sf2_latch=0;


byte dummy_r[0x2000]  __attribute__((aligned(4)));
byte dummy_w[0x2000]  __attribute__((aligned(4)));

//#define SUPPORT_FOR_ARCADE_CARD 111

#ifdef SUPPORT_FOR_ARCADE_CARD
int want_arcade_card_emulation=1;
byte ac_extra_mem[0x200000]  __attribute__((aligned(4)));



#endif

void TRACE(char *a,...) {}

#define WIDTH  512 //(320+64)
#define HEIGHT 256



int UPeriod;
 int BaseClock;

int min(int a,int b)
 {
 if(a<b) return a;
 return b;
 }

#ifndef TRUE
#define	TRUE	1
#define	FALSE	0
#endif



#define	VRAMSIZE	0x20000


byte RAM[0x8000+0x2000] __attribute__((aligned(4))); // suma 0x2000 por posible desbordamiento
byte PopRAM[0x10000] __attribute__((aligned(4)));


#define	ZW	64
//byte ZBuf[ZW*256];
byte *PageR[16], *PageW[16], *ROMMapR[256], *ROMMapW[256];
//BOOL IsROM[8];
byte *VRAM,*ROM,*vchange,*vchanges,*WRAM=0,/**DMYROM,*/*IOAREA,*IOAREA2;

short SPRAM[64*4] __attribute__((aligned(4)));

void * get_addr(unsigned page)
{
return &ROM[0x2000*page];
}

byte SPM[WIDTH*HEIGHT] __attribute__((aligned(4)));

static byte SPM_SAV[WIDTH*HEIGHT] __attribute__((aligned(4)));

void get_SPM()
{
int n,m,l;
if(io.screen_w<=384)
	{
	memset((void *) SPM,0,WIDTH*HEIGHT);
    l=(WIDTH-384)>>1;
	for(n=0;n<HEIGHT;n++)
		{
		for(m=0;m<384;m++)
			{
			SPM[WIDTH*n+m+l]=SPM_SAV[384*n+m];
			}
		}
	}
else memcpy((void *) SPM,(void *) SPM_SAV, WIDTH*HEIGHT);
}

void set_SPM()
{
int n,m,l;
if(io.screen_w<=384)
	{
	memset((void *) SPM_SAV,0,WIDTH*HEIGHT);
    l=(WIDTH-384)>>1;
	for(n=0;n<HEIGHT;n++)
		{
		for(m=0;m<384;m++)
			{
			SPM_SAV[384*n+m]=SPM[WIDTH*n+m+l];
			}
		}
	}
else memcpy((void *) SPM_SAV, (void *) SPM,WIDTH*HEIGHT);
}
unsigned long *VRAM2,*VRAMS;

int ROM_size;
extern int vmode;
int Country=0;
int IPeriod;
extern int BaseClock, UPeriod;
//static int TimerCount
extern unsigned CycleOld;
int TimerPeriod;
int scanlines_per_frame  = 263;
int scanline;
#define MinLine	io.minline
#define MaxLine io.maxline
//int MinLine = 0,MaxLine = 255;
#define MAXDISP	242 //242 //227
byte BGONSwitch = 1, SPONSwitch = 1;
char *cart_name;
byte cart_reload;
byte populus = 0;
int scroll = 0;

byte Pal[512] __attribute__((aligned(4)));

IO io;

int rom_need_decrypt=0;
int watch_dog=0;


void decrypt_rom()
{
int n;
unsigned char v,v2;

rom_need_decrypt=0;    

    for (n = 0; n < (ROM_size * 0x2000);n++)
	{
	v = ROM[n];
	v2=0;
	if(v & 128) v2|=1;
	if(v &  64) v2|=2;
	if(v &  32) v2|=4;
	if(v &  16) v2|=8;
	if(v &   8) v2|=16;
	if(v &   4) v2|=32;
	if(v &   2) v2|=64;
	if(v &   1) v2|=128;
	ROM[n]=v2; 
	}

}

#define mayuscula(v) (v & ~32)


void test_decrypt_rom()
{
int n=0;
int flag=0;

is_street_fighter=0;

for (n = 0; n < ((ROM_size * 0x2000))-8;n++)
	{
    if(ROM[n]=='S') 
	if(ROM[n+1]=='T')
	if(ROM[n+2]=='R')
	if(ROM[n+3]=='E') 
	if(ROM[n+4]>='E') 
	if(ROM[n+5]=='T')
	if(ROM[n+6]==' ')
	if(ROM[n+7]=='F')
	if(ROM[n+8]=='I') 
	if(ROM[n+9]>='G') 
	if(ROM[n+10]=='H') 
	if(ROM[n+11]>='T') 
	if(ROM[n+12]=='E') 
	if(ROM[n+13]>='R') 
	if(ROM[n+14]=='#') 
	{flag=1; is_street_fighter=1;break;}


	if(mayuscula(ROM[n])=='B')
	if(mayuscula(ROM[n+1])=='U')
	if(mayuscula(ROM[n+2])=='T')
	if(mayuscula(ROM[n+3])=='T')
	if(mayuscula(ROM[n+4])=='O')
	if(mayuscula(ROM[n+5])=='N') {flag=1; break;}

	if(ROM[n]==0x78)
	if(ROM[n+2]==0xa9)
	if(ROM[n+4]==0x53)
	if(ROM[n+6]==0xad)
	if(ROM[n+8]==0x10) {flag=1; break;}


	if(mayuscula(ROM[n])=='C')
	if(mayuscula(ROM[n+1])=='O')
	if(mayuscula(ROM[n+2])=='P')
	if(mayuscula(ROM[n+3])=='Y')
	if(mayuscula(ROM[n+4])=='R')
	if(mayuscula(ROM[n+5])=='I')
	if(mayuscula(ROM[n+6])=='G')
	if(mayuscula(ROM[n+7])=='H')
	if(mayuscula(ROM[n+8])=='T') {flag=1; break;}

	if(ROM[n]==96) // simbolo (c)
	if(ROM[n+1]=='1')
	if(ROM[n+2]=='9')
	if(ROM[n+3]=='8' || ROM[n+3]=='9') 
	if(ROM[n+4]>='0' || ROM[n+4]<='9') {flag=1; break;}
	}

if(flag==1) return;

decrypt_rom();


for (n = 0; n < ((ROM_size * 0x2000))-8;n++)
	{
	if(ROM[n]=='S') 
	if(ROM[n+1]=='T')
	if(ROM[n+2]=='R')
	if(ROM[n+3]=='E') 
	if(ROM[n+4]>='E') 
	if(ROM[n+5]=='T')
	if(ROM[n+6]==' ')
	if(ROM[n+7]=='F')
	if(ROM[n+8]=='I') 
	if(ROM[n+9]>='G') 
	if(ROM[n+10]=='H') 
	if(ROM[n+11]>='T') 
	if(ROM[n+12]=='E') 
	if(ROM[n+13]>='R') 
	if(ROM[n+14]=='#') 
	{flag=1; is_street_fighter=1;break;}


	if(mayuscula(ROM[n])=='B')
	if(mayuscula(ROM[n+1])=='U')
	if(mayuscula(ROM[n+2])=='T')
	if(mayuscula(ROM[n+3])=='T')
	if(mayuscula(ROM[n+4])=='O')
	if(mayuscula(ROM[n+5])=='N') {flag=1; break;}

	if(ROM[n]==0x78)
	if(ROM[n+2]==0xa9)
	if(ROM[n+4]==0x53)
	if(ROM[n+6]==0xad)
	if(ROM[n+8]==0x10) {flag=1; break;}

	if(mayuscula(ROM[n])=='C')
	if(mayuscula(ROM[n+1])=='O')
	if(mayuscula(ROM[n+2])=='P')
	if(mayuscula(ROM[n+3])=='Y')
	if(mayuscula(ROM[n+4])=='R')
	if(mayuscula(ROM[n+5])=='I')
	if(mayuscula(ROM[n+6])=='G')
	if(mayuscula(ROM[n+7])=='H')
	if(mayuscula(ROM[n+8])=='T') {flag=1; break;}

	if(ROM[n]==96) // simbolo (c)
	if(ROM[n+1]=='1')
	if(ROM[n+2]=='9')
	if(ROM[n+3]=='8' || ROM[n+3]=='9') 
	if(ROM[n+4]>='0' || ROM[n+4]<='9') {flag=1; break;}
	
	}

if(flag==1) return;

decrypt_rom(); // vuelvo a la posicion inicial pues no estoy seguro de si est encriptado (lo fio al watch_dog)

}
extern BOOL snd_bSound;

#define	VRR	2
enum _VDC_REG {
	MAWR,MARR,VWR,vdc3,vdc4,CR,RCR,BXR,
	BYR,MWR,HSR,HDR,VPR,VDW,VCR,DCR,
	SOUR,DISTR,LENR,SATB};


#define	NODATA	0xff
#define	ENABLE	1
#define	DISABLE	0

#define	VDC_CR	0x01
#define	VDC_OR	0x02
#define	VDC_RR	0x04
#define	VDC_DS	0x08
#define	VDC_DV	0x10
#define	VDC_VD	0x20
#define	VDC_BSY	0x40
#define	VDC_SpHit	VDC_CR
#define	VDC_Over	VDC_OR
#define	VDC_RasHit	VDC_RR
#define	VDC_InVBlank VDC_VD
#define	VDC_DMAfinish	VDC_DV
#define	VDC_SATBfinish	VDC_DS

#define	SpHitON		(io.VDC[CR].W&0x01)
#define	OverON		(io.VDC[CR].W&0x02)
#define	RasHitON	(io.VDC[CR].W&0x04)
#define	VBlankON	(io.VDC[CR].W&0x08)
#define	SpriteON	(io.VDC[CR].W&0x40)
#define	ScreenON	(io.VDC[CR].W&0x80)

#define SATBIntON	(io.VDC[DCR].W&0x01)
#define DMAIntON	(io.VDC[DCR].W&0x02)
#define SATBLOOP	(io.VDC[DCR].W&0x10)

#define	IRQ2	1
#define	IRQ1	2
#define	TIRQ	4

//#define ScrollX	io.scroll_x
//#define ScrollY io.scroll_y
#define	ScrollX	io.VDC[BXR].W
#define	ScrollY	io.VDC[BYR].W
int ScrollYDiff;
int	oldScrollX;
int	oldScrollY;
int	oldScrollYDiff;

typedef struct {
	short y,x,no,atr;
} SPR;


int CheckSprites(void);

int JoyStick(int sel);

void inline IO_write(word A,byte V);
byte inline IO_read(word A);
void RefreshLine(int Y1,int Y2);
void RefreshSprite(int Y1,int Y2,BYTE bg);
void RefreshScreen(void);

//byte mmr[256];

#define mmr M2->MPR

byte * ram_ptr=0;



void bank_set(byte P,byte V)
{

if(P==1) // control de pagina cero
	{
	if(V>=0xf8 && V<=0xfb)
		{
		ram_ptr=&RAM[0x2000*(V-0xf8)];
		}
	else ram_ptr=ROMMapR[V];
	}
//if((V>=0xF8 && V<=0xfb) && P<) 
	//mmr[P] = V;
	M2->MPR[P]=V;
	if (ROMMapR[V]==IOAREA)
	{
//	IOAREA2=IOAREA-P*0x2000;
	PageR[P]=IOAREA2;
	PageW[P]=IOAREA2;
	}
	else
	{
	//if(V>=0x40 && V<=0x4f) trap=(V<<8) | P;
	PageR[P]=ROMMapR[V]-P*0x2000;
	PageW[P]=ROMMapW[V]-P*0x2000;
	 
	}
//	IsROM[P] = (V < 0xF7);
}


/* write */
	


int force_update_sprite=0;


void IO_ACW(word A,byte V)
{
#ifdef SUPPORT_FOR_ARCADE_CARD
register unsigned V2=(unsigned ) V;

	if ((A & 0x1AE0) == 0x1AE0)
	  {
	    switch (A & 15)
	      {
	      case 0:
		io.ac_shift = (io.ac_shift & 0xffffff00) | V2;
		break;
	      case 1:
		io.ac_shift = (io.ac_shift & 0xffff00ff) | (V2 << 8);
		break;
	      case 2:
		io.ac_shift = (io.ac_shift & 0xff00ffff) | (V2 << 16);
		break;
	      case 3:
		io.ac_shift = (io.ac_shift & 0x00ffffff) | (V2 << 24);
		break;
	      case 4:

				io.ac_shiftbits = V & 0x0f;
				if (io.ac_shiftbits != 0)
				  {
					if (io.ac_shiftbits < 8)
					  {
					io.ac_shift <<= io.ac_shiftbits;
					  }
					else
					  {
					io.ac_shift >>= (16 - io.ac_shiftbits);
					  }
				  }
				break;
		  case 5:
			  io.ac_unknown4 = V; 
			  break;
	      }
	    return;
	  }
	else
	  {
	    UChar ac_port = (A >> 4) & 3;
	    switch (A & 15)
	      {
	      case 0:
	      case 1:

			  {
                 		 unsigned aci;

                 		 aci = io.ac_base[ac_port];
		                 if(io.ac_control[ac_port] & 2)
		                 {
		                  aci += io.ac_offset[ac_port];
		                  if(io.ac_control[ac_port] & 0x8)
		                   aci += 0xFF0000;
		                 }
		                 aci &= 0x1FFFFF;
		                 ac_extra_mem[aci] = V;
						// trap=aci;
				}

				if (io.ac_control[ac_port] & 1)
				{
					if (io.ac_control[ac_port] & 0x10)
						{
						io.ac_base[ac_port] +=io.ac_incr[ac_port];
						io.ac_base[ac_port] &=0xffffff;
						}
					else
						io.ac_offset[ac_port] += io.ac_incr[ac_port];
				}

		return;
	      case 2:
		io.ac_base[ac_port] = (io.ac_base[ac_port] & 0xffff00) | V2;
		return;
	      case 3:
		io.ac_base[ac_port] =
		  (io.ac_base[ac_port] & 0xff00ff) | (V2 << 8);
		return;
	      case 4:
		io.ac_base[ac_port] =
		  (io.ac_base[ac_port] & 0x00ffff) | (V2 << 16);
		return;
	      case 5:
		io.ac_offset[ac_port] = (io.ac_offset[ac_port] & 0xff00) | V2;
		return;
	      case 6:
				io.ac_offset[ac_port] = (io.ac_offset[ac_port] & ~0xff00) | (V2 << 8);

				if ((io.ac_control[ac_port] & 0x60) == 0x40)
				{
				io.ac_base[ac_port] += io.ac_offset[ac_port];

				if(io.ac_control[ac_port] & 0x08)
					io.ac_base[ac_port] += 0xFF0000;

				io.ac_base[ac_port] &= 0xffffff;
				}
                              
		return;
	      case 7:
		io.ac_incr[ac_port] = (io.ac_incr[ac_port] & 0xff00) | V2;
		return;
	      case 8:
		io.ac_incr[ac_port] =(io.ac_incr[ac_port] & 0x00ff) | (V2 << 8);
		return;
	      case 9:
		io.ac_control[ac_port] = V2  & 0x7f;
		return;
	      case 0xa:
		
				if ((io.ac_control[ac_port] & 0x60) == 0x60)
					{
					io.ac_base[ac_port] += io.ac_offset[ac_port];

					if(io.ac_control[ac_port] & 0x08)
					io.ac_base[ac_port] += 0xFF0000;

					io.ac_base[ac_port] &= 0xffffff;
					}
		return;
	      
	      }

	  }
      
#endif
}

void  inline IO_write(word A,byte V)
{
 A &= 0x1FFF;

 if ((A >= 0x800) && (A < 0x1800)) // We keep the io buffer value
    io.io_buffer = V;

if ((A & 0x1e00)==0x1a00) {IO_ACW(A,V);return;}

	//printf("w%04x,%02x ",A&0x3FFF,V);
  switch(A&0x1c00) {
  case 0x0000:	/* VDC */
	switch(A&3){
	case 0: io.vdc_reg = V&31; return;
	case 1: return;
	case 2:
		//printf("vdc_l%d,%02x ",io.vdc_reg,V);
		switch(io.vdc_reg){
		case VWR:
			/*VRAM[io.VDC[MAWR].W*2] = V;*/ io.vdc_ratch = V;
			//io.VDC_ratch[VWR] = V;
/*			if (0x1000 <= io.VDC[MAWR].W && io.VDC[MAWR].W < 0x1008)
			{
				TRACE("L: PC = %X, ", M.PC.W);
				for (int i = -10; i < 4; i++)
					TRACE("%02X ", Page[(M.PC.W+i)>>13][M.PC.W+i]);
				TRACE("\nL: V[%X] = %X\n", io.VDC[MAWR].W, V);
			}
*/			return;
		case HDR:
			io.screen_w = (V+1)<<3;
			//printf("screen:%dx%d %d\n",io.screen_w,256,V);
			//TRACE("HDRl: %X\n", V);
			break;
		case MWR:
			{static byte bgw[]={32,64,128,128};
			io.bg_h=(V&0x40)?64:32;
			io.bg_w=bgw[(V>>4)&3];}
			//TRACE("bg:%dx%d, V:%X\n",io.bg_w,io.bg_h, V);
			//TRACE("MWRl: %02X\n", V);
			break;
		case BYR:
			if (!scroll) {
				oldScrollX = ScrollX;
				oldScrollY = ScrollY;
				oldScrollYDiff = ScrollYDiff;
			}
			io.VDC[BYR].B.l = V;
			scroll=1;

			ScrollYDiff=scanline-1;

			return;
		case BXR:
			if (!scroll) {
				oldScrollX = ScrollX;
				oldScrollY = ScrollY;
				oldScrollYDiff = ScrollYDiff;
			}
			io.VDC[BXR].B.l = V;
			scroll=1;
			return;

	
			
		}
		io.VDC[io.vdc_reg].B.l = V; //io.VDC_ratch[io.vdc_reg] = V;
//		if (io.vdc_reg != CR)
//			TRACE("vdc_l: %02X,%02X\n", io.vdc_reg, V);
		if (io.vdc_reg>19) {
			//TRACE("ignore write lo vdc%d,%02x\n",io.vdc_reg,V);
		}
		return;
	case 3:
		//printf("vdc_h%d,%02x ",io.vdc_reg,V);
		switch(io.vdc_reg){
		case VWR:
			//printf("v%04x\n",io.VDC[MAWR].W);
			VRAM[io.VDC[MAWR].W<<1]=io.vdc_ratch;
			VRAM[(io.VDC[MAWR].W<<1)+1]=V;

			vchange[io.VDC[MAWR].W>>4]=1;
			vchanges[io.VDC[MAWR].W>>6]=1;
			io.VDC[MAWR].W+=io.vdc_inc;
			
			//io.vdc_ratch=0;// modificado
			return;
		case VDW:
			watch_dog=0; // si ajusta el video no creo que se haya colgado..
			//io.VDC[VDW].B.l = io.VDC_ratch[VDW];
			io.VDC[VDW].B.h = V;
			io.screen_h = (io.VDC[VDW].W&511)+1;
			MaxLine = io.screen_h-1;
			//TRACE("VDWh: %X\n", io.VDC[VDW].W);
			return;
		case LENR:
			watch_dog=0; // si programa dma's  no creo que se haya colgado..
		#if 0
			//io.VDC[LENR].B.l = io.VDC_ratch[LENR];
			io.VDC[LENR].B.h = V;
//			TRACE("DMA:%04x %04x %04x\n",io.VDC[DISTR].W,io.VDC[SOUR].W,io.VDC[LENR].W);
			/* VRAM to VRAM DMA */
			memcpy(VRAM+(io.VDC[DISTR].W<<1),VRAM+(io.VDC[SOUR].W<<1),
				(io.VDC[LENR].W+1)<<1);
			memset(vchange+(io.VDC[DISTR].W>>4),1,(io.VDC[LENR].W+1)>>4);
			memset(vchange+(io.VDC[DISTR].W>>6),1,(io.VDC[LENR].W+1)>>6);
			io.VDC[DISTR].W += io.VDC[LENR].W+1;
			io.VDC[SOUR].W += io.VDC[LENR].W+1;
			io.vdc_status|=VDC_DMAfinish;
			#else

			 io.VDC[LENR].B.h = V;

              { // black-- 's code

                int sourcecount = (io.VDC[DCR].W & 8) ? -1 : 1;
                int destcount = (io.VDC[DCR].W & 4) ? -1 : 1;

                int source = io.VDC[SOUR].W * 2;
                int dest = io.VDC[DISTR].W * 2;

                int i;

                for (i = 0; i < (io.VDC[LENR].W + 1) * 2; i++)
                  {
                    *(VRAM + dest) = *(VRAM + source);
                    dest += destcount;
                    source += sourcecount;
                  }

                /*
                  io.VDC[SOUR].W = source;
                  io.VDC[DISTR].W = dest;
                */
                // Erich Kitzmuller fix follows
                io.VDC[SOUR].W = source / 2;
                io.VDC[DISTR].W = dest / 2;

              }

              io.VDC[LENR].W = 0xFFFF;

              memset(vchange, 1, VRAMSIZE / 32);
              memset(vchanges,1, VRAMSIZE / 128);


              /* TODO: check whether this flag can be ignored */
              io.vdc_status |= VDC_DMAfinish;
			  #endif

			return;
		case CR :
			{static byte incsize[]={1,32,64,128};
			io.vdc_inc = incsize[(V>>3)&3];
			 io.VDC[CR].B.h = V;
			//TRACE("CRh: %02X\n", V);
			}
			break;
		case HDR:
			//io.screen_w = (io.VDC_ratch[HDR]+1)*8;
			//TRACE0("HDRh\n");
			break;
		case BYR:
			if (!scroll) {
				oldScrollX = ScrollX;
				oldScrollY = ScrollY;
				oldScrollYDiff = ScrollYDiff;
			}
			io.VDC[BYR].B.h = V&1;
			scroll=1;
//			io.vdc_iswrite_h = 1;
//			if (scanline <= MaxLine)
//			{
				//TRACE("BYRh = %d, scanline = %d, h = %d\n", io.VDC[BYR].W, scanline, io.screen_h);
			//if (RasHitON)
			{
				ScrollYDiff=scanline-1;
				//TRACE("BYRh = %d, scanline = %d, h = %d\n", io.VDC[BYR].W, scanline, io.screen_h);
				//DebugDumpFp(4, TRUE);
			}
//			}
//			else
//				ScrollYDiff=0;
			//ScrollY = 51-35;
			return;
		case SATB:
			io.VDC[SATB].B.h = V;
			//TRACE("SATB=%X,scanline=%d\n", io.VDC[SATB].W, scanline);
			//memcpy(SPRAM,VRAM+io.VDC[SATB].W*2,64*8);
			//memcpy_b16((void *) SPRAM, (void *) (VRAM+io.VDC[SATB].W*2),64*8);
			
			/*if(!(io.vdc_status & VDC_SATBfinish))
		    {
			//io.vdc_satb=2;
			memcpy_b16((void *) SPRAM, (void *) (VRAM+io.VDC[SATB].W*2),64*8);  
			}*/
			force_update_sprite=1;
			io.vdc_satb=1;
			io.vdc_status&=~VDC_SATBfinish;
			return;
		case BXR:
			if (io.VDC[BXR].B.h == (V & 3))
                return; // modificado
			if (!scroll) {
				oldScrollX = ScrollX;
				oldScrollY = ScrollY;
				oldScrollYDiff = ScrollYDiff;
			}
			io.VDC[BXR].B.h = V & 3;
			scroll=1;
//			ScrollX = io.VDC[BXR].W;
//			TRACE("BXRh = %d, scanline = %d\n", io.VDC[BXR].W, scanline);
//			io.VDC[BXR].W = 256;
			return;
			
#define PRINT_VDC_H(REG)	case REG: /*TRACE(#REG "h: %X\n",V);*/break;
/*			PRINT_VDC_H(HSR);
			//PRINT_VDC_H(HDR);
*/			PRINT_VDC_H(VPR);
			PRINT_VDC_H(VCR);
/*			PRINT_VDC_H(SOUR);
			PRINT_VDC_H(DISTR);
*/			PRINT_VDC_H(DCR);
		//case RCR: TRACE("RCR: %02X%02X\n", V, io.VDC[io.vdc_reg].B.l);break;

		}
		//io.VDC[io.vdc_reg].B.l = io.VDC_ratch[io.vdc_reg];
		io.VDC[io.vdc_reg].B.h = V;
//		if (io.vdc_reg != CR)
//			TRACE("vdc_h: %02X,%02X\n", io.vdc_reg, V);
		if (io.vdc_reg>19) {
//			TRACE("ignore write hi vdc%d,%02x\n",io.vdc_reg,V);
		}
		return;
	}
	break;

  case 0x0400:	/* VCE */
	switch(A&7) {
	case 0: /*io.vce_reg.W = 0; io.vce_ratch=0;*/ /*??*/
//		TRACE("VCE 0, V=%X\n", V); 
     return;
	case 2: io.vce_reg.B.l = V; return;
	case 3: io.vce_reg.B.h = V&1; return;
	case 4: io.VCE[io.vce_reg.W].B.l= V;
		{byte c; int i,n;
		n = io.vce_reg.W;
		c = io.VCE[n].W>>1;
		if (n==0) {
			for(i=0;i<256;i+=16) Pal[i]=c;
		}else if (n&15) Pal[n] = c;
		}
		return;
	case 5:
		/*io.VCE[io.vce_reg.W].B.l = io.vce_ratch;*/
//	DebugDumpFp(4, TRUE);
		io.VCE[io.vce_reg.W].B.h = V;
		{byte c; int i,n;
		n = io.vce_reg.W;
		c = io.VCE[n].W>>1;
		if (n==0) {
			for(i=0;i<256;i+=16) Pal[i]=c;
		}else if (n&15) Pal[n] = c;
		}
		io.vce_reg.W=(io.vce_reg.W+1)&0x1FF;
		return;
	//case 6: /* ?? */ return;
	case 1:	/*TRACE("VCE 1, V=%X\n", V);*/ return;
	case 6:	/*TRACE("VCE 6, V=%X\n", V);*/ return;
	case 7:	/*TRACE("VCE 7, V=%X\n", V);*/ return;
	}
	break;

  case 0x0800:	/* PSG */
	
	{
	int i;
	int update=0;
  	switch(A&15){
	case 0: V&=7;if(V>5) return; io.psg_ch = V;  return;
	case 1: io.psg_volume = V; update=1;break; // esto es  balance! V=(L<<4) | R
	case 2: io.PSG[io.psg_ch][2] = V; if(io.PSG[io.psg_ch][4] & 0x80) update=1; break; // frecuencia LSB
	case 3: io.PSG[io.psg_ch][3] = V&15;if(io.PSG[io.psg_ch][4] & 0x80) update=1; break; // frecuencia MSB
	case 4: io.PSG[io.psg_ch][4] = V;update=1; break; // canal, DDA, volume
	case 5: io.PSG[io.psg_ch][5] = V;if(io.PSG[io.psg_ch][4] & 0x80) update=1; break; // balance de canal
	case 6: if (io.PSG[io.psg_ch][4]&0x40){
				io.wave[io.psg_ch][0]=V&31;
			}else {
				io.wave[io.psg_ch][io.wavofs[io.psg_ch]]=V&31;
				io.wavofs[io.psg_ch]=(io.wavofs[io.psg_ch]+1)&31;
			}
			if(io.PSG[io.psg_ch][4] & 0x80) update=1; 
			break;
	case 7: io.PSG[io.psg_ch][7] = V;if(io.PSG[io.psg_ch][4] & 0x80) update=1;  break;
	case 8: io.psg_lfo_freq = V;update=1;  break;
	case 9: io.psg_lfo_ctrl = V;update=1;  break;
          
    }
	if(update)
		 for (i = 0; i < 6; i++)write_psg(i);
	}
    return;

  case 0x0c00:	/* timer */
	//TRACE("Timer Access: A=%X,V=%X\n", A, V);
	switch(A&1){
	case 0: io.timer_reload = V&127; return;
	case 1: 
		V&=1;
		if (V && !io.timer_start)
			io.timer_counter = io.timer_reload;
		io.timer_start = V;
		return;
	}
	break;

  case 0x1000:	/* joypad */
//	  TRACE("V=%02X\n", V);
		watch_dog=0; // si escribe el pad no creo que se haya colgado...
		/*io.joy_select = V&1;
		if (V&2) io.joy_counter = 0;*/
		if((V & 1) && !(io.joy_select & 2) && (V & 2))
		 {
		  io.joy_counter = 0;
		  io.joy_select&=~16;
		 }
		 else if((V & 1) && !(io.joy_select & 1))
		 {
		  if(io.joy_counter < 255)
		   io.joy_counter++; io.joy_select&=~16;
		 }
		 io.joy_select =(io.joy_select & 16) | (V & 3);
		return;

  case 0x1400:	/* IRQ */
	switch(A&15){
	case 2: io.irq_mask = V;/*TRACE("irq_mask = %02X\n", V);*/ return;
	case 3: io.irq_status= (io.irq_status&~TIRQ)|(V&0xF8); return;
	}
	break;
#ifdef SUPPORT_FOR_ARCADE_CARD5

 case 0x1A00:
      {

	if ((A & 0x1AE0) == 0x1AE0)
	  {
	    switch (A & 15)
	      {
	      case 0:
		io.ac_shift = (io.ac_shift & 0xffffff00) | V;
		break;
	      case 1:
		io.ac_shift = (io.ac_shift & 0xffff00ff) | (V << 8);
		break;
	      case 2:
		io.ac_shift = (io.ac_shift & 0xff00ffff) | (V << 16);
		break;
	      case 3:
		io.ac_shift = (io.ac_shift & 0x00ffffff) | (V << 24);
		break;
	      case 4:
		io.ac_shiftbits = V & 0x0f;
		if (io.ac_shiftbits != 0)
		  {
		    if (io.ac_shiftbits < 8)
		      {
			io.ac_shift <<= io.ac_shiftbits;
		      }
		    else
		      {
			io.ac_shift >>= (16 - io.ac_shiftbits);
		      }
		  }
		  case 5:
			  io.ac_unknown4 = V; 
			  break;
	      default:
		break;
	      }
	    return;
	  }
	else
	  {
	    UChar ac_port = (A >> 4) & 3;
	    switch (A & 15)
	      {
	      case 0:
	      case 1:

		if (io.ac_control[ac_port] & AC_USE_OFFSET)
		  {

		    // Log("Write %d to 0x%04X (base + offset)\n",V,
		    //           io.ac_offset[ac_port] + io.ac_base[ac_port]);
		    ac_extra_mem[((io.ac_base[ac_port] +
				   io.ac_offset[ac_port]) & 0x1fffff)] = V;
		  }
		else
		  {

		    // Log("Write %d to 0x%04X (base)\n",V, io.ac_base[ac_port]);
		    ac_extra_mem[((io.ac_base[ac_port]) & 0x1fffff)] = V;
		  }

		if (io.ac_control[ac_port] & AC_ENABLE_INC)
		  {
		    if (io.ac_control[ac_port] & AC_INCREMENT_BASE)
		      io.ac_base[ac_port] =
			(io.ac_base[ac_port] +
			 io.ac_incr[ac_port]) & 0xffffff;
		    else
		      io.ac_offset[ac_port] =
			(io.ac_offset[ac_port] +
			 io.ac_incr[ac_port]) & 0xffffff;
		  }

		return;
	      case 2:
		io.ac_base[ac_port] = (io.ac_base[ac_port] & 0xffff00) | V;
		return;
	      case 3:
		io.ac_base[ac_port] =
		  (io.ac_base[ac_port] & 0xff00ff) | (V << 8);
		return;
	      case 4:
		io.ac_base[ac_port] =
		  (io.ac_base[ac_port] & 0x00ffff) | (V << 16);
		return;
	      case 5:
		io.ac_offset[ac_port] = (io.ac_offset[ac_port] & 0xff00) | V;
		return;
	      case 6:
		io.ac_offset[ac_port] =
		  (io.ac_offset[ac_port] & 0x00ff) | (V << 8);
		if (io.ac_control[ac_port] & (AC_ENABLE_OFFSET_BASE_6))
		  io.ac_base[ac_port] =
		    (io.ac_base[ac_port] + io.ac_offset[ac_port]) & 0xffffff;
		return;
	      case 7:
		io.ac_incr[ac_port] = (io.ac_incr[ac_port] & 0xff00) | V;
		return;
	      case 8:
		io.ac_incr[ac_port] =
		  (io.ac_incr[ac_port] & 0x00ff) | (V << 8);
		return;
	      case 9:
		io.ac_control[ac_port] = V;
		return;
	      case 0xa:
		if ((io.ac_control[ac_port]
                    & (AC_ENABLE_OFFSET_BASE_A | AC_ENABLE_OFFSET_BASE_6))
                    == (AC_ENABLE_OFFSET_BASE_A | AC_ENABLE_OFFSET_BASE_6))
		  io.ac_base[ac_port] =
		    (io.ac_base[ac_port] + io.ac_offset[ac_port]) & 0xffffff;
		return;
	      
	      }

	  }
      }
      break;

#endif
  case 0x1800:	/* CD-ROM extention */
	
	if(CD_emulation==0)
	  {
	
	  switch(A&15){
	  case 7: io.backup = ENABLE; return;
 
    	}
	  }
	  else pce_cd_handle_write_1800(A, V);
	  break;

  }
	//TRACE("ignore I/O write %04x,%02x\n",A,V);
//	DebugDumpTrace(4, TRUE);
}

#if 1
int return_value_mask_tab_0002[32] =
  {
    0xFF,
    0xFF,
    0xFF,
    0xFF, /* unused */
    0xFF, /* unused */
    0xFF,
    0xFF,
    0xFF,
    0xFF, /* 8 */
    0xFF,
    0x1F, /* A */
    0x7F,
    0x1F, /* C */
    0xFF,
    0xFF, /* E */
    0x1F,
    0xFF, /* 10 */
    0xFF,
    /* No data for remaining reg, assuming 0xFF */
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF
  };

int return_value_mask_tab_0003[32] =
  {
    0xFF,
    0xFF,
    0xFF,
    0xFF, /* unused */
    0xFF, /* unused */
    0x1F,
    0x03,
    0x03,
    0x01, /* 8 */	/* ?? */
    0x00,
    0x7F, /* A */
    0x7F,
    0xFF, /* C */
    0x01,
    0x00, /* E */
    0x00,
    0xFF, /* 10 */
    0xFF,
    /* No data for remaining reg, assuming 0xFF */
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF
  };


int return_value_mask_tab_0400[8] =
  {
    0xFF,
    0x00,
    0xFF,
    0x01,
    0xFF,
    0x01,
    0xFF, /* unused */
    0xFF  /* unused */
  };

int return_value_mask_tab_0800[16] =
  {
    0x03,
    0xFF,
    0xFF,
    0x0F,
    0xDF,
    0xFF,
    0x1F,
    0x9F,
    0xFF,
    0x83,
    /* No data for remainig reg, assuming 0xFF */
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF
  };

int return_value_mask_tab_0c00[2] =
  {
    0x7F,
    0x01
  };

int return_value_mask_tab_1400[4] =
  {
    0xFF,
    0xFF,
    0x03,
    0x03
  };



//! Returns the useful value mask depending on port value
static int
return_value_mask(UInt16 A)
{
  if (A < 0x400) // VDC
    {
      if ((A & 0x3) == 0x02)
        {
          return return_value_mask_tab_0002[io.vdc_reg];
        }
      else
        if ((A & 0x3) == 0x03)
          {
            return return_value_mask_tab_0003[io.vdc_reg];
          }
        else
          return 0xFF;
    }

  if (A < 0x800) // VCE
    return return_value_mask_tab_0400[A & 0x07];

  if (A < 0xC00) /* PSG */
    return return_value_mask_tab_0800[A & 0x0F];

  if (A < 0x1000) /* Timer */
    return return_value_mask_tab_0c00[A & 0x01];

  if (A < 0x1400) /* Joystick / IO port */
    return 0xFF;

  if (A < 0x1800) /* Interruption acknowledgement */
    return return_value_mask_tab_1400[A & 0x03];

  /* We don't know for higher ports */
  return 0xFF;
}

#endif

byte inline IO_read_raw(word A)
{
	byte ret;

	//printf("r%04x ",A&0x3FFF);
//  switch(A&0x1FC0){
  switch(A&0x1C00){
  case 0x0000: /* VDC */
  	switch(A&3){
	case 0:
		ret = io.vdc_status;
		io.vdc_status=0;//&=VDC_InVBlank;//&=~VDC_BSY;
		return ret;
	case 1:
		return 0;
	case 2:
		if (io.vdc_reg==VRR)
			return VRAM[io.VDC[MARR].W*2];
		else return io.VDC[io.vdc_reg].B.l;
	case 3:
		if (io.vdc_reg==VRR) {
			ret = VRAM[io.VDC[MARR].W*2+1];
			io.VDC[MARR].W+=io.vdc_inc;
//			TRACE0("VRAM read\n");
			return ret;
		} else return io.VDC[io.vdc_reg].B.h;
	}
	break;

  case 0x0400:/* VCE */
  	switch(A&7){
	case 4: return io.VCE[io.vce_reg.W].B.l;
	case 5: return io.VCE[io.vce_reg.W++].B.h;
	}
	break;

  case 0x0800:	/* PSG */
	switch(A&15){
	case 0: return io.psg_ch;
	case 1: return io.psg_volume;
	case 2: return io.PSG[io.psg_ch][2];
	case 3: return io.PSG[io.psg_ch][3];
	case 4: return io.PSG[io.psg_ch][4];
	case 5: return io.PSG[io.psg_ch][5];
	case 6:
		{
			int	ofs=io.wavofs[io.psg_ch];
			io.wavofs[io.psg_ch]=(io.wavofs[io.psg_ch]+1)&31;
			return io.wave[io.psg_ch][ofs];
		}
	case 7: return io.PSG[io.psg_ch][7];
	case 8: return io.psg_lfo_freq;
	case 9: return io.psg_lfo_ctrl;
	default: return NODATA;
	}
	break;

  case 0x0c00:	/* timer */
	return io.timer_counter;

  case 0x1000:	/* joypad */
	  watch_dog=0; // si lee el pad no creo que se haya colgado..
//	  TRACE("js=%d\n", io.joy_counter);
		ret = io.JOY[io.joy_counter]^0xff;
		/*switch(io.joy_select & 0x11)
	    {
		case 0:ret = (io.JOY[io.joy_counter] & 14)^0xff;break;
		case 1:ret=io.JOY[io.joy_counter]^0xff;break;
		case 0x10:ret = io.JOY[io.joy_counter]^0xff;break;
		case 0x11:ret = ((io.JOY[io.joy_counter] & 1))^0xff;break;
		}*/
		if (io.joy_select&1) ret>>=4;
		else { ret&=15;io.joy_select^=16;/* io.joy_counter=(io.joy_counter+1)%5;*/ }
		
		return ret | (Country << 6) | (CD_emulation ? 0x30 : 0xB0); 
		//return ret|Country; /* country 0:JPN 1=US */

  case 0x1400:	/* IRQ */
	switch(A&15){
	case 2: return io.irq_mask;
	case 3: ret = io.irq_status;io.irq_status=0;return ret;
	}
	break;
/*case 0x18C0:		// Memory management ?
		switch (A & 15)
			{
				case 5:
				case 1:
					return 0xAA;
				case 2:
				case 6:
					return 0x55;
				case 3:
				case 7:
					return 0x03;
			}
		break;*/

#ifdef SUPPORT_FOR_ARCADE_CARD7

case 0x1AC0:
	//if ((A & 0x1AE0) == 0x1AE0)
	    {
		switch (A & 15)
		{
		case 0:
			return (byte) (io.ac_shift);
		case 1:
			return (byte) (io.ac_shift >> 8);
		case 2:
			return (byte) (io.ac_shift >> 16);
		case 3:
			return (byte) (io.ac_shift >> 24);
		case 4:
			return io.ac_shiftbits;
		case 5:
			return io.ac_unknown4;
		case 14:
			return (byte)(want_arcade_card_emulation ? 0x10 : NODATA);
		case 15:
			return (byte)(want_arcade_card_emulation ? 0x51 : NODATA);
//		default:
			//Log ("Unknown Arcade card port access : 0x%04X\n", A);
		}
		}
		break;

	case 0x1A00:
	{
		byte ac_port = (byte)((A >> 4) & 3);
		
		switch (A & 15)
		{
		case 0:
		case 1:
			/*
			 * switch (io.ac_control[ac_port] & (AC_USE_OFFSET | AC_USE_BASE))
			 * {
			 * case 0:
			 * return ac_extra_mem[0];
			 * case AC_USE_OFFSET:
			 * ret = ac_extra_mem[io.ac_offset[ac_port]];
			 * if (!(io.ac_control[ac_port] & AC_INCREMENT_BASE))
			 * io.ac_offset[ac_port]+=io.ac_incr[ac_port];
			 * return ret;
			 * case AC_USE_BASE:
			 * ret = ac_extra_mem[io.ac_base[ac_port]];
			 * if (io.ac_control[ac_port] & AC_INCREMENT_BASE)
			 * io.ac_base[ac_port]+=io.ac_incr[ac_port];
			 * return ret;
			 * default:
			 * ret = ac_extra_mem[io.ac_base[ac_port] + io.ac_offset[ac_port]];
			 * if (io.ac_control[ac_port] & AC_INCREMENT_BASE)
			 * io.ac_base[ac_port]+=io.ac_incr[ac_port];
			 * else
			 * io.ac_offset[ac_port]+=io.ac_incr[ac_port];
			 * return ret;
			 * }
			 * return 0;
			 */


			if (io.ac_control[ac_port] & AC_USE_OFFSET)
				ret = ac_extra_mem[((io.ac_base[ac_port] +
						     io.
						     ac_offset[ac_port]) &
						    0x1fffff)];
			else
				ret = ac_extra_mem[((io.
						     ac_base[ac_port]) &
						    0x1fffff)];

			if (io.ac_control[ac_port] & AC_ENABLE_INC)
			{
				if (io.
				    ac_control[ac_port] & AC_INCREMENT_BASE)
					io.ac_base[ac_port] =
						(io.ac_base[ac_port] +
						 io.
						 ac_incr[ac_port]) & 0xffffff;
				else
					io.ac_offset[ac_port] = (UInt16)
						((io.ac_offset[ac_port] +
						 io.
						 ac_incr[ac_port]) & 0xffff);
			}


			return ret;
		


		case 2:
			return (byte) (io.ac_base[ac_port]);
		case 3:
			return (byte) (io.ac_base[ac_port] >> 8);
		case 4:
			return (byte) (io.ac_base[ac_port] >> 16);
		case 5:
			return (byte) (io.ac_offset[ac_port]);
		case 6:
			return (byte) (io.ac_offset[ac_port] >> 8);
		case 7:
			return (byte) (io.ac_incr[ac_port]);
		case 8:
			return (byte) (io.ac_incr[ac_port] >> 8);
		case 9:
			return io.ac_control[ac_port];
		//default:
			//Log ("Unknown Arcade card port access : 0x%04X\n", A);
		}
		break;
		
	}

#endif
  case 0x1800:	/* CD-ROM extention */
  if((A & 0x18C0)==0x18C0)		// Memory management ?
	   {
		switch (A & 15)
			{
				case 1:
				case 5:
					return 0xAA;
				case 2:
				case 6:
					return 0x55;
				case 3:
					return 0;
				case 7:
					return 0x03;
			}
	   return 0;//NODATA;
	   }
	if(CD_emulation==0)
	  {
	  switch(A&15)
		  {
		  case 3: return io.backup = DISABLE;
	      }
    	break;
	  } else 
	 return pce_cd_handle_read_1800(A);
  }
	//TRACE("ignore I/O read %04x\n",A);
//	DebugDumpFp(4, TRUE);
	return NODATA;
}



byte inline IO_ACR(word A)
{
byte ret=0;

#ifdef SUPPORT_FOR_ARCADE_CARD
unsigned ac_port = ((A >> 4) & 3);

if ((A & 0x1AE0) == 0x1AE0)
	    {
		switch (A & 15)
		{
		case 0:
			return (byte) (io.ac_shift);
		case 1:
			return (byte) (io.ac_shift >> 8);
		case 2:
			return (byte) (io.ac_shift >> 16);
		case 3:
			return (byte) (io.ac_shift >> 24);
		case 4:
			return io.ac_shiftbits;
		case 5:
			return io.ac_unknown4;
		case 14:
			return (byte)(want_arcade_card_emulation ? 0x10 : NODATA);
		case 15:
			return (byte)(want_arcade_card_emulation ? 0x51 : NODATA);
//		default:
			//Log ("Unknown Arcade card port access : 0x%04X\n", A);
		}
		return 0xff;
		}
	

	{
		
		unsigned aci;

		switch (A & 15)
		{
		case 0:
		case 1:
			
             

                 aci = io.ac_base[ac_port];
                 if(io.ac_control[ac_port] & 2)
                 {
                  aci += io.ac_offset[ac_port];
                  if(io.ac_control[ac_port] & 0x8)
                   aci += 0xFF0000;
                 }
                 aci &= 0x1FFFFF;
             ret =  ac_extra_mem[aci];

			if (io.ac_control[ac_port] & 1)
			{
				if (io.ac_control[ac_port] & 0x10)
					{
					io.ac_base[ac_port] +=io.ac_incr[ac_port];
					io.ac_base[ac_port] &=0xffffff;
					}
				else
					io.ac_offset[ac_port] += io.ac_incr[ac_port];
			}


			return ret;
		


		case 2:
			return (byte) (io.ac_base[ac_port]);
		case 3:
			return (byte) (io.ac_base[ac_port] >> 8);
		case 4:
			return (byte) (io.ac_base[ac_port] >> 16);
		case 5:
			return (byte) (io.ac_offset[ac_port]);
		case 6:
			return (byte) (io.ac_offset[ac_port] >> 8);
		case 7:
			return (byte) (io.ac_incr[ac_port]);
		case 8:
			return (byte) (io.ac_incr[ac_port] >> 8);
		case 9:
			return io.ac_control[ac_port];
		case 0xa: return 0;
		//default:
			//Log ("Unknown Arcade card port access : 0x%04X\n", A);
		}
	return 255;
		
	}
#endif

return ret;
}


byte inline IO_read(word A)
{
  int mask;
 byte temporary_return_value;

 A &= 0x1FFF;

 if ((A & 0x1e00)==0x1a00) {return IO_ACR(A);}

  if ((A < 0x800) || (A >= 0x1800)) // latch isn't affected out of the 0x800 - 0x1800 range
    return IO_read_raw(A);
 

  mask = return_value_mask(A);

  temporary_return_value = IO_read_raw(A);

  io.io_buffer = temporary_return_value | (io.io_buffer & ~mask);

  return io.io_buffer;
}



byte inline IO_ACR(word A);
void IO_ACW(word A,byte V);

byte RdDefault(register word A)
{
register word B=A>>13;
#ifdef SUPPORT_FOR_ARCADE_CARD
if(want_arcade_card_emulation)
{
if ((M2->MPR[B] >= 0x40)  && (M2->MPR[B] <= 0x4f))
			{
        
	       return IO_read((word)(0x1A00 + (((M2->MPR[B] - 0x40) & 0x3) << 4)));
				
			//return /*IO_read*/IO_ACR((word)(0x1A00 | ((A >> 9) & 0x30)));
				
			}
}
#endif
if (PageR[B]==IOAREA2) return IO_read(A) ;
return PageR[B][A];

}

void WrDefault(register word A,register byte V)
{register word B=A>>13;
#ifdef SUPPORT_FOR_ARCADE_CARD
if(want_arcade_card_emulation)
{
if ((M2->MPR[B] >= 0x40)  && (M2->MPR[B] <= 0x4f))
			{//trap=0x888;
				IO_write((word)(0x1A00 + (((M2->MPR[B] - 0x40) & 0x3) << 4)), V);
				//IO_ACW((word)(0x1A00  | ((A >> 9) & 0x30)), V);
				return;
			}
	
}
#endif
if (PageW[B]==IOAREA2) {IO_write(A,V);return;}
	

PageW[B][A]=V;

}



void WrSf2(word A,byte V)
{
register word B=A>>13;
			/* support for SF2CE silliness */
			if ((A & 0x1ffc) == 0x1ff0)
				{
					register int i;
					register byte *R;
                   
				    sf2_latch=(A & 3);
					R=ROMMapR[0x40] = ROMMapR[0] + 0x80000+ sf2_latch* 0x80000;
					

					for (i = 0x41; i <= 0x7f; i++)
						{
						R+=0x2000;
					    ROMMapR[i] =R;
						}
				}
				else
				if (PageW[B] == IOAREA2)
				  IO_write (A, V);
				else
				  PageW[B][A] = V;
	}


byte (*_Rd6502)(word A)=RdDefault;
void (*_Wr6502)(word A, byte V)=WrDefault;



byte Loop6502(M6502 *R)
{
	static int UCount = 0;
	//static int ACount = 0;
	static int prevline;
	int dispmin, dispmax;
	int ret;
	//printf("PC:%04x ",R->PC.W);
 //io.vdc_status &= ~(VDC_RasHit | VDC_SATBfinish);//memcpy_b16((void *) SPRAM, (void *) (VRAM+io.VDC[SATB].W*2),64*8);
 debug_str="Loop6502()";
/*if (io.vdc_satb==1 || (io.VDC[DCR].W&0x0010))
		{
			memcpy_b16((void *) SPRAM, (void *) (VRAM+io.VDC[SATB].W*2),64*8);
			io.vdc_satb=0;
			io.vdc_status&=~VDC_SATBfinish;
		}*/
	dispmin = (MaxLine-MinLine>MAXDISP ? MinLine+((MaxLine-MinLine-MAXDISP+1)>>1) : MinLine);
	dispmax = (MaxLine-MinLine>MAXDISP ? MaxLine-((MaxLine-MinLine-MAXDISP+1)>>1) : MaxLine);

	scanline=(scanline+1)%scanlines_per_frame;	//printf("scan %d\n",scanline);
	ret = INT_NONE;
	io.vdc_status&=~VDC_RasHit;
	if (scanline>MaxLine)
		io.vdc_status|=VDC_InVBlank;
//	if (scanline==MinLine+scanlines_per_frame-1)
//	else 
	if (scanline==MinLine) {
		io.vdc_status&=~VDC_InVBlank;
		prevline=dispmin;
		ScrollYDiff = 0;
		oldScrollYDiff = 0;
//		if (io.vdc_iswrite_h)
//		{
//			io.vdc_iswrite_h = 0;
//			ScrollY = io.VDC[BYR].W;
//		}
//		TRACE("\nFirstLine\n");
	}else
	if (scanline==MaxLine) {
		if (CheckSprites()) io.vdc_status|=VDC_SpHit;
		else io.vdc_status&=~VDC_SpHit;
		if (UCount) UCount--;
		else {
			
			if (SpriteON && SPONSwitch) RefreshSprite(prevline,dispmax,0);
			RefreshLine(prevline,dispmax-1);
			if (SpriteON && SPONSwitch) RefreshSprite(prevline,dispmax,1);
			
			prevline=dispmax;
			UCount=UPeriod;
			RefreshScreen();
		}
	}
	if (scanline>=MinLine && scanline<=MaxLine) {
		if (scanline==(io.VDC[RCR].W&1023)-64) {
			if (RasHitON && !UCount && dispmin<=scanline && scanline<=dispmax) {
				
				if (SpriteON && SPONSwitch) RefreshSprite(prevline,scanline,0);
				RefreshLine(prevline,scanline-1);
				if (SpriteON && SPONSwitch) RefreshSprite(prevline,scanline,1);
				
				prevline=scanline;
			}
			io.vdc_status|=VDC_RasHit;
			if (RasHitON) {
				//TRACE("rcr=%d\n", scanline);
				ret = INT_IRQ;
			}
		} else if (scroll) {
			if (scanline-1>prevline && !UCount) {
				int	tmpScrollX, tmpScrollY, tmpScrollYDiff;
				tmpScrollX=ScrollX;
				tmpScrollY=ScrollY;
				tmpScrollYDiff=ScrollYDiff;
				ScrollX=oldScrollX;
				ScrollY=oldScrollY;
				ScrollYDiff=oldScrollYDiff;
				
				if (SpriteON && SPONSwitch) RefreshSprite(prevline,scanline-1,0);
				RefreshLine(prevline,scanline-2);
				if (SpriteON && SPONSwitch) RefreshSprite(prevline,scanline-1,1);
				
				prevline=scanline-1;
				ScrollX = tmpScrollX;
				ScrollY = tmpScrollY;
				ScrollYDiff = tmpScrollYDiff;
			}
		}
	} else {
		int rcr = (io.VDC[RCR].W&1023)-64;
		if (scanline==rcr)
		{
//			ScrollYDiff = scanline;
			if (RasHitON) {
				//TRACE("rcr=%d\n", scanline);
				io.vdc_status |= VDC_RasHit;
				ret = INT_IRQ;
			}
		}
	}
	scroll=0;
	if (scanline==MaxLine+1) {
//	if (scanline==scanlines_per_frame-63) {
		int J=JoyStick(0);
		if (J&0x10000) { debug_str="Undef"; return INT_QUIT;}
		io.JOY[0]=J;
		J=JoyStick(1);
		if (J&0x10000) {debug_str="Undef"; return INT_QUIT;}
		io.JOY[1]=J;
		J=JoyStick(2);
		if (J&0x10000) {debug_str="Undef"; return INT_QUIT;}
		io.JOY[2]=J;
		J=JoyStick(3);
		if (J&0x10000) {debug_str="Undef"; return INT_QUIT;}
		io.JOY[3]=J;
        debug_str="Loop6502()";	
		/* VRAM to SATB DMA */
		if (force_update_sprite || io.vdc_satb==1 || (io.VDC[DCR].W&0x0010))
		{
			memcpy_b16((void *) SPRAM, (void *) (VRAM+io.VDC[SATB].W*2),64*8);
			force_update_sprite=0;
			if(io.vdc_satb==1 || (io.VDC[DCR].W&0x0010))
			{
			io.vdc_satb=1;
			io.vdc_status&=~VDC_SATBfinish;
			}
		}
		if (ret==INT_IRQ)
			io.vdc_pendvsync = 1;
		else {
			//TRACE("vsync\n");
			//io.vdc_status|=VDC_InVBlank;
			if (VBlankON) {
				//TRACE("vsync=%d\n", scanline);
				ret = INT_IRQ;
			}
		}
	}
	else 
	if (scanline==min(MaxLine+5, scanlines_per_frame-1)) {

		
		if (io.vdc_satb) {
			io.vdc_status|=VDC_SATBfinish;
			io.vdc_satb = 0;
			if (SATBIntON) {
				//TRACE("SATB=%d\n", scanline);
				ret = INT_IRQ;
			}
          
		  
		
/*		} else {
			io.vdc_status&=~VDC_SATBfinish;
			io.vdc_satb = 0;
*/		}
	} else if (io.vdc_pendvsync && ret!=INT_IRQ) {
		io.vdc_pendvsync = 0;
		//io.vdc_status|=VDC_InVBlank;
		if (VBlankON) {
			//TRACE("vsync=%d\n", scanline);
			ret = INT_IRQ;
		}
	}
	if (ret == INT_IRQ) {
		if (!(io.irq_mask&IRQ1)) {
			io.irq_status|=IRQ1;
			//if (io.vdc_status&0x20)
			//TRACE("status=%02X\n", io.vdc_status);
			//TRACE("irq:scan %d\n ",scanline);
			debug_str="Undef";
			return ret;
		}
	}

	return INT_NONE;
}


byte TimerInt(M6502 *R)
{


	if (io.timer_start) {
		io.timer_counter--;
		if (io.timer_counter > 128) {
			io.timer_counter = io.timer_reload;
			//io.irq_status &= ~TIRQ;
			if (!(io.irq_mask&TIRQ)) {
				io.irq_status |= TIRQ;

				return INT_TIMER;
			}
		}
	}
	return INT_NONE;
}




/*
	Hit Chesk Sprite#0 and others
*/
int CheckSprites(void)
	{
	int i,x0,y0,w0,h0,x,y,w,h;
	SPR *spr;
	spr = (SPR*) (void *) SPRAM;
	x0 = (int) spr->x;
	y0 = (int) spr->y;
	w0 = (((spr->atr>>8 )&1)+1)*16;
	h0 = (((spr->atr>>12)&3)+1)*16;
	spr++;
	for(i=1;i<64;i++,spr++) {
		x = spr->x;
		y = spr->y;
		w = (((spr->atr>>8 )&1)+1)<<4;
		h = (((spr->atr>>12)&3)+1)<<4;
		if ((x<x0+w0)&&(x+w>x0)&&(y<y0+h0)&&(y+h>y0)) return TRUE;
	}
	return FALSE;
	}

unsigned pre_tabl1[256];
unsigned pre_tabl2[256];
unsigned pre_tabl3[256];
unsigned pre_tabl4[256];

static inline void plane2pixel(int no)
{
	register unsigned long M;
	byte *C=VRAM+(no<<5);
	unsigned long L,*C2 = VRAM2+no*8;
	int j;
	
	
  for(j=0;j<8;j++,C+=2,C2++) {
    /*M=C[0];
    L =((M&0x88)>>3)|((M&0x44)<<6)|((M&0x22)<<15)|((M&0x11)<<24);
	M=C[1];
	L|=((M&0x88)>>2)|((M&0x44)<<7)|((M&0x22)<<16)|((M&0x11)<<25);
	M=C[16];
	L|=((M&0x88)>>1)|((M&0x44)<<8)|((M&0x22)<<17)|((M&0x11)<<26);
	M=C[17];
	L|=((M&0x88))|((M&0x44)<<9)|((M&0x22)<<18)|((M&0x11)<<27);
	C2[0] = L; //37261504
	*/
	M=C[0];
    L =pre_tabl1[M];
	M=C[1];
	L|=pre_tabl2[M];
	M=C[16];
	L|=pre_tabl3[M];
	M=C[17];
	L|=pre_tabl4[M];
	C2[0] =L; //37261504
  }

}


static inline void sp2pixel(int no)
{
	register /*byte*/ unsigned  M;

	byte *C;
	unsigned long *C2;
	C=&VRAM[no<<7];
	C2=&VRAMS[no<<5];
	int i;
	
	for(i=0;i<32;i++,C++,C2++){
		register unsigned long L;
		/*M=C[0];
		L =((M&0x88)>>3)|((M&0x44)<<6)|((M&0x22)<<15)|((M&0x11)<<24);
		M=C[32];
		L|=((M&0x88)>>2)|((M&0x44)<<7)|((M&0x22)<<16)|((M&0x11)<<25);
		M=C[64];
		L|=((M&0x88)>>1)|((M&0x44)<<8)|((M&0x22)<<17)|((M&0x11)<<26);
		M=C[96];
		L|=((M&0x88))|((M&0x44)<<9)|((M&0x22)<<18)|((M&0x11)<<27);
		C2[0]=L;
		*/
		M=C[0];
		L =pre_tabl1[M];
		M=C[32];
		L|=pre_tabl2[M];
		M=C[64];
		L|=pre_tabl3[M];
		M=C[96];
		L|=pre_tabl4[M];
		C2[0] = L;
	}
}

#define	PAL(c)	R[c]
//#define	SPal	(Pal+256)
extern byte *XBuf;
byte Black = 0;
#define	FC_W	io.screen_w
#define	FC_H	256

void RefreshLine(int Y1,int Y2)
{
	int X1,XW,Line;
	int x,y,h,offset,Shift;
	unsigned long L,L2;
	unsigned char *R1= (unsigned char *) &L;
	unsigned char *R2= (unsigned char *) &L2;
    int yincre;
	byte *PP;//,*ZP;
	unsigned char LPal[256];
	int n;

	for(n=0;n<256;n++)
	{
	LPal[n]=Pal[n];
	}
	//TRACE("%d-%d,Scroll=%d\n",Y1,Y2,ScrollY-ScrollYDiff);
	Y2++;
	PP= (byte *) (XBuf+/*WIDTH*(HEIGHT-FC_H)/2+*/(WIDTH-FC_W)/2+WIDTH*Y1);
//	if(!ScreenON || !BGONSwitch) memset(XBuf+Y1*WIDTH,Black,(Y2-Y1)*WIDTH);
//	else {
	if(ScreenON && BGONSwitch) {
		//TRACE("ScrollY=%d,diff=%d\n", ScrollY, ScrollYDiff);
		//TRACE("ScrollX=%d\n", ScrollX);
	y = Y1+ScrollY-ScrollYDiff;
	offset = y&7;
	h = 8-offset;
	if (h>Y2-Y1) h=Y2-Y1;
	y>>=3;
	PP-=ScrollX&7;
	XW=io.screen_w/8+1;
	Shift = ScrollX&7;
//	{byte *Z=ZBuf+Y1*ZW;
//	for(Line=Y1;Line<Y2;Line++,Z+=ZW) Z[0]=0;
//	}

  for(Line=Y1;Line<Y2;y++) {
//    ZP = ZBuf+Line*ZW;
	x = ScrollX/8;
	y &= io.bg_h-1;yincre=y*io.bg_w;
	for(X1=0;X1<XW;X1++,x++,PP+=8){
		register byte *R,*P,*C;//,*Z;
		register unsigned long *C2;
		int no,i;
		x&=io.bg_w-1;
		no = SWAP16((((word*)VRAM)[x+yincre]));
		R = &LPal[(no>>12)<<4];
		no&=0xFFF;
		if (vchange[no]) { vchange[no]=0; plane2pixel(no);}
		C2 = &VRAM2[(no<<3)+offset];
		C = &VRAM[(no<<5)+offset+offset];
		P = PP;
//		Z = ZP;
		for(i=0;i<h;i++,P+=WIDTH,C2++,C+=2/*,Z+=ZW*/) {
			
			BYTE	J;

			J = ((C[0]|C[1]|C[16]|C[17]));
			if (!J) continue;

	/*		L=C2[0];
			if (J&0x80) P[0]=PAL((L>>4)&15);
			if (J&0x40) P[1]=PAL((L>>12)&15);
			if (J&0x20) P[2]=PAL((L>>20)&15);
			if (J&0x10) P[3]=PAL((L>>28));
			if (J&0x08) P[4]=PAL((L)&15);
			if (J&0x04) P[5]=PAL((L>>8)&15);
			if (J&0x02) P[6]=PAL((L>>16)&15);
			if (J&0x01) P[7]=PAL((L>>24)&15);
	*/
			L =L2= C2[0];
			L=(L>>4) & 0x0f0f0f0f;
			L2=L2 & 0x0f0f0f0f;
			if (J&0x80) P[0]=PAL(R1[0]);
			if (J&0x40) P[1]=PAL(R1[1]);
			if (J&0x20) P[2]=PAL(R1[2]);
			if (J&0x10) P[3]=PAL(R1[3]);
			if (J&0x08) P[4]=PAL(R2[0]);
			if (J&0x04) P[5]=PAL(R2[1]);
			if (J&0x02) P[6]=PAL(R2[2]);
			if (J&0x01) P[7]=PAL(R2[3]);
//			L = J<<Shift;
//			Z[0]|=L>>8;Z[1]=L;
		}
	}
	Line+=h;
	PP+=WIDTH*h-(XW<<3);
	offset = 0;
	h = Y2-Line;
	if (h>8) h=8;
  }
  	}
	/* Refresh Sprite */
//	if (SpriteON) RefreshSprite(Y1,Y2);
}

#define	V_FLIP	0x8000
#define	H_FLIP	0x0800
#define	SPBG	0x80
#define	CGX		0x100

static void inline PutSprite(byte *P,byte *C,unsigned long *C2,byte *R,int h,int inc)
{
	int i,J;
	unsigned long L,L2;
	unsigned char *R1= (unsigned char *) &L;
	unsigned char *R2= (unsigned char *) &L2;

//return;

	for(i=0;i<h;i++,C+=inc,C2+=inc,P+=WIDTH) {
		J = ((word*)C)[0]|((word*)C)[16]|((word*)C)[32]|((word*)C)[48];
		if (!J) continue;
		J=SWAP16(J);
	/*
		L = C2[1];//sp2pixel(C+1);
		if (J&0x8000) P[0]=PAL((L>>4)&15);
		if (J&0x4000) P[1]=PAL((L>>12)&15);
		if (J&0x2000) P[2]=PAL((L>>20)&15);
		if (J&0x1000) P[3]=PAL((L>>28));
		if (J&0x0800) P[4]=PAL((L)&15);
		if (J&0x0400) P[5]=PAL((L>>8)&15);
		if (J&0x0200) P[6]=PAL((L>>16)&15);
		if (J&0x0100) P[7]=PAL((L>>24)&15);
		L = C2[0];//sp2pixel(C);
		if (J&0x80) P[8 ]=PAL((L>>4)&15);
		if (J&0x40) P[9 ]=PAL((L>>12)&15);
		if (J&0x20) P[10]=PAL((L>>20)&15);
		if (J&0x10) P[11]=PAL((L>>28));
		if (J&0x08) P[12]=PAL((L)&15);
		if (J&0x04) P[13]=PAL((L>>8)&15);
		if (J&0x02) P[14]=PAL((L>>16)&15);
		if (J&0x01) P[15]=PAL((L>>24)&15);
		*/
		L =L2= C2[1];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;

		if (J&0x8000) P[0]=PAL(R1[0]);
		if (J&0x4000) P[1]=PAL(R1[1]);
		if (J&0x2000) P[2]=PAL(R1[2]);
		if (J&0x1000) P[3]=PAL(R1[3]);
		if (J&0x0800) P[4]=PAL(R2[0]);
		if (J&0x0400) P[5]=PAL(R2[1]);
		if (J&0x0200) P[6]=PAL(R2[2]);
		if (J&0x0100) P[7]=PAL(R2[3]);
		L =L2= C2[0];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if (J&0x80) P[8 ]=PAL(R1[0]);
		if (J&0x40) P[9 ]=PAL(R1[1]);
		if (J&0x20) P[10]=PAL(R1[2]);
		if (J&0x10) P[11]=PAL(R1[3]);
		if (J&0x08) P[12]=PAL(R2[0]);
		if (J&0x04) P[13]=PAL(R2[1]);
		if (J&0x02) P[14]=PAL(R2[2]);
		if (J&0x01) P[15]=PAL(R2[3]);
	}
}

static void inline PutSpriteHflip(byte *P,byte *C,unsigned long *C2,byte *R,int h,int inc)
{
	int i,J;
	unsigned long L,L2;
	unsigned char *R1= (unsigned char *) &L;
	unsigned char *R2= (unsigned char *) &L2;

	for(i=0;i<h;i++,C+=inc,C2+=inc,P+=WIDTH) {
		J = ((word*)C)[0]|((word*)C)[16]|((word*)C)[32]|((word*)C)[48];
		if (!J) continue;
		J=SWAP16(J);
		/*L = C2[1];//sp2pixel(C+1);
		if (J&0x8000) P[15]=PAL((L>>4)&15);
		if (J&0x4000) P[14]=PAL((L>>12)&15);
		if (J&0x2000) P[13]=PAL((L>>20)&15);
		if (J&0x1000) P[12]=PAL((L>>28));
		if (J&0x0800) P[11]=PAL((L)&15);
		if (J&0x0400) P[10]=PAL((L>>8)&15);
		if (J&0x0200) P[9]=PAL((L>>16)&15);
		if (J&0x0100) P[8]=PAL((L>>24)&15);
		L = C2[0];//sp2pixel(C);
		if (J&0x80) P[7]=PAL((L>>4)&15);
		if (J&0x40) P[6]=PAL((L>>12)&15);
		if (J&0x20) P[5]=PAL((L>>20)&15);
		if (J&0x10) P[4]=PAL((L>>28));
		if (J&0x08) P[3]=PAL((L)&15);
		if (J&0x04) P[2]=PAL((L>>8)&15);
		if (J&0x02) P[1]=PAL((L>>16)&15);
		if (J&0x01) P[0]=PAL((L>>24)&15);*/
		L =L2= C2[1];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;

		if (J&0x8000) P[15]=PAL(R1[0]);
		if (J&0x4000) P[14]=PAL(R1[1]);
		if (J&0x2000) P[13]=PAL(R1[2]);
		if (J&0x1000) P[12]=PAL(R1[3]);
		if (J&0x0800) P[11]=PAL(R2[0]);
		if (J&0x0400) P[10]=PAL(R2[1]);
		if (J&0x0200) P[9]=PAL(R2[2]);
		if (J&0x0100) P[8]=PAL(R2[3]);
		L =L2= C2[0];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if (J&0x80) P[7 ]=PAL(R1[0]);
		if (J&0x40) P[6 ]=PAL(R1[1]);
		if (J&0x20) P[5]=PAL(R1[2]);
		if (J&0x10) P[4]=PAL(R1[3]);
		if (J&0x08) P[3]=PAL(R2[0]);
		if (J&0x04) P[2]=PAL(R2[1]);
		if (J&0x02) P[1]=PAL(R2[2]);
		if (J&0x01) P[0]=PAL(R2[3]);
	}
}

static void inline PutSpriteM(byte *P,byte *C,unsigned long *C2,byte *R,int h,int inc,byte *M,byte pr)
{
	int i,J;
	unsigned long L,L2;
	unsigned char *R1=(unsigned char *) &L;
	unsigned char *R2=(unsigned char *) &L2;

	for(i=0;i<h;i++,C+=inc,C2+=inc,P+=WIDTH,M+=WIDTH) {
		J = ((word*)C)[0]|((word*)C)[16]|((word*)C)[32]|((word*)C)[48];
		if (!J) continue;
		J=SWAP16(J);
		/*
		L = C2[1];//sp2pixel(C+1);
		if ((J&0x8000)&&M[0]<=pr) P[0]=PAL((L>>4)&15);
		if ((J&0x4000)&&M[1]<=pr) P[1]=PAL((L>>12)&15);
		if ((J&0x2000)&&M[2]<=pr) P[2]=PAL((L>>20)&15);
		if ((J&0x1000)&&M[3]<=pr) P[3]=PAL((L>>28));
		if ((J&0x0800)&&M[4]<=pr) P[4]=PAL((L)&15);
		if ((J&0x0400)&&M[5]<=pr) P[5]=PAL((L>>8)&15);
		if ((J&0x0200)&&M[6]<=pr) P[6]=PAL((L>>16)&15);
		if ((J&0x0100)&&M[7]<=pr) P[7]=PAL((L>>24)&15);
		L = C2[0];//sp2pixel(C);
		if ((J&0x80)&&M[8 ]<=pr) P[8 ]=PAL((L>>4)&15);
		if ((J&0x40)&&M[9 ]<=pr) P[9 ]=PAL((L>>12)&15);
		if ((J&0x20)&&M[10]<=pr) P[10]=PAL((L>>20)&15);
		if ((J&0x10)&&M[11]<=pr) P[11]=PAL((L>>28));
		if ((J&0x08)&&M[12]<=pr) P[12]=PAL((L)&15);
		if ((J&0x04)&&M[13]<=pr) P[13]=PAL((L>>8)&15);
		if ((J&0x02)&&M[14]<=pr) P[14]=PAL((L>>16)&15);
		if ((J&0x01)&&M[15]<=pr) P[15]=PAL((L>>24)&15);
		*/
		L =L2= C2[1];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if ((J&0x8000)&&M[0]<=pr) P[0]=PAL(R1[0]);
		if ((J&0x4000)&&M[1]<=pr) P[1]=PAL(R1[1]);
		if ((J&0x2000)&&M[2]<=pr) P[2]=PAL(R1[2]);
		if ((J&0x1000)&&M[3]<=pr) P[3]=PAL(R1[3]);
		if ((J&0x0800)&&M[4]<=pr) P[4]=PAL(R2[0]);
		if ((J&0x0400)&&M[5]<=pr) P[5]=PAL(R2[1]);
		if ((J&0x0200)&&M[6]<=pr) P[6]=PAL(R2[2]);
		if ((J&0x0100)&&M[7]<=pr) P[7]=PAL(R2[3]);
		L =L2= C2[0];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if ((J&0x80)&&M[8 ]<=pr) P[8 ]=PAL(R1[0]);
		if ((J&0x40)&&M[9 ]<=pr) P[9 ]=PAL(R1[1]);
		if ((J&0x20)&&M[10]<=pr) P[10]=PAL(R1[2]);
		if ((J&0x10)&&M[11]<=pr) P[11]=PAL(R1[3]);
		if ((J&0x08)&&M[12]<=pr) P[12]=PAL(R2[0]);
		if ((J&0x04)&&M[13]<=pr) P[13]=PAL(R2[1]);
		if ((J&0x02)&&M[14]<=pr) P[14]=PAL(R2[2]);
		if ((J&0x01)&&M[15]<=pr) P[15]=PAL(R2[3]);
	}
}

static void inline PutSpriteHflipM(byte *P,byte *C,unsigned long *C2,byte *R,int h,int inc,byte *M,byte pr)
{
	int i,J;
	unsigned long L,L2;
	unsigned char *R1= (unsigned char *) &L;
	unsigned char *R2= (unsigned char *) &L2;

	for(i=0;i<h;i++,C+=inc,C2+=inc,P+=WIDTH,M+=WIDTH) {
		J = ((word*)C)[0]|((word*)C)[16]|((word*)C)[32]|((word*)C)[48];
		if (!J) continue;
		J=SWAP16(J);
		
		/*L = C2[1];//sp2pixel(C+1);
		if ((J&0x8000)&&M[15]<=pr) P[15]=PAL((L>>4)&15);
		if ((J&0x4000)&&M[14]<=pr) P[14]=PAL((L>>12)&15);
		if ((J&0x2000)&&M[13]<=pr) P[13]=PAL((L>>20)&15);
		if ((J&0x1000)&&M[12]<=pr) P[12]=PAL((L>>28));
		if ((J&0x0800)&&M[11]<=pr) P[11]=PAL((L)&15);
		if ((J&0x0400)&&M[10]<=pr) P[10]=PAL((L>>8)&15);
		if ((J&0x0200)&&M[9]<=pr) P[9]=PAL((L>>16)&15);
		if ((J&0x0100)&&M[8]<=pr) P[8]=PAL((L>>24)&15);
		L = C2[0];//sp2pixel(C);
		if ((J&0x80)&&M[7]<=pr) P[7]=PAL((L>>4)&15);
		if ((J&0x40)&&M[6]<=pr) P[6]=PAL((L>>12)&15);
		if ((J&0x20)&&M[5]<=pr) P[5]=PAL((L>>20)&15);
		if ((J&0x10)&&M[4]<=pr) P[4]=PAL((L>>28));
		if ((J&0x08)&&M[3]<=pr) P[3]=PAL((L)&15);
		if ((J&0x04)&&M[2]<=pr) P[2]=PAL((L>>8)&15);
		if ((J&0x02)&&M[1]<=pr) P[1]=PAL((L>>16)&15);
		if ((J&0x01)&&M[0]<=pr) P[0]=PAL((L>>24)&15);
		*/
		L =L2= C2[1];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if ((J&0x8000)&&M[15]<=pr) P[15]=PAL(R1[0]);
		if ((J&0x4000)&&M[14]<=pr) P[14]=PAL(R1[1]);
		if ((J&0x2000)&&M[13]<=pr) P[13]=PAL(R1[2]);
		if ((J&0x1000)&&M[12]<=pr) P[12]=PAL(R1[3]);
		if ((J&0x0800)&&M[11]<=pr) P[11]=PAL(R2[0]);
		if ((J&0x0400)&&M[10]<=pr) P[10]=PAL(R2[1]);
		if ((J&0x0200)&&M[9 ]<=pr) P[9 ]=PAL(R2[2]);
		if ((J&0x0100)&&M[8 ]<=pr) P[8]=PAL(R2[3]);
		L =L2= C2[0];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if ((J&0x80)&&M[7]<=pr) P[7]=PAL(R1[0]);
		if ((J&0x40)&&M[6]<=pr) P[6]=PAL(R1[1]);
		if ((J&0x20)&&M[5]<=pr) P[5]=PAL(R1[2]);
		if ((J&0x10)&&M[4]<=pr) P[4]=PAL(R1[3]);
		if ((J&0x08)&&M[3]<=pr) P[3]=PAL(R2[0]);
		if ((J&0x04)&&M[2]<=pr) P[2]=PAL(R2[1]);
		if ((J&0x02)&&M[1]<=pr) P[1]=PAL(R2[2]);
		if ((J&0x01)&&M[0]<=pr) P[0]=PAL(R2[3]);

	}
}

static void inline PutSpriteMakeMask(byte *P,byte *C,unsigned long *C2,byte *R,int h,int inc,byte *M,byte pr)
{
	int i,J;
	unsigned long L,L2;
	unsigned char *R1= (unsigned char *) &L;
	unsigned char *R2= (unsigned char *) &L2;

	for(i=0;i<h;i++,C+=inc,C2+=inc,P+=WIDTH,M+=WIDTH) {
		J = ((word*)C)[0]|((word*)C)[16]|((word*)C)[32]|((word*)C)[48];
		if (!J) continue;
		J=SWAP16(J);
		L =L2= C2[1];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if (J&0x8000) {P[0]=PAL(R1[0]); M[0]=pr;}
		if (J&0x4000) {P[1]=PAL(R1[1]); M[1]=pr;}
		if (J&0x2000) {P[2]=PAL(R1[2]); M[2]=pr;}
		if (J&0x1000) {P[3]=PAL(R1[3]); M[3]=pr;}
		if (J&0x0800) {P[4]=PAL(R2[0]); M[4]=pr;}
		if (J&0x0400) {P[5]=PAL(R2[1]); M[5]=pr;}
		if (J&0x0200) {P[6]=PAL(R2[2]); M[6]=pr;}
		if (J&0x0100) {P[7]=PAL(R2[3]); M[7]=pr;}
		
		L =L2= C2[0];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if (J&0x80) {P[8 ]=PAL(R1[0]); M[8]=pr;}
		if (J&0x40) {P[9 ]=PAL(R1[1]); M[9]=pr;}
		if (J&0x20) {P[10]=PAL(R1[2]); M[10]=pr;}
		if (J&0x10) {P[11]=PAL(R1[3]); M[11]=pr;}
		if (J&0x08) {P[12]=PAL(R2[0]); M[12]=pr;}
		if (J&0x04) {P[13]=PAL(R2[1]); M[13]=pr;}
		if (J&0x02) {P[14]=PAL(R2[2]); M[14]=pr;}
		if (J&0x01) {P[15]=PAL(R2[3]); M[15]=pr;}
	}
}

static void inline  PutSpriteHflipMakeMask(byte *P,byte *C,unsigned long *C2,byte *R,int h,int inc,byte *M,byte pr)
{
	int i,J;
	unsigned long L,L2;
	unsigned char *R1= (unsigned char *) &L;
	unsigned char *R2= (unsigned char *) &L2;

	for(i=0;i<h;i++,C+=inc,C2+=inc,P+=WIDTH,M+=WIDTH) {
		J = ((word*)C)[0]|((word*)C)[16]|((word*)C)[32]|((word*)C)[48];
		if (!J) continue;
		J=SWAP16(J);
		/*L = C2[1];//sp2pixel(C+1);
		if (J&0x8000) {P[15]=PAL((L>>4)&15);  M[15]=pr;}
		if (J&0x4000) {P[14]=PAL((L>>12)&15); M[14]=pr;}
		if (J&0x2000) {P[13]=PAL((L>>20)&15); M[13]=pr;}
		if (J&0x1000) {P[12]=PAL((L>>28));    M[12]=pr;}
		if (J&0x0800) {P[11]=PAL((L)&15);     M[11]=pr;}
		if (J&0x0400) {P[10]=PAL((L>>8)&15);  M[10]=pr;}
		if (J&0x0200) {P[9]=PAL((L>>16)&15);  M[9]=pr;}
		if (J&0x0100) {P[8]=PAL((L>>24)&15);  M[8]=pr;}
		L = C2[0];//sp2pixel(C);
		if (J&0x80) {P[7]=PAL((L>>4)&15);  M[7]=pr;}
		if (J&0x40) {P[6]=PAL((L>>12)&15); M[6]=pr;}
		if (J&0x20) {P[5]=PAL((L>>20)&15); M[5]=pr;}
		if (J&0x10) {P[4]=PAL((L>>28));    M[4]=pr;}
		if (J&0x08) {P[3]=PAL((L)&15);     M[3]=pr;}
		if (J&0x04) {P[2]=PAL((L>>8)&15);  M[2]=pr;}
		if (J&0x02) {P[1]=PAL((L>>16)&15); M[1]=pr;}
		if (J&0x01) {P[0]=PAL((L>>24)&15); M[0]=pr;}
		*/
		L =L2= C2[1];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if (J&0x8000) {P[15]=PAL(R1[0]); M[15]=pr;}
		if (J&0x4000) {P[14]=PAL(R1[1]); M[14]=pr;}
		if (J&0x2000) {P[13]=PAL(R1[2]); M[13]=pr;}
		if (J&0x1000) {P[12]=PAL(R1[3]); M[12]=pr;}
		if (J&0x0800) {P[11]=PAL(R2[0]); M[11]=pr;}
		if (J&0x0400) {P[10]=PAL(R2[1]); M[10]=pr;}
		if (J&0x0200) {P[9 ]=PAL(R2[2]); M[9 ]=pr;}
		if (J&0x0100) {P[8 ]=PAL(R2[3]); M[8 ]=pr;}
		
		L =L2= C2[0];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if (J&0x80) {P[7]=PAL(R1[0]); M[7]=pr;}
		if (J&0x40) {P[6]=PAL(R1[1]); M[6]=pr;}
		if (J&0x20) {P[5]=PAL(R1[2]); M[5]=pr;}
		if (J&0x10) {P[4]=PAL(R1[3]); M[4]=pr;}
		if (J&0x08) {P[3]=PAL(R2[0]); M[3]=pr;}
		if (J&0x04) {P[2]=PAL(R2[1]); M[2]=pr;}
		if (J&0x02) {P[1]=PAL(R2[2]); M[1]=pr;}
		if (J&0x01) {P[0]=PAL(R2[3]); M[0]=pr;}
	}
}

void RefreshSprite(int Y1,int Y2,BYTE bg)
{
	int n;
	SPR *spr;
	unsigned char SPal[256];

	static int usespbg = 0;
	int desplazx;

	spr = ((SPR*) (void *) SPRAM) + 63;

    desplazx=(WIDTH-FC_W)>>1;
	if (bg==0)
		usespbg=0;
    for(n=0;n<256;n++)
	{
	SPal[n]=Pal[n+256];
	}
	for(n=0;n<64;n++,spr--){
		int x,y,no,atr,inc,cgx,cgy;
		register byte *R,*C;
		register unsigned long *C2;
		int	pos;
		int h,t,i,j;
		int y_sum;
		int spbg;

		atr=spr->atr;
		spbg = (atr>>7)&1;
		if (spbg != bg)
			continue;
		y = (spr->y&1023)-64;
		x = (spr->x&1023)-32;
		no= spr->no&2047;
		cgx = (atr>>8)&1;
		cgy = (atr>>12)&3;
		cgy |= cgy>>1;
		no = (no>>1)&~((cgy<<1)+cgx);
		if (y>=Y2 || y+((cgy+1)<<4)<Y1 || x>=FC_W || x+((cgx+1)<<4)<0) continue;

		R = &SPal[(atr&15)<<4];
		for (i=0;i<cgy*2+cgx+1;i++) {
			if (vchanges[no+i]) {
				vchanges[no+i] = 0;
				sp2pixel(no+i);
			}
			if (!cgx) i++;
		}
		C = &VRAM[no<<7];
		C2 = &VRAMS[no<<5];
		pos = desplazx+/*WIDTH*(HEIGHT-FC_H)/2+(WIDTH-FC_W)/2+*/WIDTH*y+x;
		inc = 2;
		if (atr&V_FLIP) { inc=-2; C+=30+(cgy<<8); C2+=30+(cgy<<6);}
		y_sum = 0;
		//printf("(%d,%d,%d,%d,%d)",x,y,cgx,cgy,h);
		//TRACE("Spr#%d,no=%d,x=%d,y=%d,CGX=%d,CGY=%d,xb=%d,yb=%d\n", n, no, x, y, cgx, cgy, atr&H_FLIP, atr&V_FLIP);
		for(i=0;i<=cgy;i++) {
			t = Y1-y-y_sum;
			h = 16;
			if (t>0) {
				C+=t*inc;
				C2+=t*inc;
				h-=t;
				pos+=t*WIDTH;
			}
			if (h>Y2-y-y_sum) h = Y2-y-y_sum;

if(!fast_sprite)
		{
			if (spbg==0){
				usespbg=1;
				if (atr&H_FLIP){
				  for(j=0;j<=cgx;j++)
					PutSpriteHflipMakeMask(XBuf+pos+((cgx-j)<<4), (void *) (C+(j<<7)), (void *) (C2+(j<<5)), (void *) (R),h,inc,SPM+pos+((cgx-j)<<4),n);
				}else{
				  for(j=0;j<=cgx;j++)
					PutSpriteMakeMask(XBuf+pos+(j<<4), (void *) (C+(j<<7)), (void *) (C2+(j<<5)), (void *) R,h,inc,SPM+pos+(j<<4),n);
				}
			} else if (usespbg) {
				if (atr&H_FLIP){
				  for(j=0;j<=cgx;j++)
					PutSpriteHflipM(XBuf+pos+((cgx-j)<<4),  (void *) (C+(j<<7)), (void *) (C2+(j<<5)), (void *) R,h,inc,SPM+pos+((cgx-j)<<4),n);
				}else{
				  for(j=0;j<=cgx;j++)
					PutSpriteM(XBuf+pos+(j<<4), (void *) (C+(j<<7)), (void *) (C2+(j<<5)), (void *) R,h,inc,SPM+pos+(j<<4),n);
				}
			} else {
				if (atr&H_FLIP){
				  for(j=0;j<=cgx;j++)
					PutSpriteHflip(XBuf+pos+((cgx-j)<<4), (void *) (C+(j<<7)), (void *) (C2+(j<<5)), (void *) R,h,inc);
				}else{
				  for(j=0;j<=cgx;j++)
					PutSprite(XBuf+pos+(j<<4),(void *) (C+(j<<7)), (void *) (C2+(j<<5)), (void *) R,h,inc);
				}
			}
		}
			else // fast_sprite
			{
			if (atr&H_FLIP){
				  for(j=0;j<=cgx;j++)
					PutSpriteHflip(XBuf+pos+((cgx-j)<<4), (void *) (C+(j<<7)), (void *) (C2+(j<<5)), (void *) R,h,inc);
				}else{
				  for(j=0;j<=cgx;j++)
					PutSprite(XBuf+pos+(j<<4), (void *) (C+(j<<7)), (void *) (C2+(j<<5)), (void *) R,h,inc);
				}
			}
		

			
			pos+=h*WIDTH;
			C+=(h+16*7)*inc;
			C2+=(h+16)*inc;
			y_sum+=16;
		}
	}
}

void RefreshScreen(void)
{
	int dispmin,dispmax;
     register unsigned *p,v;
	 int n;
	dispmin = (MaxLine-MinLine>MAXDISP ? MinLine+((MaxLine-MinLine-MAXDISP+1)>>1) : MinLine);
	dispmax = (MaxLine-MinLine>MAXDISP ? MaxLine-((MaxLine-MinLine-MAXDISP+1)>>1) : MaxLine);
	PutImage((WIDTH-FC_W)>>1,/*(HEIGHT-FC_H)/2+*/MinLine+dispmin,FC_W,dispmax-dispmin+1);
	// ATENCION: Paso X en PutImage unicamente para conocer si debo invertir la pantalla
	
//	memset(XBuf+MinLine*WIDTH,Pal[0],(MaxLine-MinLine)*WIDTH);

	v=Pal[0]; v=(v<<8) | v; v=(v<<8) | v; v=(v<<8) | v;
	p=(unsigned *) (XBuf+MinLine*WIDTH); n=((MaxLine-MinLine)*WIDTH)>>2;	while(n) {*p++=v;n--;}
//	memset(SPM+MinLine*WIDTH,0,(MaxLine-MinLine)*WIDTH);
	p=(unsigned *) (SPM+MinLine*WIDTH); n=((MaxLine-MinLine)*WIDTH)>>2;	while(n) {*p++=0;n--;}
	
}
static int is_a_sav=0;

int CartLoad(char *name)
{
	FILE *fp;
	int fsize;
	int use_gzip=0;
	int use_zip=0;

debug_str="CartLoad()";	

  //  if(iso_FILE) {fclose(iso_FILE);iso_FILE=0;}
	//open_wav("/mnt/sd/roms/pcengine/track-04.wav");
	is_a_sav=0;
	CD_emulation=0;
	actual_track=0;
	CD_track[0].filename[0]=0;
	MY_filename=name;   
    if (is_ext (name, ".sav"))
	{
	if(!load_game(1)) return -1; // error cargando save game
	debug_str="CartLoad()";	
	name=MY_filename; // reemplazo de nombre
	is_a_sav=1;
	}

	ISO_filename=0;
	if (is_ext (name, ".iso") || is_ext (name, ".ISO") || is_ext (name, ".bin") || is_ext (name, ".BIN") 
		|| is_ext (name, ".toc") || is_ext (name, ".TOC") || is_ext (name, ".hcd") || is_ext (name, ".HCD"))
    {
    int mode=0;
	ISO_filename=name;

	if(is_ext (name, ".bin") || is_ext (name, ".BIN")) mode=1;
	
	CD_emulation = 2;
	if(!is_ext (name, ".toc") && !is_ext (name, ".TOC") && !is_ext (name, ".hcd") && !is_ext (name, ".HCD"))
	{
	 if (!(iso_FILE = fopen (ISO_filename, "rb")))
	{
	 CD_emulation = 0;
	  return -1;
	}
	debug_str="CartLoad() fill_cd_info";	

      fill_cd_info(mode);
	  //fclose(iso_FILE);iso_FILE=0;
	  // CD_emulation = 3;
	}
	else
		{
		debug_str="CartLoad() ReadTocList";

	    if(ReadTocList(name)<0) {CD_emulation = 0;return -1;}

	  iso_FILE=0;
	  CD_emulation = 3;
		}
    debug_str="CartLoad() syscard";
	fp=NULL;
    if(CD_track[0].filename[0]!=0)
		{
		fp=fopen(CD_track[0].filename,"rb");
		if (fp && (is_ext (CD_track[0].filename, ".bz2") || is_ext (CD_track[0].filename, ".BZ2"))) use_gzip=1;
		if (fp && (is_ext (CD_track[0].filename, ".zip") || is_ext (CD_track[0].filename, ".ZIP")))
													{sprintf(tempfilename,"%s",CD_track[0].filename);use_zip=1;}
		}
	if (fp==NULL) {sprintf(tempfilename,"%ssyscard.pce",path_rom);fp=fopen(tempfilename,"rb");}
	if (fp==NULL) {sprintf(tempfilename,"%sSYSCARD.PCE",path_rom);fp=fopen(tempfilename,"rb");}
	if (fp==NULL) {sprintf(tempfilename,"%ssyscard.pce.bz2",path_rom);fp=fopen(tempfilename,"rb");if(fp) use_gzip=1;}
	if (fp==NULL) {sprintf(tempfilename,"%sSYSCARD.PCE.bz2",path_rom);fp=fopen(tempfilename,"rb");if(fp) use_gzip=1;}
	if (fp==NULL) {sprintf(tempfilename,"%ssyscard.zip",path_rom);fp=fopen(tempfilename,"rb");if(fp) use_zip=1;}
	if (fp==NULL) {sprintf(tempfilename,"%sSYSCARD.ZIP",path_rom);fp=fopen(tempfilename,"rb");if(fp) use_zip=1;}
	if (fp==NULL) {
	//	TRACE("%s not found.\n",name);
	if(iso_FILE) {fclose(iso_FILE);iso_FILE=0;}
	CD_emulation = 0;
		return -1;
	}
	if(use_zip)
	{
	unz_global_info gi;
	unzFile uf;
	int error;
	int n;
	char zip_file[256];
    unz_file_info zip_file_info;

	fsize=0;
    if (fp==NULL) {	return -1;}
	fclose(fp);
	uf = unzOpen (tempfilename);

	if (uf == NULL) return -1;

	error = unzGetGlobalInfo (uf, &gi);
	if(error != UNZ_OK)  {unzClose(uf);return -1;}

	for (n=0; n<gi.number_entry; n++)
		{
		  error = unzGetCurrentFileInfo (uf, &zip_file_info, zip_file,
					   sizeof (zip_file), NULL, 0, NULL, 0);

		  if(error != UNZ_OK)  {unzClose(uf);return -1;}

		  if (strcasestr(zip_file, ".pce") || strcasestr (zip_file, ".PCE")) break;
			
		  if (n < (gi.number_entry-1))
			{
			error = unzGoToNextFile (uf);
			if(error != UNZ_OK)  {unzClose(uf);return -1;}
			}
		}
	//

	ROM =(BYTE *)malloc(zip_file_info.uncompressed_size+0x2000);
	if (ROM == NULL) {unzClose(uf);return -1;}

    error = unzOpenCurrentFile (uf);
    if(error != UNZ_OK)  {free(ROM);ROM=0;unzClose(uf);return -1;}

	fsize=zip_file_info.uncompressed_size;
    n=0;
	while(n<zip_file_info.uncompressed_size)
		{
		error = unzReadCurrentFile (uf, ROM+n, zip_file_info.uncompressed_size-n);
		if (error <= 0) break;

		n+=error; 
	    }
      

     if(error <0)  {free(ROM);ROM=0;unzCloseCurrentFile(uf);unzClose(uf);return -1;}

     error = unzCloseCurrentFile (uf);
     if(error != UNZ_OK)  {unzClose(uf);free(ROM);ROM=0;return -1;}

	 for(n=0;n<(fsize & ~0x1fff); n++)
		{
		ROM[n]=ROM[n+(fsize&0x1fff)];
		}
	fsize&=~0x1fff;
	ROM_size = fsize/0x2000;

	}
	else
	if(use_gzip)
	{
	BZFILE * my_bzip;
	int bzip_err=0;
	int n;
	fsize=0;
	
	if (fp==NULL) {	return -1;	}
	ROM =(BYTE *)malloc(2*1024*1024);
	if(ROM==NULL) {fclose(fp);return -2;}
	my_bzip=BZ2_bzReadOpen( &bzip_err, fp, 0, 1, NULL, 0 );
	
	fsize=BZ2_bzRead (&bzip_err, my_bzip, ROM, 2*1024*1024);
	
	BZ2_bzReadClose (&bzip_err, my_bzip);
    fclose(fp);
	for(n=0;n<(fsize & ~0x1fff); n++)
		{
		ROM[n]=ROM[n+(fsize&0x1fff)];
		}
	fsize&=~0x1fff;
	ROM_size = fsize/0x2000;
	}
	else
	{
	fseek(fp,0,SEEK_END);
	fsize = ftell(fp);
	
	fseek(fp,fsize&0x1fff,SEEK_SET);
	//printf("seekptr %x",ftell(fp));
	fsize&=~0x1fff;
	
//	ROM = (BYTE *) malloc(48*0x2000 + 512 ); 
	ROM =(BYTE *)malloc(fsize+0x2000);

	if(ROM==NULL) {CD_emulation = 0;fclose(fp);return -2;}
	ROM_size = fsize/0x2000;
	fread(ROM,1,fsize,fp);
	fclose(fp);
	}
	if(ROM) // capture functions from the BIOS
		{ 
		int n;
	
		for(n=0;n<0x18;n++)
		ROM[n*3]=0xfc;
	
		}
  
	}
	else
	{
	debug_str="CartLoad() ROM";
	if (is_ext (name, ".zip") || is_ext (name, ".ZIP")) // zip files
	{
	unz_global_info gi;
	unzFile uf;
	int error;
	int n;
	char zip_file[256];
    unz_file_info zip_file_info;

	fsize=0;

	uf = unzOpen (name);
	if (uf == NULL) return -1;

	error = unzGetGlobalInfo (uf, &gi);
	if(error != UNZ_OK)  {unzClose(uf);return -1;}

	for (n=0; n<gi.number_entry; n++)
		{
		  error = unzGetCurrentFileInfo (uf, &zip_file_info, zip_file,
					   sizeof (zip_file), NULL, 0, NULL, 0);

		  if(error != UNZ_OK)  {unzClose(uf);return -1;}

		  if (strcasestr(zip_file, ".pce") || strcasestr (zip_file, ".PCE")) break;
			
		  if (n < (gi.number_entry-1))
			{
			error = unzGoToNextFile (uf);
			if(error != UNZ_OK)  {unzClose(uf);return -1;}
			}
		}
	//

	ROM =(BYTE *)malloc(zip_file_info.uncompressed_size+0x2000);
	if (ROM == NULL) {unzClose(uf);return -1;}

    error = unzOpenCurrentFile (uf);
    if(error != UNZ_OK)  {free(ROM);ROM=0;unzClose(uf);return -1;}

	fsize=zip_file_info.uncompressed_size;
    n=0;
	while(n<zip_file_info.uncompressed_size)
		{
		error = unzReadCurrentFile (uf, ROM+n, zip_file_info.uncompressed_size-n);
		if (error <= 0) break;

		n+=error; 
	    }
      

     if(error <0)  {free(ROM);ROM=0;unzCloseCurrentFile(uf);unzClose(uf);return -1;}

     error = unzCloseCurrentFile (uf);
     if(error != UNZ_OK)  {unzClose(uf);free(ROM);ROM=0;return -1;}

	 for(n=0;n<(fsize & ~0x1fff); n++)
		{
		ROM[n]=ROM[n+(fsize&0x1fff)];
		}
	fsize&=~0x1fff;
	ROM_size = fsize/0x2000;

    }
	else
    if (is_ext (name, ".bz2") || is_ext (name, ".BZ2"))
	{
	BZFILE * my_bzip;
	int bzip_err=0;
	int n;
	fsize=0;
	fp=fopen(name,"rb");
	if (fp==NULL) {	return -1;	}
	ROM =(BYTE *)malloc(2*1024*1024);
	if(ROM==NULL) {fclose(fp);return -2;}
	my_bzip=BZ2_bzReadOpen( &bzip_err, fp, 0, 1, NULL, 0 );
	
	fsize=BZ2_bzRead (&bzip_err, my_bzip, ROM, 2*1024*1024);
	
	BZ2_bzReadClose (&bzip_err, my_bzip);
    fclose(fp);
	for(n=0;n<(fsize & ~0x1fff); n++)
		{
		ROM[n]=ROM[n+(fsize&0x1fff)];
		}
	fsize&=~0x1fff;
	ROM_size = fsize/0x2000;
	}
	else
		{
		
		fp=fopen(name,"rb");
		if (fp==NULL) {	return -1;	}
		fseek(fp,0,SEEK_END);
		fsize = ftell(fp);
	
		fseek(fp,fsize&0x1fff,SEEK_SET);
		
		fsize&=~0x1fff;
		ROM =(BYTE *)malloc(fsize+0x2000);
		if(ROM==NULL) {fclose(fp);return -2;}
		ROM_size = fsize/0x2000;
	    fread(ROM,1,fsize,fp);
		fclose(fp);
		
		}
	}
	//printf("ROM size:%x\n",fsize);
	

	if (strstr(name, "populous") || strstr(name, "POPULOUS"))
	{
	
		populus = 1;
	}
	else
		populus = 0;
	return 0;
}

typedef struct
{
unsigned ID;
int have;
int page[8];
int CD_cmd[8];
unsigned button;
unsigned short is_street_fighter;
unsigned short sf2_latch;
int reserved[254];
} t_cab_sav;

extern MCONFIG mconfig;

extern int CD_track_cmd[8];

static FILE *fp_bzip=0;

int compress_rom(char *name)
{

int i,n,m;
char filename[256];
BZFILE * my_bzip;
int bzip_err=0;
char *temp;
FILE *fp, *fp_bzip;
strcpy(filename,name);

temp=malloc(1024*2048);
if(!temp) return -3;

strcat(filename,".bz2");

fp = fopen(name, "rb");
if (fp == NULL) {free(temp);return -1;}

fp_bzip = fopen(filename, "wb");
if (fp_bzip == NULL) {free(temp);fclose(fp);return -2;}
	
fseek(fp,0,SEEK_END);
m = ftell(fp);
fseek(fp,0,SEEK_SET);
if(m>(1024*2048)) {free(temp);fclose(fp);fclose(fp_bzip);return -3;}
n=fread(temp,1,m,fp);
fclose(fp); 
if(n<m) {free(temp);fclose(fp_bzip);return -4;}



my_bzip=BZ2_bzWriteOpen( &bzip_err, fp_bzip, 4, 0,30);
if(bzip_err!=BZ_OK)  {free(temp);fclose(fp_bzip);return -5;}

BZ2_bzWrite (&bzip_err, my_bzip, temp,  m);
i=bzip_err;	
BZ2_bzWriteClose (&bzip_err, my_bzip,0,(unsigned int *) &n,(unsigned int *) &m);
fclose(fp_bzip);
free(temp);
//sync();
if(i!=BZ_OK || bzip_err!=BZ_OK)
	{
	remove(filename);
	 return -5;
	}
else remove(name);


return 0;
}
extern int swap_runselect;

void save_cd(char *data);
void load_cd(char *data);

static char cd_data[80];


int save_game()
{

t_cab_sav cabsav;
int n, m;
BZFILE * my_bzip;
int bzip_err=0;
int file_error=0;
char savefile[256];

cabsav.ID=0xCACABACA;
cabsav.have=128;

cabsav.button=(mconfig.A & 0xff) | ((mconfig.B & 0xff)<<8) | ((swap_runselect!=0)<<31);

cabsav.is_street_fighter=0x666 *(is_street_fighter!=0);
cabsav.sf2_latch=sf2_latch;


for(n=8;n<0x2000;n++)
	{
	if(WRAM[n]!=0) break;
	}
if(n!=0x2000) cabsav.have|=1; // WRAM en uso

if (populus) cabsav.have|=2; // memoria extra de populus
if (CD_emulation) cabsav.have|=4+8; // ram de cdrom
for (n=0;n<8;n++) cabsav.CD_cmd[n]=CD_track_cmd[n]; 

for(n=0;n<8;n++)
	{
	if(PageR[n]==IOAREA2) m=256;
	else
	{
	for(m=0;m<256;m++)
		{
		if(PageR[n]==(ROMMapR[m]-n*0x2000)) break;
		}
	}
	cabsav.page[n]=m;
	}

skip_wave_sound=1;
/*while(1)
	{
	usleep(1000*200);
	if(wave_sound_run==0) break;
	}
*/
back_name_path[back_name_ext-1]=0;
sprintf(savefile,"%s.tmp",back_name_path);

 back_name_path[back_name_ext-1]='.';
	back_name_path[back_name_ext]='s';back_name_path[back_name_ext+1]='a';back_name_path[back_name_ext+2]='v';back_name_path[back_name_ext+3]=0;


   
	fp_bzip = fopen(/*back_name_path*/savefile, "wb");
	
	if (fp_bzip == NULL)
	{skip_wave_sound=0;return 0;}
	else
	{
		
     my_bzip=BZ2_bzWriteOpen( &bzip_err, fp_bzip, 4, 0,30);
	 if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun;}
		
		BZ2_bzWrite (&bzip_err, my_bzip, &cabsav,  sizeof(cabsav));
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		if(cabsav.have & 128) BZ2_bzWrite (&bzip_err, my_bzip, MY_filename,256);
		
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		BZ2_bzWrite (&bzip_err, my_bzip, M2,  sizeof(M6502)); // salva los registros etc+
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		BZ2_bzWrite (&bzip_err, my_bzip, &io,  sizeof(io)); // salva el tema I/O 
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		
		BZ2_bzWrite (&bzip_err, my_bzip, SPRAM,64*8);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		BZ2_bzWrite (&bzip_err, my_bzip, Pal,512);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		set_SPM();
		if(io.screen_w<=384)
		  BZ2_bzWrite (&bzip_err, my_bzip, SPM_SAV,384*HEIGHT);
		else
		  BZ2_bzWrite (&bzip_err, my_bzip, SPM_SAV,WIDTH*HEIGHT);

		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		
		BZ2_bzWrite (&bzip_err, my_bzip, vchange,VRAMSIZE/32);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		BZ2_bzWrite (&bzip_err, my_bzip, vchanges,VRAMSIZE/128);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}

		BZ2_bzWrite (&bzip_err, my_bzip, VRAM,VRAMSIZE);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		BZ2_bzWrite (&bzip_err, my_bzip, VRAM2,VRAMSIZE);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		BZ2_bzWrite (&bzip_err, my_bzip, VRAMS,VRAMSIZE);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		BZ2_bzWrite (&bzip_err, my_bzip, RAM,  0x8000);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		if(cabsav.have & 1)
		     BZ2_bzWrite (&bzip_err, my_bzip, WRAM,  0x2000);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		if(cabsav.have & 2)
		     BZ2_bzWrite (&bzip_err, my_bzip, PopRAM,  0x8000);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}

		if(cabsav.have & 4) // if cdrom
		{
		BZ2_bzWrite (&bzip_err, my_bzip, cd_extra_mem,  0x10000);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		BZ2_bzWrite (&bzip_err, my_bzip, cd_extra_super_mem,  0x30000);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		
		if(cabsav.have & 8) 
			{
			save_cd(cd_data); // save extra CD
			BZ2_bzWrite (&bzip_err, my_bzip, cd_data,  80);
			if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
			BZ2_bzWrite (&bzip_err, my_bzip, PCM,  0x10000);
			if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
			BZ2_bzWrite (&bzip_err, my_bzip, cd_sector_buffer,  0x2000);
			if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
			}
		}
	exit_fun_2:
		BZ2_bzWriteClose (&bzip_err, my_bzip,0, (unsigned int *) &n, (unsigned int *) &m);
		fclose(fp_bzip); fp_bzip=0;
		if(bzip_err!=BZ_OK) {file_error=1;}
		//sync();
	}
exit_fun:
	
if(!file_error)
{
remove(back_name_path);
rename(savefile,back_name_path);
}
else 
	{
	remove(savefile);
	skip_wave_sound=0;
	return 0;
	}

skip_wave_sound=0;
return 1;
}

int load_game(int modo)
{

t_cab_sav cabsav;
int n;
BZFILE * my_bzip;
int bzip_err=0;

debug_str="load_game()";

cabsav.have=0;


skip_wave_sound=1;

/*while(1)
	{
	usleep(1000*200);
	if(wave_sound_run==0) break;
	}*/
back_name_path[back_name_ext]='s';back_name_path[back_name_ext+1]='a';back_name_path[back_name_ext+2]='v';back_name_path[back_name_ext+3]=0;

	
if(modo==0) fp_bzip = fopen(back_name_path, "rb");
else
if(modo==1)	fp_bzip = fopen(MY_filename, "rb");
else fseek(fp_bzip,0,SEEK_SET); // rebobina la pelicula...

	if (fp_bzip == NULL)
	{skip_wave_sound=0;return 0;}
	else
	{
	my_bzip=BZ2_bzReadOpen( &bzip_err, fp_bzip, 0, 1, NULL, 0 );
	BZ2_bzRead (&bzip_err, my_bzip, &cabsav,  sizeof(cabsav));


		if(cabsav.ID!=0xCACABACA || (modo!=0 && (cabsav.have & 128)==0))
		{fclose(fp_bzip);BZ2_bzReadClose (&bzip_err, my_bzip);skip_wave_sound=0;return 0;}
		
		mconfig.A=cabsav.button & 0xff;
		mconfig.B=(cabsav.button>>8) & 0xff;
		swap_runselect=(cabsav.button>>31);

		is_street_fighter=(cabsav.is_street_fighter==0x666);
		sf2_latch=cabsav.sf2_latch & 3;
	
		if(cabsav.have & 128) 
		 {
		 char *p;
		 BZ2_bzRead (&bzip_err, my_bzip, MY_filename,256);
		 p=strstr(MY_filename,"pcengine/");
		 if(!p) p=strstr(MY_filename,"PCENGINE/");
		 if(p)
			 {
			 p+=9;
             sprintf(tempfilename,"%s%s",path_rom,p);
			 memcpy(MY_filename, tempfilename, 256);
			 }
		 }
		if(modo==1) 
			{BZ2_bzReadClose (&bzip_err, my_bzip);
		     
		    skip_wave_sound=0;return 1; // sal sin cerrar el fichero...
			 }
		BZ2_bzRead (&bzip_err, my_bzip, M2,  sizeof(M6502)); // salva los registros etc
		M2->P=(((M2->P)&~(N_FLAG|V_FLAG|Z_FLAG ))|(M2->NF&N_FLAG)|(M2->VF&V_FLAG)|(M2->ZF? 0:Z_FLAG));
		
		BZ2_bzRead (&bzip_err, my_bzip, &io,  sizeof(io)); // salva el tema I/O 
		new_adpcm_play=0;
		PCM_fade=ADPCM_fade=0;

		BZ2_bzRead (&bzip_err, my_bzip, SPRAM,64*8);
        
		BZ2_bzRead (&bzip_err, my_bzip, Pal,512);

		if(io.screen_w<=384)
			BZ2_bzRead (&bzip_err, my_bzip, SPM_SAV,384*HEIGHT);
		else 
			BZ2_bzRead (&bzip_err, my_bzip, SPM_SAV,WIDTH*HEIGHT);
		get_SPM();

		BZ2_bzRead (&bzip_err, my_bzip, vchange,VRAMSIZE/32);
		BZ2_bzRead (&bzip_err, my_bzip, vchanges,VRAMSIZE/128);

		BZ2_bzRead (&bzip_err, my_bzip, VRAM,VRAMSIZE);
		BZ2_bzRead (&bzip_err, my_bzip, VRAM2,VRAMSIZE);
		BZ2_bzRead (&bzip_err, my_bzip, VRAMS,VRAMSIZE);
		BZ2_bzRead (&bzip_err, my_bzip, RAM,  0x8000);
		if(cabsav.have & 1)
		     BZ2_bzRead (&bzip_err, my_bzip, WRAM,  0x2000);
		if(cabsav.have & 2)
		     BZ2_bzRead (&bzip_err, my_bzip, PopRAM,  0x8000) ;

		

		if(cabsav.have & 4)  // if cdrom
		{
		new_adpcm_play=0;
		PCM_fade=ADPCM_fade=0;

		BZ2_bzRead (&bzip_err, my_bzip, cd_extra_mem,  0x10000);
		BZ2_bzRead (&bzip_err, my_bzip, cd_extra_super_mem,  0x30000);
		for(n=0;n<8;n++) CD_track_cmd[n]=cabsav.CD_cmd[n];

		if(cabsav.have & 8) 
			{
			
			BZ2_bzRead (&bzip_err, my_bzip, cd_data,  80);
			load_cd(cd_data); // load extra CD
			BZ2_bzRead (&bzip_err, my_bzip, PCM,  0x10000);
			BZ2_bzRead (&bzip_err, my_bzip, cd_sector_buffer,  0x2000);
			}

		if(CD_track_cmd[0]==1) h_play_track(CD_track_cmd[1],CD_track_cmd[3]);
		else
		if(CD_track_cmd[0]==2) h_play_sectors(CD_track_cmd[1],CD_track_cmd[2],CD_track_cmd[3]);
		
		if(CD_track_cmd[4]==4) pce_cd_read_sector_special (CD_track_cmd[5]);
        WAV_TPOSITION_IN=0;
		
		
		} 
		BZ2_bzReadClose (&bzip_err, my_bzip);
		fclose(fp_bzip);fp_bzip=0;

	for(n=0;n<8;n++)
	{
	if(cabsav.page[n]==256) {PageR[n]=IOAREA2;PageW[n]=IOAREA2;}
	else
	bank_set(n,M2->MPR[n]);
	/*
	if(n==1)
		{
		int V=cabsav.page[n];
		if(V>=0xf8 && V<=0xfb)
			{
			ram_ptr=&RAM[0x2000*(V-0xf8)];
			}
		else ram_ptr=ROMMapR[V];
		PageR[n]=ROMMapR[cabsav.page[n]]-n*0x2000;PageW[n]=ROMMapW[cabsav.page[n]]-n*0x2000;

		}
	else {PageR[n]=ROMMapR[cabsav.page[n]]-n*0x2000;PageW[n]=ROMMapW[cabsav.page[n]]-n*0x2000;}
	*/
	}
	
    if(is_street_fighter)
		{
	    int i;
		byte *R;

		R=ROMMapR[0x40] = ROMMapR[0] + 0x80000+ sf2_latch* 0x80000;
		

		for (i = 0x41; i <= 0x7f; i++)
			{
			R+=0x2000;
			ROMMapR[i] =R;
			}
		}

	}
	
skip_wave_sound=0;
return 1;
}

void ResetPCE(M6502 *M)
{


debug_str="ResetPCE()";
WAV_TPOSITION_IN=0;
	memset(M,0,sizeof(*M));
	memset (SPRAM, 0, 64 * 8);
	//TimerCount = TimerPeriod;
	M->IPeriod = IPeriod;
	//M->TrapBadOps = 1;
	memset(&io, 0, sizeof(IO));
	scanline = 0;
	io.vdc_status=0;//VDC_InVBlank;
	io.vdc_inc = 1;
	io.minline = 0;
	io.maxline = 255;
	io.irq_mask = 0;
	io.psg_volume = 0;
	io.psg_ch = 0;
	io.screen_w = 255;
	io.screen_h = 224;
	/*for (i = 0; i < 6; i++)
	{
		io.PSG[i][4] = 0x00;
	}*/
	CycleOld = 0;

Reset6502(M);

debug_str="Undef";

 // sp_base = RAM + 0x100;
  

	
	//printf("reset PC=%04x ",M->PC.W);
}

int InitPCE(char *name)
{
	int i,ROMmask;
	FILE *fp;
	
	char *w;
	cart_name = name;

    back_name_path[0]=0;
	CD_track_cmd[0]=0;
	CD_track_cmd[4]=0;

	debug_str="InitPCE()";

	if (CartLoad(name)) return -1;

	memset(XBuf,0,WIDTH * HEIGHT);
	memset(Pal,0,512);
	//DMYROM=(BYTE *)malloc(0x2000);
	//memset(DMYROM,NODATA,0x2000);

	WRAM=(BYTE *)malloc(0x2000+0x2000);
	if(WRAM==NULL) return -2;
	memset(WRAM,0,0x4000);
   #if 1
	WRAM[0] = 0x48;		/* 'H' */
	WRAM[1] = 0x55;		/* 'U' */
    WRAM[2] = 0x42;		/* 'B' */
    WRAM[3] = 0x4D;		/* 'M' */
    WRAM[5] = 0xA0;		/* WRAM[4-5] = 0xA000, end of free mem ? */
    WRAM[6] = 0x10;		/* WRAM[6-7] = 0x8010, beginning of free mem ? */
    WRAM[7] = 0x80;
	#endif

	w=get_name(name);
	
	i=0;{int n; while (w[i]!=0) i++; n=i; while (w[i]!='.' && i>0) i--;	if(i<=0) i=n;}
	w[i++]='.';w[i++]='w';w[i++]='r';w[i++]='a';w[i++]=0;
    sprintf(back_name_path,"%ssaves/%s",path_rom,w);
	i=0;while (back_name_path[i]!=0) i++; back_name_ext=i-3; 
	 
	 fp = fopen (back_name_path, "rb"); // cargando memoria backup

    if (fp != NULL)
      {
	  fread (WRAM, 0x2000, 1, fp);
	  fclose (fp);
      }


	VRAM=(BYTE *)malloc(VRAMSIZE);
	if(VRAM==NULL) return -2;
	VRAM2=(unsigned long *)malloc(VRAMSIZE);
	if(VRAM2==NULL) return -2;
	VRAMS=(unsigned long *)malloc(VRAMSIZE);
	if(VRAMS==NULL) return -2;

	memset(VRAM,0,VRAMSIZE);
	memset(VRAM2,0,VRAMSIZE);
	memset(VRAMS,0,VRAMSIZE);

	IOAREA=(BYTE *)malloc(0x2000+0x2000);
	if(IOAREA==NULL) return -2;

	memset(IOAREA,0xFF,0x2000);
	memset(dummy_r,0x0,0x2000);
	//IOAREA=0;
	vchange = (BYTE *)malloc(VRAMSIZE/32);
	memset(vchange,1,VRAMSIZE/32);
	vchanges = (BYTE *)malloc(VRAMSIZE/128);
	memset(vchanges,1,VRAMSIZE/128);
	ROMmask = 1;
	while(ROMmask<ROM_size) ROMmask<<=1;
	ROMmask--;
	for(i=0;i<0xFF;i++) {ROMMapR[i]=dummy_r;ROMMapW[i]=dummy_w;}

	ROMMapR[0xFF] = IOAREA;
	ROMMapW[0xFF] = IOAREA;

	for(i=0;i<0x80;i++)
	{
		if (ROM_size == 0x30)
		{
			switch (i&0x70)
			{
			case 0x00:
			case 0x10:
			case 0x50:
				ROMMapR[i]=ROM+(i&ROMmask)*0x2000;
				break;
			case 0x20:
			case 0x60:
				ROMMapR[i]=ROM+((i-0x20)&ROMmask)*0x2000;
				break;
			case 0x30:
			case 0x70:
				ROMMapR[i]=ROM+((i-0x10)&ROMmask)*0x2000;
				break;
			case 0x40:
				ROMMapR[i]=ROM+((i-0x20)&ROMmask)*0x2000;
				break;
			}
		}
		else
		{
			ROMMapR[i]=ROM+(i&ROMmask)*0x2000;
			//ROMMapW[i]=ROM+(i&ROMmask)*0x2000;
		}
	}
//		ROMMap[i]=ROM+(i%ROM_size+i/ROM_size*0x10)*0x2000;
/*		if (((i&ROMmask)+i/(ROMmask+1)) < ROM_size)
			ROMMap[i]=ROM+((i&ROMmask)+i/(ROMmask+1)*0x20)*0x2000;
		else
			ROMMap[i]=ROM;
*///		ROMMap[i]=ROM+(i&ROMmask)*0x2000;
	if (populus)
	{
		ROMMapR[0x40] = PopRAM + (0)*0x2000;
		ROMMapR[0x41] = PopRAM + (1)*0x2000;
		ROMMapR[0x42] = PopRAM + (2)*0x2000;
		ROMMapR[0x43] = PopRAM + (3)*0x2000;

		ROMMapW[0x40] = PopRAM + (0)*0x2000;
		ROMMapW[0x41] = PopRAM + (1)*0x2000;
		ROMMapW[0x42] = PopRAM + (2)*0x2000;
		ROMMapW[0x43] = PopRAM + (3)*0x2000;
	
	}

	if (CD_emulation)
    {

      ROMMapR[0x80] = cd_extra_mem;
      ROMMapR[0x81] = cd_extra_mem + 0x2000;
      ROMMapR[0x82] = cd_extra_mem + 0x4000;
      ROMMapR[0x83] = cd_extra_mem + 0x6000;
      ROMMapR[0x84] = cd_extra_mem + 0x8000;
      ROMMapR[0x85] = cd_extra_mem + 0xA000;
      ROMMapR[0x86] = cd_extra_mem + 0xC000;
      ROMMapR[0x87] = cd_extra_mem + 0xE000;

	  ROMMapW[0x80] = cd_extra_mem;
      ROMMapW[0x81] = cd_extra_mem + 0x2000;
      ROMMapW[0x82] = cd_extra_mem + 0x4000;
      ROMMapW[0x83] = cd_extra_mem + 0x6000;
      ROMMapW[0x84] = cd_extra_mem + 0x8000;
      ROMMapW[0x85] = cd_extra_mem + 0xA000;
      ROMMapW[0x86] = cd_extra_mem + 0xC000;
      ROMMapW[0x87] = cd_extra_mem + 0xE000;

      

      for (i = 0x68; i < 0x80; i++)
				{
					ROMMapR[i] = cd_extra_super_mem + 0x2000 * (i - 0x68);
					ROMMapW[i] = cd_extra_super_mem + 0x2000 * (i - 0x68);
					
				}

    }
/*	ROMMap[0x80] = PopRAM + (0)*0x2000;
	ROMMap[0x81] = PopRAM + (1)*0x2000;
	ROMMap[0x82] = PopRAM + (2)*0x2000;
	ROMMap[0x83] = PopRAM + (3)*0x2000;
	ROMMap[0x84] = PopRAM + (4)*0x2000;
	ROMMap[0x85] = PopRAM + (5)*0x2000;
	ROMMap[0x86] = PopRAM + (6)*0x2000;
	ROMMap[0x87] = PopRAM + (7)*0x2000;
*/	


IOAREA2=IOAREA;


	ROMMapR[0xF7] = WRAM;
	ROMMapW[0xF7] = WRAM;

	ROMMapR[0xF8] = RAM;
	ROMMapW[0xF8] = RAM;

	ROMMapR[0xF9]=RAM+0x2000;
	ROMMapR[0xFA]=RAM+0x4000;
	ROMMapR[0xFB]=RAM+0x6000;

	ROMMapW[0xF9]=RAM+0x2000;
	ROMMapW[0xFA]=RAM+0x4000;
	ROMMapW[0xFB]=RAM+0x6000;

	
	

// mira si puede detectar la ROM encriptada buscando cadenas clave

if(!rom_need_decrypt) test_decrypt_rom();
if(is_street_fighter)
	{
	_Rd6502=RdDefault;
    _Wr6502=WrSf2;
	}
else
	{
	_Rd6502=RdDefault;
    _Wr6502=WrDefault;
	}
  if (/*(ROM[0x1FFF] < 0xE0) || */rom_need_decrypt) decrypt_rom();
    
	/*FILE *fp;
	fp = fopen(backmemname, "rb");
	if (fp == NULL)
		LogDump("Can't open %s\n", backmemname);
	else
	{
		fread(WRAM, 0x2000, 1, fp);
		fclose(fp);
	}
*/

debug_str="Undef()";	
	return 0;
}

int save_wram=0;

void SaveWRAM()
{
FILE *fp;
int n;
debug_str="SaveWRAM";
if(watch_dog!=0 || save_wram==0 || !WRAM)  goto ret;

for(n=8;n<0x2000;n++)
	{
	if(WRAM[n]!=0) break;
	}
if(n==0x2000) goto ret; // test if WRAM is not modified and return 

if(back_name_path[0]!=0) 
	{
	back_name_path[back_name_ext]='w';back_name_path[back_name_ext+1]='r';back_name_path[back_name_ext+2]='a';back_name_path[back_name_ext+3]=0;
	
	fp = fopen (back_name_path, "wb"); // cargando memoria backup

    if (fp != NULL)
      {
	  fwrite(WRAM, 0x2000, 1, fp);
	  fclose (fp);
	  //sync();
      }
	}
ret:
	debug_str="Undef";
}
int RunPCE(int mode)
{
	M6502 M;
	M2=&M;
	M=dummy;

force_update_sprite=0;

debug_str="RunPCE()";

	if(!mode) ResetPCE(&M);
	if(is_a_sav)
	{
	is_a_sav=0;
    if(!load_game(2)) return 1; // error cargando save game

debug_str="RunPCE()";

	if(fp_bzip) fclose(fp_bzip);fp_bzip=0;
	}
	save_wram=1;
	debug_str="RunPCE() Startsound";
	StartSound();
	debug_str="RunPCE() Run6502";
	Run6502(&M);
	dummy=M;never_run_one_rom=0;
	SaveWRAM();
	save_wram=0;
	debug_str="Undef";
	return 1;
}

void TrashPCE()
{
	
	
debug_str="TrashPCE() close_wav";	
	close_wav();

debug_str="TrashPCE()";	

	if(iso_FILE) {fclose(iso_FILE);iso_FILE=0;}
	if (IOAREA) free(IOAREA); IOAREA=0;
	if (vchange) free(vchange); vchange=0;
	if (vchanges) free(vchanges); vchanges=0;
//	if (DMYROM) free(DMYROM);
	if (WRAM) free(WRAM);  WRAM=0;
	if (VRAM) free(VRAM);  VRAM=0;
	if (VRAM2) free(VRAM2); VRAM2=0;
	if (VRAMS) free(VRAMS); VRAMS=0;
	if (ROM) free(ROM);  ROM=0;
debug_str="Undef";
}

int JoyStick(int n)
{
	return Joysticks(n);
}


int in_game=0;
void Loading_Encrypt_SCR();
extern int gp2x_speed;

int Main_Emulator(unsigned char * path_game, int fps)
{
unsigned M;
	/*BaseClock = 5000000;//7160000; //3.58-21.48;
	IPeriod = BaseClock/(scanlines_per_frame*43);
	*/

debug_str="Main_Emulator()";

	BaseClock = 7160000;
	//BaseClock = 7800000;
	
	IPeriod = BaseClock/(scanlines_per_frame*fps); // 50 FPS



	
	
	UPeriod = 0;
	TimerPeriod = (((BaseClock/1000)*3*1024))/21480;
	
	vmode = 0;
	
	
	// crea la tabla de conversion
	for(M=0;M<256;M++)
		{
		pre_tabl1[M]=SWAP32((((M&0x88)>>3)|((M&0x44)<<6)|((M&0x22)<<15)|((M&0x11)<<24)));
		pre_tabl2[M]=SWAP32((((M&0x88)>>3)|((M&0x44)<<6)|((M&0x22)<<15)|((M&0x11)<<24))<<1);
		pre_tabl3[M]=SWAP32((((M&0x88)>>3)|((M&0x44)<<6)|((M&0x22)<<15)|((M&0x11)<<24))<<2);
		pre_tabl4[M]=SWAP32((((M&0x88)>>3)|((M&0x44)<<6)|((M&0x22)<<15)|((M&0x11)<<24))<<3);
	
		}

if(in_game && path_game!=NULL)
	{
	TrashPCE();TrashMachine();in_game=0;back_name_path[0]=0;
	}

	if(!in_game) 
	{
	if(path_game==NULL) {TrashMachine();return 0;} // si la cadena est vacia, retorna (esto se usa para liberar memoria)
	if(path_game[0]==0)  return 0;
	if (!InitMachine()) return -1;
	rom_need_decrypt=0;cart_reload=1;watch_dog=1;
    if (InitPCE((void *) path_game)) {debug_str="Undef";return 0;}
	
	}

debug_str="Main_Emulator()";

		while (1)
		{
//			SetInfoString("Emulation started");
			RunPCE(in_game);
			StopSound();
			in_game=1;
			
			if (!cart_reload)
				break;
			cart_reload = 0;
			if(watch_dog) {back_name_path[0]=0;TrashPCE();in_game=0;watch_dog=1;Loading_Encrypt_SCR();} else break;

			if(InitPCE((void *) path_game)) break;
		}
	
	debug_str="Undef";
	return 0;
}


