

#include "pce.h"
#include "m6502.h"

extern int		ds_nBits;
extern int		ds_nChannels;
extern int		ds_nSampleRate;
extern int		ds_nLockLatency;
extern unsigned	ds_dwLockSize;
extern unsigned	ds_dwBufferSize;
extern int		bActiveApp;
//extern int		ds_CoopMode;


int InitDSound();
int StartSound(void);
int ReleaseDSound(void);
int ReleaseSoundBuffer(void);
int StopSound(void);

extern IO	io;
extern M6502	*M2;

extern int FPS;

static int bInitialized = 0;
static void WriteBuffer( short *buf, int ch, unsigned dwSize);

static inline int max(int a,int b)
{
if(b>a) return b;
return a;
}



#define SOUND_BUF_MS	200
unsigned	dwOldPos[6];

short	sbuf[6][44100*SOUND_BUF_MS/1000*sizeof(unsigned short)*2];
short	obuf[44100*SOUND_BUF_MS/1000*sizeof(unsigned short)*2];

#define SBUF_SIZE_BYTE 1024*16
//44100*SOUND_BUF_MS/1000
short adpcmbuf [SBUF_SIZE_BYTE];

unsigned	CycleOld;
extern int	BaseClock;

int mseq(UInt32 *rand_val)
{
  if (*rand_val & 0x00080000)
  {
    *rand_val = ((*rand_val ^ 0x0004) << 1) + 1;
    return 1;
  }
  else
  {
    *rand_val <<= 1;
    return 0;
  }
}


/*
 *
 * Lookup tables for IMA ADPCM format
 *
 */ 
int AdpcmIndexAdjustTable[8] =
{
  -1, -1, -1, -1,		/* +0 - +3, decrease the step size */
  2, 4, 6, 8			/* +4 - +7, increase the step size */
};

#define ADPCM_MAX_INDEX 48

int AdpcmStepSizeTable[ADPCM_MAX_INDEX + 1] =
{
  16, 17, 19, 21, 23, 25, 28,
  31, 34, 37, 41, 45, 50, 55,
  60, 66, 73, 80, 88, 97, 107,
  118, 130, 143, 157, 173, 190,
  209, 230, 253, 279, 307, 337,
  371, 408, 449, 494, 544, 598,
  658, 724, 796, 876, 963, 1060,
  1166, 1282, 1411, 1552
};



int InitSound(int Mode)
    /* Returns 1 on success, 0 otherwise. Mode=0 to skip     */
    /* initialization (will be silent), Mode=1 to use Adlib, */
    /* Mode=2..7 to use SoundBlaster wave synthesis.         */
{
	

	if (Mode == 0)
		return 1;

	int	bRet;

	memset(dwOldPos,0,4*6);
	memset(&sbuf[0][0],0, 44100*SOUND_BUF_MS/1000*sizeof(unsigned short)*2*6);
	bRet = InitDSound();

	if (bRet)
	{
		bInitialized = 1;
	}

	return bRet;
}

void TrashSound(void)                   /* Shut down sound  */
{
	

	if (!bInitialized)
		return;
	bInitialized = 0;

	StopSound();
	ReleaseDSound();
}
void write_psg(int ch)
{
	unsigned	Cycle;
	unsigned	dwNewPos;

	if (!bInitialized)
		return;
   //if(ch==2 || ch==3) return; // solo 4 canales
	if ((int)((unsigned)M2->User - CycleOld) < 0)
		CycleOld = (unsigned)M2->User;
	Cycle = (unsigned)M2->User - CycleOld;
	dwNewPos = (unsigned)ds_nSampleRate/25*(Cycle/2)/(BaseClock/45);
	if (dwNewPos > (unsigned)ds_nSampleRate*SOUND_BUF_MS/1000)
	{
//		TRACE("sound buffer overrun\n");
		dwNewPos = ds_nSampleRate*SOUND_BUF_MS*3/4/1000;
	}

	if (dwNewPos > dwOldPos[ch])
	{
	
		WriteBuffer(&sbuf[ch][dwOldPos[ch]*ds_nChannels], ch, (dwNewPos-dwOldPos[ch])*ds_nChannels);
		dwOldPos[ch] = dwNewPos;
	}
}



void inline snd_mix(register short *d,register short *s,int samples)
{
int n;
register short v;
for(n=0;n<samples;n++)
	{
	v=*d + (*s++);
    if(v<-128) v=-128; 
	if(v>127) v=127;
	*d++=v;
	}
}

void inline snd_copy(short *d,short *s,int samples)
{
int n;
register short v,v2;
for(n=0;n<samples;n+=2)
	{
	v=*s++;v2=*s++;
	//if(v<-128) v=-128; if(v>127) v=127; // limita el audio a 8 bits con signo
	//if(v2<-128) v2=-128; if(v2>127) v2=127;
	v<<=8;v2<<=8;
	
	*d++=v;*d++=v2;
	//*d++=v;*d++=v2; // convierte de 22Khz a 44Khz
	}
}
void WriteSoundData(short *buf, int ch, unsigned dwSize)
{
	unsigned	dwNewPos;

//	if(ch==2 || ch==3) return; // solo 4 canales


	dwNewPos = dwSize/ds_nChannels;
	if (dwOldPos[ch] < dwNewPos)
		WriteBuffer(&sbuf[ch][dwOldPos[ch]*ds_nChannels], ch, (dwNewPos-dwOldPos[ch])*ds_nChannels);
    
	if(/*!(io.PSG[ch][4] & 0x80) || */(io.PSG[ch][2]==0 && io.PSG[ch][3]==0))
     memset((void *) &sbuf[ch][0],0 ,44100*SOUND_BUF_MS/1000*sizeof(unsigned short)*2);
	CycleOld = (unsigned)M2->User;
	
	if(ch==0) memset(obuf, 0, dwSize*sizeof(unsigned short));
	//if(ch==0) {if(io.psg_volume==0 || io.PSG[ch][5]==0) memset(obuf, 0, dwSize*sizeof(unsigned short)); else memcpy(obuf, sbuf[ch], dwSize*sizeof(unsigned short));}
	/*else */
	if(io.psg_volume!=0 && io.PSG[ch][5]!=0) snd_mix(obuf, sbuf[ch], dwSize);
	if(ch==5) snd_copy(buf, obuf, dwSize);
	if (dwOldPos[ch] >= dwNewPos)
	{
	if(io.psg_volume!=0 && io.PSG[ch][5]!=0)
		{
		if (dwOldPos[ch] >= (unsigned)ds_nSampleRate*SOUND_BUF_MS/(1000*100/95))
		{
			unsigned	size = ds_nSampleRate*SOUND_BUF_MS/4/1000;
			memcpy(sbuf[ch], sbuf[ch]+dwNewPos*ds_nChannels, size*sizeof(unsigned short)*ds_nChannels);
			dwOldPos[ch] = size;
		}
		else
		{
			memcpy(sbuf[ch], sbuf[ch]+dwNewPos*ds_nChannels, (dwOldPos[ch]-dwNewPos)*sizeof(unsigned short )*ds_nChannels);
			dwOldPos[ch] = dwOldPos[ch]-dwNewPos;
		}
		}
	}
	else
	{dwOldPos[ch] = 0;}
	
}


void WriteBuffer(/*unsigned*/ short *buf, int ch, unsigned dwSize)
{
	int i;
//#ifdef _DEBUG
//	if (ch == 0)
//		debug_dump("%08X-%08X\n", buf-sbuf[ch], buf-sbuf[ch]+dwSize);
//#endif
	static unsigned	n[6] = {0,0,0,0,0,0};
#define	N	32
#define DESPL_S 22
	static unsigned	k[6] = {0,0,0,0,0,0};
    unsigned	t=0;
//	static int		bInit = 1;
	static unsigned	r[6]={0,0,0,0,0,0};
	static unsigned	rand_val[6] = {0,0,0,0,0x51F631E4,0x51F631E4};
	static /*unsigned*/ short	wave[32];
	int polarity[2],polarity2[2];
	/* a*2^(b*x) */
	/* a = 400, b = log2(16384/a), x = 0.0 ~ 1.0 */
	static int		vol_tbl[32] =
	{
		100,451,508,573,646,728,821,925,
		1043,1175,1325,1493,1683,1898,2139,2411,
		2718,3064,3454,3893,4388,4947,5576,6285,
		7085,7986,9002,10148,11439,12894,14535,16384,
	};
	unsigned	dwPos;
	int		lvol, rvol;
	unsigned	Tp;

	 
	
if (!(io.PSG[ch][4]&0x80))
	{
		n[ch] = k[ch] = 0;
		for (dwPos = 0; dwPos < dwSize*ds_nChannels; dwPos++)
			*buf++ = 0;
		return;
	}
//	TRACE("buf=%08X,size=%08X\n", buf, dwSize);

	if (io.PSG[ch][4]&0x40)
	{
//		TRACE("wave=%d\n", io.wave[ch][0]);
		wave[0] = ((short)io.wave[ch][0]-16)*702;
		if (ds_nChannels == 2)
		{
			lvol = ((io.psg_volume>>3)&0x1E) + (io.PSG[ch][4]&0x1F) + ((io.PSG[ch][5]>>3)&0x1E);
			lvol = lvol-60;
			if (lvol < 0) lvol = 0;
			lvol = (((int)(short)wave[0])*vol_tbl[lvol])>>DESPL_S;
			rvol = ((io.psg_volume<<1)&0x1E) + (io.PSG[ch][4]&0x1F) + ((io.PSG[ch][5]<<1)&0x1E);
			rvol = rvol-60;
			if (rvol < 0) rvol = 0;
			rvol = (((int)(short)wave[0])*vol_tbl[rvol])>>DESPL_S;
			for (dwPos = 0; dwPos < dwSize; dwPos += 2)
			{
				*buf++ = (int)lvol;
				*buf++ = (int)rvol;
			}
		}
		else
		{
			lvol = max((io.psg_volume>>3)&0x1E, (io.psg_volume<<1)&0x1E) + (io.PSG[ch][4]&0x1F) +
						max((io.PSG[ch][5]>>3)&0x1E, (io.PSG[ch][5]<<1)&0x1E);
			lvol = lvol-60;
			if (lvol < 0) lvol = 0;
			lvol = (((int)(short)wave[0])*vol_tbl[lvol])>>DESPL_S;
			for (dwPos = 0; dwPos < dwSize; dwPos++)
			{
				*buf++ = (int)lvol;
			}
		}
	}
	else
	{
//for (dwPos = 0; dwPos < dwSize; dwPos++)
//	*buf++ = 0;

		if (ch >= 4 && (io.PSG[ch][7]&0x80))
		{
			unsigned Np = (io.PSG[ch][7]&0x1F);
			if (ds_nChannels == 2)
			{
			register int r_value,l_value;
				lvol = ((io.psg_volume>>3)&0x1E) + (io.PSG[ch][4]&0x1F) + ((io.PSG[ch][5]>>3)&0x1E);
				lvol = lvol-60;
				
				if (lvol < 0) lvol = 0;
				lvol = vol_tbl[lvol];

				rvol = ((io.psg_volume<<1)&0x1E) + (io.PSG[ch][4]&0x1F) + ((io.PSG[ch][5]<<1)&0x1E);
				rvol = rvol-60;
			
				if (rvol < 0) rvol = 0;
				rvol = vol_tbl[rvol];
				l_value=(10*702*lvol)>>DESPL_S;
				r_value=(10*702*rvol)>>DESPL_S;
               
			    polarity[0]=l_value;polarity[1]=-l_value;
				polarity2[0]=r_value;polarity2[1]=-r_value;
				for (dwPos = 0; dwPos < dwSize; dwPos += 2)
				{
					k[ch] += 3000+(Np<<9);
					t = k[ch] / (unsigned)ds_nSampleRate;
					if (t >= 1)
					{
						r[ch] = mseq(&rand_val[ch]);
						k[ch] -= ds_nSampleRate*t;
					}
					//*buf++ = (int)((r[ch] ? 10*702 : -10*702)*lvol/16384);
					//*buf++ = (int)((r[ch] ? 10*702 : -10*702)*rvol/16384);
					*buf++ = polarity[r[ch]];//(int)((r[ch] ? l_value : -l_value));
					*buf++ = polarity2[r[ch]];//(int)((r[ch] ? r_value : -r_value));
				}
			
			}
			else
			{register int l_value;
				lvol = max((io.psg_volume>>3)&0x1E, (io.psg_volume<<1)&0x1E) + (io.PSG[ch][4]&0x1F) +
							max((io.PSG[ch][5]>>3)&0x1E, (io.PSG[ch][5]<<1)&0x1E);
				lvol = lvol-60;
				if (lvol < 0) lvol = 0;
				lvol = vol_tbl[lvol];

				l_value=(10*702*lvol)>>DESPL_S;
				polarity[0]=l_value;polarity[1]=-l_value;
				for (dwPos = 0; dwPos < dwSize; dwPos++)
				{
					k[ch] += 3000+(Np<<9);
					t = k[ch] / (unsigned)ds_nSampleRate;
					if (t >= 1)
					{
						r[ch] = mseq(&rand_val[ch]);
						k[ch] -= ds_nSampleRate*t;
					}
					*buf++ = polarity[r[ch]]; //(int)((r[ch] ? l_value : -l_value));
				}
			}
			return;
		}

		for (i = 0; i < 32; i++)
			wave[i] = ((short)io.wave[ch][i]-16)*702;

		Tp = io.PSG[ch][2]+((unsigned)io.PSG[ch][3]<<8);
		

		if (ds_nChannels == 2)
		{
		if (Tp == 0)
		{
			for (dwPos = 0; dwPos < dwSize*2; dwPos++)
				*buf++ = 0;
			return;
		}
			lvol = ((io.psg_volume>>3)&0x1E) + (io.PSG[ch][4]&0x1F) + ((io.PSG[ch][5]>>3)&0x1E);
			lvol = lvol-60;
			if (lvol < 0) lvol = 0;
			lvol = vol_tbl[lvol];
			rvol = ((io.psg_volume<<1)&0x1E) + (io.PSG[ch][4]&0x1F) + ((io.PSG[ch][5]<<1)&0x1E);
			rvol = rvol-60;
			if (rvol < 0) rvol = 0;
			rvol = vol_tbl[rvol];
			for (dwPos = 0; dwPos < dwSize; dwPos += 2)
			{
				*buf++ = (int)(((int)(short)wave[n[ch]]*lvol)>>DESPL_S);
				*buf++ = (int)(((int)(short)wave[n[ch]]*rvol)>>DESPL_S);
				k[ch] += N*1118608/Tp;
				t = k[ch] / (10*(unsigned)ds_nSampleRate);
				n[ch] = (n[ch]+t)%N;
				k[ch] -= 10*ds_nSampleRate*t;
			}
		}
		else
		{
		if (Tp == 0)
		{
			for (dwPos = 0; dwPos < dwSize; dwPos++)
				*buf++ = 0;
			return;
		}
			lvol = max((io.psg_volume>>3)&0x1E, (io.psg_volume<<1)&0x1E) + (io.PSG[ch][4]&0x1F) +
						max((io.PSG[ch][5]>>3)&0x1E, (io.PSG[ch][5]<<1)&0x1E);
			lvol = lvol-60;
			if (lvol < 0) lvol = 0;
			lvol = vol_tbl[lvol];
			for (dwPos = 0; dwPos < dwSize; dwPos++)
			{
				*buf++ = ((int)((int)(short)wave[n[ch]]*lvol)>>DESPL_S);
				k[ch] += N*1118608/Tp;
				t = k[ch] / (10*(unsigned)ds_nSampleRate);
				n[ch] = (n[ch]+t)%N;
				k[ch] -= 10*ds_nSampleRate*t;
			}
		}
	}
}

UInt32 AdpcmFilledBuf = 0;
UChar new_adpcm_play = 0;

extern unsigned adpcm_pptr_rep,adpcm_psize_rep,adpcm_rate_rep,adpcm_rep;

extern unsigned trap;
/* TODO : improve pointer in adpcm buffer maybe using fixed type */
UInt32 WriteBufferAdpcm16 (short *buf, UInt32 begin, UInt32 size, SChar *Index, SInt32 *PreviousValue)
{
  UInt32 ret_val = 0;

#if 1
  /* TODO: use something else than ALLEGRO's fixed to make this portable */

  SInt32 step, difference, deltaCode;
  SChar index = *Index;
  SInt32 previousValue = *PreviousValue;
 static int FixedIndex = 0, FixedInc;


  if (io.adpcm_rate)
    FixedInc = ( io.adpcm_rate * 1000)/* / (float) ds_nSampleRate*/;
  else
    return 0;
 //trap=size;
  while (size)
    {
  
      FixedIndex += FixedInc;
     
      while (FixedIndex >= ds_nSampleRate)
	{

	  FixedIndex -= ds_nSampleRate;

	  ret_val++;

	  deltaCode = PCM[begin >> 1];
     // trap=begin;
	  if (begin & 1)
	    deltaCode >>= 4;
	  //else
	    deltaCode &= 0xF;

	  step = AdpcmStepSizeTable[index];

	  begin++;
     // if(begin>0x1FFFF) break;
	  begin &= 0x1FFFF;
	  // Make the adpcm repeat from beginning once finished

	  /* Construct the difference by scaling the current step size */
	  /* This is approximately: difference = (deltaCode+.5)*step/4 */
	  difference = step >> 3;
	  if (deltaCode & 1)
	    difference += step >> 2;
	  if (deltaCode & 2)
	    difference += step >> 1;
	  if (deltaCode & 4)
	    difference += step;

	  if (deltaCode & 8)
	    difference = -difference;

	  /* Build the new sample */
	  previousValue += difference;

	

	 /*if (previousValue > 32767)
	    previousValue = 32767;
	  else if (previousValue < -32768)
	    previousValue = -32768;
*/
      if (previousValue > 2047)
	    previousValue = 2047;
	  else if (previousValue < -2048)
	    previousValue = -2048;

	  index += AdpcmIndexAdjustTable[deltaCode & 7];
	  if (index < 0)
	    index = 0;
	  else if (index > ADPCM_MAX_INDEX)
	    index = ADPCM_MAX_INDEX;
     
	}
      /* TEST, was 5 */
	  if(ret_val>=io.adpcm_psize) 
		{
		if(!adpcm_rep)  break; // rompe si supera los nibbles
		begin=io.adpcm_pptr=adpcm_pptr_rep;
		io.adpcm_psize=adpcm_psize_rep;
		io.adpcm_rate=adpcm_rate_rep;
	    }
      *(buf++) =  (int)((previousValue) <<4); 

      size--;

    }
 // rellena con 0 el resto del buffer
  while (size)
    {
	*(buf++) =  0;
      size--;
	}
  *Index = index;
  *PreviousValue = previousValue;

#endif
  return ret_val;
}


void write_adpcm(int nsamples)
{
#if 1
//  UInt32 Cycle;
  UInt32 AdpcmUsedNibbles;

  static SChar index;
  static SInt32 previousValue=0;
//unsigned	dwNewPos;

if (!new_adpcm_play || !io.adpcm_psize) return;
/*
if ((int)((unsigned)M2->User - CycleOld) < 0)
	CycleOld = (unsigned)M2->User;

	Cycle = (unsigned)M2->User - CycleOld;

      dwNewPos =(unsigned) (((unsigned long long) ds_nSampleRate)*((unsigned long long)Cycle)/((unsigned long long)BaseClock));
dwNewPos = (unsigned)ds_nSampleRate/25*(Cycle/2)/(BaseClock/45);
	if (dwNewPos > (unsigned)ds_nSampleRate*SOUND_BUF_MS/1000)
	{
//		TRACE("sound buffer overrun\n");
		dwNewPos = ds_nSampleRate*SOUND_BUF_MS*3/4/1000;
	}
      

  AdpcmFilledBuf = dwNewPos;
*/
  if (new_adpcm_play==2)
    {
	  new_adpcm_play=1;
      index = 0;
      previousValue = 0;
    }
nsamples/=2;
memset(adpcmbuf,0,nsamples<<1);
AdpcmFilledBuf=nsamples;
/* if (AdpcmFilledBuf > io.adpcm_psize)*/
 //   AdpcmFilledBuf = io.adpcm_psize;//-index;

  AdpcmUsedNibbles =
    WriteBufferAdpcm16 (adpcmbuf,
		       io.adpcm_pptr, AdpcmFilledBuf, &index, &previousValue);

if(AdpcmUsedNibbles>io.adpcm_psize)  AdpcmUsedNibbles=io.adpcm_psize;
  io.adpcm_pptr += AdpcmUsedNibbles;
  io.adpcm_pptr &= 0x1FFFF;
if (AdpcmUsedNibbles)
   
   io.adpcm_psize -= AdpcmUsedNibbles;
  else
    io.adpcm_psize = 0;

 if( (int) io.adpcm_psize<=0) 
	 {
	 if(!adpcm_rep)
		 {io.adpcm_psize = 0;new_adpcm_play=0;}
	 else
		 {
		 io.adpcm_pptr=adpcm_pptr_rep;
		 io.adpcm_psize=adpcm_psize_rep;
		 io.adpcm_rate=adpcm_rate_rep;
		 new_adpcm_play=2;
		 }
	 }
  /* If we haven't played even a nibbles, it problably mean we won't ever be
   * able to play one, so we stop the adpcm playing
   */

#ifdef SOUND_DEBUG
//  Log ("size = %d\n", io.adpcm_psize);
#endif
#endif
}

void adpcm_mix(short *p,int nsamples)
{
#if 1
int n;
int v;

if(io.adpcm_psize && new_adpcm_play)
for(n=0;n<nsamples;n++)
	{
    v=p[0]+adpcmbuf[n]; if(v<-32768) v=-32768; if(v>32767) v=32767;
	p[0]=v;

	v=p[1]+adpcmbuf[n]; if(v<-32768) v=-32768; if(v>32767) v=32767;
	p[1]=v;
	p+=2;
	}
#endif
}
