/*  GP2Xengine WAV support
    Copyright (C) 2006  Hermes/PS2Reality 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#define OGG_TRACKS 1

#include "wav.h"
#include "pce.h"
#include "unistd.h"
#include "iso.h"

#ifdef OGG_TRACKS
#include <fcntl.h>
#include "../tremor/ivorbiscodec.h"
#include "../tremor/ivorbisfile.h"
#endif
extern unsigned trap;
extern char path_rom[257];
int is_ext(char *a,char *b);
//byte subq_info[10];

unsigned long filesize (FILE * F);

int wave_is_reading=0;
extern unsigned actual_track;

_waveinfo waveinfo;

int PCE_time=0;
int WAV_time=0;
extern int skip_wave_sound;
static int WAV_LENBUF=44100/5;
static FILE *FWAV=0;
static int WAV_START=0; 
unsigned WAV_TPOSITION=0; // posicion de la pista de sonido
unsigned WAV_TPOSITION_IN=0; //posicion de recuperacion de sonido

static int WAV_NSAMPLES=0;
static int WAV_SECT=0; // se usa para simular la lectura por sectores


static short *wave_ring[WAV_NUMBUF+1];
static short wave_buf[WAV_LENBUF_MAX*(WAV_NUMBUF+2)];
static int wave_counter=-1;
static int wave_readed=0;
static int wave_loop=0;
static int wave_end=0;


int CD_track_cmd[8]={0,0,0,0,0,0,0,0};

static short tabpcm8[256];

static void creattabpcm() // genera la tabla PCM 8 bits
{
int n,m;
int AMP=10; // factor de amplificacion

for(n=0;n<256;n++)
{
m=((65535*n)/255);
m-=32768;
m=(m*AMP)/8;
if(m<-32768) m=-32768;
if(m>32767) m=32767;

tabpcm8[n]=m;
}

}

#ifdef OGG_TRACKS

FILE *fd_ogg=0;
/* OGG control */

#define READ_SAMPLES 48000 // samples that it must read before to send
#define MAX_PCMOUT 4096 // minimum size to read ogg samples

typedef struct
{
OggVorbis_File vf;
vorbis_info *vi;
int current_section;

int pcm_len;
int pcm_indx;

/* OGG buffer control */
short pcmout[READ_SAMPLES+MAX_PCMOUT*2];  /* take 4k out of the data segment, not the stack */


} private_data_ogg;

static private_data_ogg private_ogg;


int read_ogg(char *buff, int len)
{
int ret=0;
int total=0;
char *debug_str2=debug_str;
if(!buff) return 0;
debug_str="read_ogg()";
if(private_ogg.pcm_len>0)
	{
	if(len>0)
		{
		if((private_ogg.pcm_len<<1)>len) 
			{
			memcpy(buff, (void *) &private_ogg.pcmout[private_ogg.pcm_indx],len);
			total+=len;buff+=total;
			private_ogg.pcm_indx+=len>>1;
			private_ogg.pcm_len-=len>>1;
			len=0;
			}
		else 
			{
			memcpy(buff, (void *) &private_ogg.pcmout[private_ogg.pcm_indx],(private_ogg.pcm_len<<1));
			total+=(private_ogg.pcm_len<<1);buff+=total;
			len-=total;
		    private_ogg.pcm_len=0;
			private_ogg.pcm_indx=0;
			}
		}
	}
while(len>0)
	{
	private_ogg.pcm_len=0;
	private_ogg.pcm_indx=0;

	debug_str="ov_read()";
	ret=ov_read(&private_ogg.vf,(void *) &private_ogg.pcmout[0],MAX_PCMOUT,/*0,2,1,*/&private_ogg.current_section);
	if (ret == 0) 
		{
		/* EOF */
		
		break;		
					   //
		} 
	else if (ret < 0) 
		{
		if(ret!=OV_HOLE) 
			{
			break;
			}
		} 
	else 
		{
		if(ret>len) 
			{
			memcpy(buff, (void *) &private_ogg.pcmout[0],len);
			buff+=len;total+=len;private_ogg.pcm_indx=len>>1;ret-=len;private_ogg.pcm_len=ret>>1;
			len=0;
			}
		else {memcpy(buff, (void *) &private_ogg.pcmout[0],ret);buff+=ret;total+=ret;len-=ret;}
		}
	}

debug_str=debug_str2;
return total;
}

int open_ogg(char *name)
{
char * debug_str2=debug_str;

private_ogg.pcm_len=0;
private_ogg.pcm_indx=0;


private_ogg.current_section=0;

debug_str="open ogg file";
fd_ogg=fopen(name,"rb");
if(!fd_ogg) {skip_wave_sound=0;return -1;}

memset(&private_ogg.vf,0,sizeof(private_ogg.vf));
debug_str="ov_open()";
if(ov_open((void *) fd_ogg, &private_ogg.vf, NULL, 0) < 0) 
	{
	fclose(fd_ogg);fd_ogg=0;
	debug_str=debug_str2;
	skip_wave_sound=0;return -1;
	}
debug_str="ov_info()";

private_ogg.vi=ov_info(&private_ogg.vf,-1);

if(!private_ogg.vi) exit(0); // ???

waveinfo.nChannels=private_ogg.vi->channels;

waveinfo.nSamplesPerSecond=private_ogg.vi->rate;

waveinfo.nBitsPerSample=16;
debug_str="ov_pcm_total()";
WAV_NSAMPLES=ov_pcm_total(&private_ogg.vf,-1)*waveinfo.nChannels;// numero de samples totales
debug_str=debug_str2;
WAV_START=0;
WAV_SECT=(waveinfo.nSamplesPerSecond*waveinfo.nChannels/**(waveinfo.nBitsPerSample>>3)*/)/75;


WAV_LENBUF=(waveinfo.nSamplesPerSecond*waveinfo.nChannels)/5;	
	
skip_wave_sound=0;

return 0;
}

#endif


int close_wav()
{
int n;
FILE *FWAV2=FWAV;

//subq_info[0]=2;

#ifdef OGG_TRACKS
//int fd=fd_ogg;
if(!CD_emulation) return 0;
if(!FWAV && !fd_ogg) return 0;
#else
if(!FWAV) return 0;
#endif
//skip_wave_sound=1;
//while(wave_is_reading) usleep(50*1000);
wave_loop=0;
FWAV=0;

/*#ifdef OGG_TRACKS
fd_ogg=-1;

#endif
*/
wave_counter=-1;
for(n=0;n<WAV_NUMBUF;n++)
	{
	wave_ring[n]=&wave_buf[WAV_LENBUF_MAX*n];
	wave_buf[WAV_LENBUF_MAX*n]=0;
	
	}

if(FWAV2) fclose(FWAV2);

#ifdef OGG_TRACKS
if(fd_ogg) {ov_clear(&private_ogg.vf);fd_ogg=0;}
#endif

skip_wave_sound=0;

return 0;
}


int open_wav(char *name)
{

unsigned IDriff,ID1wave,ID2wave,IDdata;
unsigned lriff,lwavef,lwave;
int n;
static int one=1;
if(one) {one=0;creattabpcm();}
PCE_time=0;
WAV_time=0;

for(n=0;n<WAV_NUMBUF;n++)
	{
	wave_ring[n]=&wave_buf[WAV_LENBUF_MAX*n];
	wave_buf[WAV_LENBUF_MAX*n]=0;
	
	}
wave_readed=0;
wave_end=0x7fffffff; // longitud 'infinita'
wave_loop=1;
wave_counter=1;
WAV_TPOSITION=0;
WAV_START=0; 
WAV_NSAMPLES=0;
WAV_SECT=0;

skip_wave_sound=1;
FWAV =0;
#ifdef OGG_TRACKS
if (is_ext ((void *) name, ".ogg") || is_ext ((void *) name, ".OGG"))  return open_ogg(name);
#endif

FWAV = fopen(name, "rb");
if(FWAV==NULL) {skip_wave_sound=0;return -1;}
/* lee cabecera */

fread(&IDriff,1,4,FWAV);

SET_SWAP32(IDriff);

if(IDriff!=0x46464952)
  {
//  printf("No encontrado formato RIFF\n");
  fclose(FWAV);FWAV=0;{skip_wave_sound=0;return -2;}
  }
fread(&lriff,1,4,FWAV);

SET_SWAP32(lriff);

fread(&ID1wave,1,4,FWAV);
fread(&ID2wave,1,4,FWAV);

SET_SWAP32(ID1wave);
SET_SWAP32(ID2wave);

if(ID1wave!=0x45564157 || ID2wave!=0x20746D66)
  {
  //printf("No encontrado formato WAVE\n");
  fclose(FWAV);FWAV=0;{skip_wave_sound=0;return -2;}
  }
fread(&lwavef,1,4,FWAV);

SET_SWAP32(lwavef);

if(lwavef!=16) 
 {
 // printf("Formato WAVE Extendido, no soportado\n");
 fclose(FWAV);FWAV=0;skip_wave_sound=0;return -2;
 }

fread(&waveinfo,1,lwavef,FWAV);

SET_SWAP16(waveinfo.wFormatTag);
SET_SWAP16(waveinfo.nChannels);
SET_SWAP32(waveinfo.nSamplesPerSecond);
SET_SWAP32(waveinfo.nAvgBytesPerSecond);
SET_SWAP16(waveinfo.nBlockAlign);
SET_SWAP16(waveinfo.nBitsPerSample);

if(waveinfo.wFormatTag!=1)
  {
  //printf("No es formato PCM! \n"); 
  fclose(FWAV);FWAV=0;skip_wave_sound=0;return -2;
  }

fread(&IDdata,1,4,FWAV);

SET_SWAP32(IDdata);

if(IDdata!=0x61746164)
  {
  //printf("No encontrada seccion DATA \n");
  fclose(FWAV);FWAV=0;skip_wave_sound=0;return -2;
  }
fread(&lwave,1,4,FWAV);

SET_SWAP32(lwave);

 if(waveinfo.nBitsPerSample!=8 && waveinfo.nBitsPerSample!=16)
  {
  //printf("Numero de BITS por Sample no es 8 o 16 \n");
  fclose(FWAV);FWAV=0;skip_wave_sound=0;return -2;
  }


WAV_NSAMPLES=lwave/waveinfo.nBlockAlign;// numero de samples totales
//fseek(FWAV,0,SEEK_CUR);
WAV_START=ftell(FWAV);
WAV_SECT=(waveinfo.nSamplesPerSecond*waveinfo.nChannels*(waveinfo.nBitsPerSample>>3))/75;
/*skip_wave_sound=2;
wav_loop();
skip_wave_sound=0;*/

WAV_LENBUF=waveinfo.nSamplesPerSecond*waveinfo.nChannels/5;	
	
skip_wave_sound=0;
return 0;
}



void wav_loop()
{
int n,m;
short *buf;
int l;


#ifdef OGG_TRACKS
if(!FWAV && !fd_ogg) return;
#else
if(!FWAV) return;
#endif

for(n=0;n<WAV_NUMBUF;n++)
	{//0
	buf=wave_ring[n];

	if(buf[0]==0)
		{//1
	    
		if(waveinfo.nBitsPerSample==8)
		{//2
		if(!FWAV) return; // aqui no llega ogg
		
		//skip_wave_sound=1;
		wave_is_reading=1;
        
		 m=fread(&buf[1],1,WAV_LENBUF,FWAV);
		 
		 wave_is_reading=0;
		 skip_wave_sound=0;
		 if(m<WAV_LENBUF || (wave_readed+m)>=wave_end)
			{//3
			if(m<0) return;
			if(wave_loop)
			{//4
			wave_is_reading=1;
            WAV_TPOSITION=0;
			fseek(FWAV,WAV_START,SEEK_SET); // loop

			wave_is_reading=0;
			wave_readed=0;
			}//4
		   else h_stop_track ();
			
            memset(((char *)&buf[1])+m,0,WAV_LENBUF-m); // rellena con 0 hasta el final
	        
			
			}//3
			else {wave_readed+=m;}
		
   	
		 buf[0]=1;return;
		 
  

		}//2
		else
		{//2
		//skip_wave_sound=1;
		wave_is_reading=1;
		#ifdef OGG_TRACKS
		if(fd_ogg) {m=read_ogg((void *) &buf[1],WAV_LENBUF*2);}
		else
		#endif
		if(FWAV) m=fread(&buf[1],1,WAV_LENBUF*2,FWAV); 
		else {wave_is_reading=0;/*skip_wave_sound=0;*/return;}

		//skip_wave_sound=0;
		wave_is_reading=0;
		if(m<(WAV_LENBUF<<1) || (wave_readed+m)>=wave_end)
			{
			if(m<0) return;
			
			if(wave_loop)
				{
				wave_is_reading=1;
				WAV_TPOSITION=0;
				#ifdef OGG_TRACKS
				if(fd_ogg) ov_pcm_seek(&private_ogg.vf,WAV_START/2);
				else
				#endif
				fseek(FWAV,WAV_START,SEEK_SET); // loop
				wave_is_reading=0;
				wave_readed=0;
				}
			else h_stop_track ();
				
            memset(((char *)&buf[1])+m,0,(WAV_LENBUF<<1)-m); // rellena con 0 hasta el final
			
			}
			else 
				{
				wave_readed+=m;
			
			    // big endian swap
				#ifdef OGG_TRACKS
				if(fd_ogg) ;
				else
				#endif
				for(l=0;l<(m>>1);l++)
					{
					SET_SWAP16(buf[1+l]);
					}
				}
		
		}
		
		buf[0]=1;return;
		}
	
	}

}



void wav_mix_samples(short *s,int samples)
{
register int v,v2;
//samples>>=1;
register short *buf;
register unsigned char *buf8;
int n,m;

#ifdef OGG_TRACKS
if(!FWAV && !fd_ogg) return;
#else
if(!FWAV) return;
#endif
if(wave_counter<=0) return;
/*if((PCE_time+1000)<WAV_time) // mete un silencio
	{
	return;
	}
PCE_time-=WAV_time;

WAV_time=(samples*1000)/22050;
*/
if(CD_track_cmd[0]!=0)
     WAV_TPOSITION+=samples>>1;

//trap=WAV_TPOSITION;
for(n=0;n<WAV_NUMBUF;n++)
	{
	buf=wave_ring[0];

	if(buf[0]==0)
		{
		for(m=1;m<WAV_NUMBUF;m++)
			{
			wave_ring[m-1]=wave_ring[m];	
			}
		wave_ring[m-1]=buf;

		continue;
		}



if(waveinfo.nBitsPerSample==8)
	{//0
	buf8=(unsigned char *) buf;
	if(waveinfo.nSamplesPerSecond==44100) // 8 bits 44100hz
	 {//1
	 if(waveinfo.nChannels==2) //stereo
	 {//2
		
	 while(wave_counter<WAV_LENBUF && samples>0)
		{//3
	    
		v=*s + tabpcm8[buf8[wave_counter+1]];
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;
		wave_counter++;
		}//3
	 }//2
	 else // mono
	 {//2
	 samples=(samples>>1)<<1;
	 while(wave_counter<WAV_LENBUF && samples>0)
		{//3
	    
	 v2=tabpcm8[buf8[wave_counter+1]];
	 v=*s + v2;
   	if(v<-32768) v=-32768; if(v>32767) v=32767;
	 *s++=v;samples--;
	 v=*s + v2;
   	 if(v<-32768) v=-32768; if(v>32767) v=32767;
	 *s++=v;samples--;
		wave_counter++;
	  }//3

	 }//2
	 }//1
	 if(waveinfo.nSamplesPerSecond==22050) // 8 bits 22050hz
	 {//1
	 samples=(samples>>2)<<2;
     if(waveinfo.nChannels==2) //stereo
	 {//2s
	 while(wave_counter<WAV_LENBUF && samples>0)
		{//3
	    
		v=*s + tabpcm8[buf8[wave_counter+1]];
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;

		v=*s + tabpcm8[buf8[wave_counter+2]];
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;
		
		
		v=*s + tabpcm8[buf8[wave_counter+1]];
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;

		v=*s + tabpcm8[buf8[wave_counter+2]];
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;
		
		//samples-=2;
		//s+=2;


		wave_counter+=2;
		}//3
	 }//2
	 else //mono
	 {//2
	 
	while(wave_counter<WAV_LENBUF && samples>0)
		{//3
	    
	    v2=tabpcm8[buf8[wave_counter+1]];
		v=*s + v2;
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;

		v=*s + v2;
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;
		
		
		v=*s + v2;
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;

		v=*s + v2;
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;

		wave_counter++;
		}//2
	 
	 }//2
	}//1
	}//0
	#if 1
	else //
	{
	if(waveinfo.nBitsPerSample==16)
	 {//1
	 if(waveinfo.nSamplesPerSecond==44100) // 16 bits 44100hz
	  {//2
	  if(waveinfo.nChannels==2) //stereo
	   {//3

	    while(wave_counter<WAV_LENBUF && samples>0)
		{//4
	    
		v=*s + buf[wave_counter];
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;
		wave_counter++;
		} //4
	   } //3
	   else //mono
	   { //3
	   samples=(samples>>1)<<1;
	   while(wave_counter<WAV_LENBUF && samples>0)
		{ //4
	   
	    v2= buf[wave_counter];
		v=*s +v2;
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;
		v=*s +v2;
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;
		wave_counter++;
		}//4
	   }//3

	  }//2
	  else //16 bits 22050
	  {//2
	  if(waveinfo.nSamplesPerSecond==22050) // 16 bits 22050hz
	   {//3
	   samples=(samples>>2)<<2;
	    if(waveinfo.nChannels==2) //stereo
	     {//4
	     while(wave_counter<WAV_LENBUF && samples>0)
		  {//5
	      
		  v=*s + buf[wave_counter];
		
		  if(v<-32768) v=-32768; if(v>32767) v=32767;
		  *s++=v;samples--;

		  v=*s + buf[wave_counter+1];
		
		  if(v<-32768) v=-32768; if(v>32767) v=32767;
		  *s++=v;samples--;
		
		
	      v=*s + buf[wave_counter];
		
		  if(v<-32768) v=-32768; if(v>32767) v=32767;
		  *s++=v;samples--;

		  v=*s + buf[wave_counter+1];
		
		  if(v<-32768) v=-32768; if(v>32767) v=32767;
		  *s++=v;samples--;
		
		//samples-=2;
		//s+=2;
          wave_counter+=2;
		 }//5
	    }//4
	   else //mono
	   {//4
	   
	   while(wave_counter<WAV_LENBUF && samples>0)
		 {//5 
	    
	     v2=buf[wave_counter];
		 v=*s + v2;
		
		 if(v<-32768) v=-32768; if(v>32767) v=32767;
		 *s++=v;samples--;

		 v=*s + v2;
		
		 if(v<-32768) v=-32768; if(v>32767) v=32767;
		 *s++=v;samples--;
		
		
		 v=*s + v2;
		
		 if(v<-32768) v=-32768; if(v>32767) v=32767;
		 *s++=v;samples--;

		 v=*s + v2;
		
		 if(v<-32768) v=-32768; if(v>32767) v=32767;
		 *s++=v;samples--;

		 wave_counter++;
		 }//5
	    }//4
	   }//3
	  }//2

	  }//1
	}//0
	#endif
     



	 if(wave_counter>=WAV_LENBUF)
		{
		for(m=n+1;m<WAV_NUMBUF;m++)
			{
			wave_ring[m-1]=wave_ring[m];
			}
		 wave_ring[m-1]=buf;
		buf[0]=0;wave_counter=1;
		}
	else break;
	}

}



void h_play_track (int track, int repeat)
{
if(track>nb_max_track) return;
CD_track_cmd[0]=1;CD_track_cmd[1]=track;CD_track_cmd[3]=repeat;
close_wav();
if(CD_emulation!=3) return;

if(track>0  && CD_track[track].type != 4 && CD_track[track].type != 5)
	{
	if(CD_track[track].filename[0]!=0) 
		{
	
		open_wav(CD_track[track].filename);
        //
		if(FWAV || fd_ogg) 
		        {
			    wave_loop=(int) repeat;
				#ifdef OGG_TRACKS
				
				if(fd_ogg) ov_pcm_seek(&private_ogg.vf,WAV_START/2+(WAV_TPOSITION_IN));
				else
				#endif
				if(FWAV) fseek(FWAV,WAV_START+WAV_TPOSITION_IN*(waveinfo.nBitsPerSample/8)*waveinfo.nChannels,SEEK_SET);
				WAV_TPOSITION=WAV_TPOSITION_IN;WAV_TPOSITION_IN=0;
			    }
		//
		}
	}
return;


}

void h_play_sectors (int begin_sect, int sect_len, char repeat)
{
int result;
int flag=0;



CD_track_cmd[0]=2;CD_track_cmd[1]=begin_sect;CD_track_cmd[2]=sect_len;CD_track_cmd[3]=repeat;
close_wav();

//trap=sect_len;
//sect_len-=begin_sect;


if(CD_emulation!=3) {return;}
  for (result = nb_max_track; result>1;result--)
    {
      if (((unsigned)begin_sect >= CD_track[result].beg_lsn) &&
	  		((unsigned)begin_sect < CD_track[result].beg_lsn + CD_track[result].length) && CD_track[result].type !=4 && CD_track[result].type !=5)
		{flag=1;break;}
    }
if(flag==0) // busca por aproximacion
	{
	for (result = nb_max_track; result>1;result--)
    {
      if (((unsigned) (begin_sect+sect_len)>CD_track[result].beg_lsn) &&
	  		((unsigned)begin_sect < CD_track[result].beg_lsn + CD_track[result].length) && CD_track[result].type !=4 && CD_track[result].type !=5)
		{flag=2;break;}
    }
	}
if(flag==0) {return;}

if(flag==2) {sect_len-=CD_track[result].beg_lsn-begin_sect;begin_sect=CD_track[result].beg_lsn;}
if(sect_len<0) sect_len=1;

if(CD_track[result].filename[0]==0) {return;}

if (CD_track[result].type !=4 && CD_track[result].type !=5)
	{
	
	begin_sect-=CD_track[result].beg_lsn+CD_track[result].pregap;
	if(begin_sect<0) begin_sect=0;


	  fd_ogg=0;

	  open_wav(CD_track[result].filename);
	  if(FWAV || fd_ogg) 
		       {
		        
		        WAV_START+=(begin_sect)*WAV_SECT;
                //close_wav();
		        wave_end=sect_len*WAV_SECT;
				wave_loop=(int) repeat;
				#ifdef OGG_TRACKS
			
				if(fd_ogg) 
				   {ov_pcm_seek(&private_ogg.vf,WAV_START/2+(WAV_TPOSITION_IN));
				  
				   }
				else
				#endif
				if(FWAV) fseek(FWAV,WAV_START+WAV_TPOSITION_IN*(waveinfo.nBitsPerSample/8)*waveinfo.nChannels,SEEK_SET);
				WAV_TPOSITION=WAV_TPOSITION_IN;WAV_TPOSITION_IN=0;
				wave_readed=0;
				}
	
	}

}

void h_stop_track ()
{
CD_track_cmd[0]=0;
if(CD_emulation) close_wav();
}




int ReadTocList(char *name)
{
unsigned mm=0,ss=0,ff=0;
int pos=0,n;
unsigned lba;
int ret,track,track2=0;
int leadin=0;
FILE *fd,*fd2;

int is_hcd=0;

byte Min, Sec, Fra;
unsigned char str_buf[256];
unsigned char str_buf2[256];
unsigned char type[256];
actual_track=0;
skip_wave_sound=1;

for(n=0;n<100;n++) CD_track[n].pregap=0;
//
if (is_ext (name, ".hcd")) is_hcd=1;
if (is_ext (name, ".HCD")) is_hcd=1;


fd=fopen(name,"r");
skip_wave_sound=0;
if(fd==NULL) {return -1;}

pos=0;while(name[pos]!=0) pos++;
while(name[pos]!='/' && pos>0) pos--;
pos++;

track=1;
lba=150;
skip_wave_sound=1;

while(1)
	{
	if(fgets((void *) str_buf,255,fd)==0) {track=track2;break;}

	if(is_hcd)
		{
		int len,n;

		n=0;while(str_buf[n]!=0) {if(str_buf[n]==',') str_buf[n]=32;n++;}

		ret=sscanf((void *) str_buf, "track%u%s%s%u%u",&track,type,str_buf2,&lba,&len);
		if(ret<5) {track=track2;break;}


        if(track>track2) track2=track;

        if (is_ext ((void *) str_buf2, ".iso") || is_ext ((void *) str_buf2, ".ISO")) {CD_track[track].type = 4;}
		else if (is_ext ((void *) str_buf2, ".bin") || is_ext ((void *) str_buf2, ".BIN")) {CD_track[track].type = 5;}
        else CD_track[track].type = 0;

		CD_track[track].length=len;
		nb_sect2msf (lba, &Min, &Sec, &Fra);
		CD_track[track].beg_min = binbcd[Min];
		CD_track[track].beg_sec = binbcd[Sec];
		CD_track[track].beg_fra = binbcd[Fra];
		CD_track[track].beg_lsn =lba-150;
		
        CD_track[track].filename[0]=0;
		memcpy(CD_track[track].filename,name,pos);
		CD_track[track].filename[pos]=0;
		strcat((void *) CD_track[track].filename, (void *) str_buf2);

		continue;
		} // is_hcd

	if(leadin==0)  // esto se usa para ignorar todos los comentarios hasta que aparezca la palabra Leadin
		{
		ret=sscanf((void *) str_buf,"syscard: %s",str_buf2); //system cdrom
		if(ret==1)
			{
			if(str_buf2[0]=='#')
				{
				sprintf(CD_track[0].filename,"%s%s",path_rom,&str_buf2[1]);
				}
			else 
				{memcpy(CD_track[0].filename,name,pos);CD_track[0].filename[pos]=0;strcat( CD_track[0].filename,(void *) str_buf2);}
			continue;
			}
		if (strcasestr ((void *) str_buf, "Leadin")) leadin=1;
		continue;
		}

		
    ret=sscanf((void *) str_buf,"%s %u:%2u:%2u",(char *) str_buf2,&mm,&ss,&ff);
	if(ret>0)
		{
		
	
			mm&=255;ss&=255;ff&=255;
			
		 
		  CD_track[track].length =  msf2nb_sect (mm ,ss,ff);
		  if (strcasestr ((void *) str_buf2, "Position:")) {lba=CD_track[track].length;continue;}
		  if (strcasestr ((void *) str_buf2, "Pregap:")) {CD_track[track].pregap=CD_track[track].length;/*lba+=CD_track[track].length;*/continue;}
		  if (strcasestr ((void *) str_buf2, ".iso") || strcasestr ((void *) str_buf2, ".ISO")) {CD_track[track].type = 4;}
		  else if (strcasestr ((void *) str_buf2, ".bin") || strcasestr ((void *) str_buf2, ".BIN")) {CD_track[track].type = 5;}
          else CD_track[track].type = 0;
		  


		  nb_sect2msf (lba, &Min, &Sec, &Fra);
		  CD_track[track].beg_min = binbcd[Min];
		  CD_track[track].beg_sec = binbcd[Sec];
		  CD_track[track].beg_fra = binbcd[Fra];
		  CD_track[track].beg_lsn =lba-150;
		
          CD_track[track].filename[0]=0;
		  
		if (strcasestr ((void *) str_buf2, (void *) "Leadout")) break;
		 memcpy(CD_track[track].filename,name,pos);
		 CD_track[track].filename[pos]=0;
		 strcat((void *) CD_track[track].filename, (void *) str_buf2);
 
         if(CD_track[track].type ==0 && ret<4)
			  {
			  if(!open_wav(CD_track[track].filename))
				  {
					skip_wave_sound=1;
				  #ifdef OGG_TRACKS
				  if(fd_ogg) 
					  {
					  CD_track[track].length=((WAV_NSAMPLES<<1)*(44100/waveinfo.nSamplesPerSecond))/2352;
					  }
				  else
				  #endif	
					  {
				      fseek(FWAV,0,SEEK_END);
		
				      CD_track[track].length=((ftell(FWAV)-WAV_START)*(44100/waveinfo.nSamplesPerSecond)*(16/waveinfo.nBitsPerSample)*(2/waveinfo.nChannels))/2352;
					  }
				  if(track==1) if( CD_track[track].length<(47*75+65)) CD_track[track].length=(47*75+65);
				  
				  close_wav();skip_wave_sound=1;
                  
				  }
			  else {skip_wave_sound=1;}
			  }

		 if(CD_track[track].type == 4)
			{
			fd2=fopen(CD_track[track].filename,"rb");
			if(fd2)
				{
				CD_track[track].length = filesize (fd2) / 2048;
			
				fclose(fd2);
				}
			}
		else
		if(CD_track[track].type == 5)
			{
			fd2=fopen(CD_track[track].filename,"rb");
			if(fd2)
				{
				CD_track[track].length = filesize (fd2) / 2352;
			
				fclose(fd2);
				}
			}
			
       if(CD_track[track].type ==0) CD_track[track].length+=CD_track[track].pregap;
        lba+=CD_track[track].length;
		
        track++;
		
		}
	

	}

	
nb_max_track=track-1;


fclose(fd);
skip_wave_sound=0;
return 0;
}
